/*-----------------------------------------------------------------
  PST: Petit Simulateur de Train
-------------------------------------------------------------------
  Historique:

  xx octobre 2007:
      - PST 1.0
      - Ulysse Delmas-Begue
      - Creation et mise a disposition de cette version sur le site web

  22 mars 2008:
      - PST 1.1
      - Ulysse Delmas-Begue
      - Ajout du pilotage automatique
           En  mode automatique, Les 50 premieres locomotives peuvent etre pilotees en automatique
           Pour cela il existe 50 canaux de conduite
           La conduite est decrite dans un fichier script

  15 juin 2008
      - PST 1.2
      - Ulysse Delmas-Begue
      - rajout de la carte 2d de presentation

  28 juillet 2008
      - PST 2.0
      - Ulysse Delmas-Begue
      - Ajoute la possibiliter d'utiliser plusieures lignes (100 MAX)

  19 septembre 2009
      - PST 3.0
      - Ulysse Delmas-Begue
      - Nouveau mode carte
      - modification du mecanisme des images des trains.    L'image commune disparait au profit d'une image par element de train
      - modification du mecanisme des images des batiments. L'image commune disparait au profit d'une image par element de train


-------------------------------------------------------------------
  A faire:

  TBD ulta urgent:
  -   voir probleme de degradation des performances lorsque l'on change de ligne (solution actuelle: redemarrer pst)
  -   recalculer la taille des tableaux pour le projet france
  ok  creer insertion de 1000 pixels pour plus de facilite d'utilisation de conception avec les lignes (parametrable au lieu de 1000 points)
  PT  voir pourquoi besoin d'appuyer 2 fois sur C
  PT  probleme de link (l'inversion ne fonctionne pas). fonctionne en redemarant (surement un PB de degment avec mauvais ptg/ptd gauche/droit)
  ok  demander si sauvegarde a la fermeture
  ok  probleme d'effacement a partir d'un certain moment (selection de txt problematique)
  ok  ameliorer la reduction des lignes
  ok  ajouter source et cible pour copier/coller
  ok  verifier le multi ligne pour txt,geo,bat
  ok  initialisation des trains sur la bonne ligne (necessaire de rajouter num de la ligne a l'init)
  ok  gestion de la camera lors du changement de ligne
  ok  memoriser x0/y0 des lignes pour les changements de ligne
  ok  choix de la ligne a charger ou de la carte au demarrage
  ok  sauver dans fichier suivant ligne
  ok  ajouter les variables
  ok  implementer chargement des images des batiments en fonction de la ligne
  ok  rajouter nom de la ligne et fichier de la ligne
  ok  mettre nom du fichier des sprites dans le fichier de config (attention, Windows recherche ds rep de lancement puis rep courant !)
  ok  ecrasement du fichier infra
  ok  menage des fichiers (y compris le debug)
  ok  utilisation de la variable var_start_ligne
  ok  passer les aiguillages en tableau 2D suivant la ligne
  ok  stabiliser le multi-lignes
  ok  ameliorer les performances d'affichage avec un tableau de pointeur
  ok  script dans un autre fichier
  ok  pour le chargement des scripts, F7 puis selection du script
  ok  reutiliser les capacite de texte de la carte pour le reseau
  ok  revoir le dimensionnement des differents tableaux
  ok  augmenter les performances en rajoutant les 2 segments par point
  ->  ameliorer la gestion du numero des aiguillages (mode pour ne pas demander le numero) / copoier-coller
  ok  changer position du texte si creation de ligne a gauche de la cible
  ->> permettre modification position txt/bat
  ok  rentrer plus facilement infos loco/wagons
  ->> rendre encore plus facile ajout loco/wagons
  -   releaser pst 2.0
  ok  afficher texte(s) proches dans le panneau de control
  ok  ajouter la version du fichier de config
  NO  supporter de tres long segments pour la carte (10km, suffisant)
  PT  voir pour envoyer la selection extremement loin
  ok  lors de deplacements copcol, mettre a jour les x/y lignes (ou que les x) de la carte, afin de ne pas la mettre a jour sans cesse.
  -   afficher liste des lignes (et saut)
  -   afficher liste des locomotives (et saut)
  -   donner nom aux locomotives
  -   affichage du texte d'information en fonction du sens
  ->  voir pour la generation des ponts en pierre (gris/rose/jaune)
  ->  voir pour la generation des rembardes
  ->  rajouter des rembardes pour les ponts
  ->  rajouter des couleurs pour les geo
  ok  prendre curseur comme reference pour creer les lignes wikipedia
  ok  si segment de plus de 2000 alors creer un lien
  ok  probleme de creation de lien (marche ds un sens mais pas dans l'autre)
  ok  verifier et rendre plus debugable le mode auto

  TBD urgent:
  ok  interdiction de rentrer des segments verticaux
  ok  touche pour changer le type du segment
  ok  camera uniquement avec touche c
  ok  text entry
  ok  text del
  ok  init sprite avec INV pr la commande
  ok  file update (avec interrogations)
  ok  suppression F3 / F6
  ok  regler le PB des lignes qui ne s'affichent pas (apparament lorsque x2<x1)
  ok  rajouter le copier/coller selectionner/deplacer
  ok  rajouter gestion des anciennes voies
  ok  reduire selection des seg,txt,geo,bat suivant plage x,y

  TBD:
  ok  affichage des statistiques
  ok  affichage de l'aide
  NO  verifier si segment pas en doublelors du chargement
  ok  end dans le fichier infra
  ok  transparent dans le fichier infra
  ok  x0 et y0 dans le fichier infra
  ok  x_base, y_base, aig_base dans le fichier infra
  ok  camera qui bouge aussi avec les y, mais debrayable
  NO  chiffre de debug qui apparaissent en haut de tout
  ok  forme geometriques (lignes, rectangles(vide ou pleins), rond(vide ou plein))
  ok  commentaire
  ok  liens
  ok  sons
  ok  inversion du dessin de sprite
  ok  inversion du dessin de sprite a partir du fichier
  NO  plaque tournante / trabsbordeur
  ok  pilotage automatique
  ok  afficher step d'execution
  NO  enlever necessite de rentrer section commune des aiguillages

  NO  voir passage en manuel d'une loco en automatique (c'est le sript qui decide)
  ok  mettre toutes les loco (tout les MOT) automatisables
  ok  mettre des boucles dans le mode auto (bouclage global par canal, individuel peu de sens car pas de cpt)
  ok  revoir l'automatisation (surtout au niveau des aiguillages)
  ok  choisir entre aiguilles classiques et tableaux pour les locomotives auto
  ok  voir gestion de l'horodateur
  ok  mettre a jour la doc pour l'automatique
  ok  rajouter le son en automatique
  ok  rajouter l'inversion, accrochage, decrochage en automatique
  ok  mettre sect_on sect_off dans le fichier de script

  -   signalisation

  -   affichage de l'autre cote de la ligne
  -   zoom moins (mais en remplacant les sprites par des rectangles)
  -   camera qui bouge uniquement lorsque tout le train est passe

-----------------------------------------------------------------*/


//-----------------------------------------------------------------
// INCLUSIONS, DEFINITIONS et DIMENTIONNEMENT GENERAL
//-----------------------------------------------------------------

#include <windows.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#define PST_TITLE "PST - \"Petit Simulateur de Train\" - v3.0 - septembre 2009 - Ulysse Delmas"
#define STR_ABOUT "PST - \"Petit Simulateur de Train\" - v3.0 - septembre 2009 - Ulysse Delmas\n http://udelmas.e-monsite.com"

#define CONFIG_VERS 3           //version de sauvegarde du fichier
int config_version=CONFIG_VERS;

#define CARTE_NB_SEG   50000
#define CARTE_NB_PT    10000
#define CARTE_LEN_TXT 200000

#define CARTE2_NB         50
#define CARTE2_NB_PT    5000
#define TXT_MAX       100000
#define TXT_MAX_BAT   100000

#define MAX_LIGNE        100
#define MAX_PT        100000
#define MAX_SEG       100000
#define MAX_LINK        1000
#define MAX_AIG          500
#define MAX_GEO        20000
#define MAX_TXT        10000
#define MAX_BAT        10000

#define MAX_SPRITE     10000
#define MAX_MOT         1000

#define SCRIPT_TAB_SIZE  100000
#define SCRIPT_CH_NB     100
#define SCRIPT_LOCO_NB   100

#define MAX_DISP_SEG   20000
#define MAX_DISP_GEO    5000
#define MAX_DISP_BAT    2000
#define MAX_DISP_TXT    2000

int current_ligne=0;

//-----------------------------------------------------------------
// FONCTIONS DE TEXTE
//-----------------------------------------------------------------

char szBasePstDir[1000]; //directoire de base de PST    (ex: "D:\pst\")
char szBaseResDir[1000]; //directoire de base du reseau (ex: "D:\pst\res\france\")

//buffer pour optimiser le stockage des chaines

// buffer qui contient les noms des fichiers images des trains
char szTxtBuff[TXT_MAX];
int  nextTxtBuff=0;

int txtBuff_Init(void)
{
    nextTxtBuff=0;
}

int txtBuff_Add(char* sz)
{
    int ind,len;

    ind=nextTxtBuff;
    len=strlen(sz);
    if((ind+len+5)>TXT_MAX) return -1;

    strcpy(&szTxtBuff[nextTxtBuff],sz);
    nextTxtBuff+=len+1;

    return ind;
}

int txtBuff_Find(char* sz)
{
    int ind,len;

    ind=0;
    while(ind<nextTxtBuff)
    {
        if(stricmp(sz,&szTxtBuff[ind])==0) return ind;
        ind=ind+strlen(&szTxtBuff[ind])+1;
    }

    return -1;
}

// buffer qui contient les noms des fichiers images des batiments
// different de celui des trains, car remis a 0 a chaque chargement de ligne
char szTxtBuffBat[TXT_MAX_BAT];
int  nextTxtBuffBat=0;

int txtBuffBat_Init(void)
{
    nextTxtBuffBat=0;
}

int txtBuffBat_Add(char* sz)
{
    int ind,len;

    ind=nextTxtBuffBat;
    len=strlen(sz);
    if((ind+len+5)>TXT_MAX_BAT) return -1;

    strcpy(&szTxtBuffBat[nextTxtBuffBat],sz);
    nextTxtBuffBat+=len+1;

    return ind;
}

int txtBuffBat_Find(char* sz)
{
    int ind,len;

    ind=0;
    while(ind<nextTxtBuffBat)
    {
        if(stricmp(sz,&szTxtBuffBat[ind])==0) return ind;
        ind=ind+strlen(&szTxtBuffBat[ind])+1;
    }

    return -1;
}



//-----------------------------------------------------------------
// FONCTIONS DE DESSIN
//-----------------------------------------------------------------

HINSTANCE ghInstance;
HDC hdc;
HDC hdcScreen;
HDC hdcMem;
HDC hdcMemInv;
HDC hdcMemMask;
HDC hdcMemInvMask;
HDC hdcMemBat=NULL;
HDC hdcMemBatMask=NULL;

HDC hdcMemTemp;
HWND ghwnd;
int x_res=1024,y_res=768,panel_base=580;
int panel_on=1;
int zoom_moins=0;
int use_mask=1;
int cpt;
int inc;
int en_cours=0;
char szDisp[1000];
int coord_on=0;
int x_mouse_move,y_mouse_move;

HBRUSH    bmp_pinceau_noir;
HBRUSH    bmp_pinceau_blanc;
HBRUSH    bmp_pinceau_rouge;
HBRUSH    bmp_pinceau_vert;
HBRUSH    bmp_pinceau_bleu;
HBRUSH    bmp_pinceau_gris;
HBRUSH    bmp_pinceau_jaune;

HPEN      bmp_stylo_noir;
HPEN      bmp_stylo_blanc;
HPEN      bmp_stylo_rouge;
HPEN      bmp_stylo_vert;
HPEN      bmp_stylo_bleu;
HPEN      bmp_stylo_gris;
HPEN      bmp_stylo_jaune;

HFONT     bmp_fonte;

char szInfraFileName[1024];
char szInfraFileSecu[1024];
char szSpriteFileName[1024];  //plus utilise (garder pr la compatibilite du fichier infra)

void use_res(char* szEdit)
{
    char* pc1,* pc2,* pc3;

    pc1=strstr(szEdit,"x_res=");
    pc2=strstr(szEdit,"y_res=");
    pc3=strstr(szEdit,"y_panel=");
    if(pc1==NULL || pc2==NULL || pc3==NULL) return;
    x_res=atoi(pc1+strlen("x_res=")); if(x_res>2000) x_res=2000;
    y_res=atoi(pc2+strlen("y_res=")); if(y_res>1200) y_res=1200;
    panel_base=atoi(pc3+strlen("y_panel="));
}

void font_pinceau_stylo_init(void)
{
    //bmp_fonte=CreateFont(15,10,0,0,400,0,0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH|FF_MODERN,"Courier");
    bmp_fonte=CreateFont(12,7,0,0,400,0,0,0,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH|FF_MODERN,"Courier New");

    bmp_pinceau_noir      = CreateSolidBrush(RGB(  0,  0,  0));
    bmp_pinceau_blanc     = CreateSolidBrush(RGB(255,255,255));
    bmp_pinceau_rouge     = CreateSolidBrush(RGB(255,  0,  0));
    bmp_pinceau_vert      = CreateSolidBrush(RGB(  0,255,  0));
    bmp_pinceau_bleu      = CreateSolidBrush(RGB(  0,  0,255));
  //bmp_pinceau_gris      = CreateSolidBrush(RGB( 64, 64, 64));
    bmp_pinceau_gris      = CreateSolidBrush(RGB( 96, 96, 96));
    bmp_pinceau_jaune     = CreateSolidBrush(RGB(  0,255,255));

    bmp_stylo_noir        = CreatePen(PS_SOLID,1,RGB(0  ,0  ,0  ));
    bmp_stylo_blanc       = CreatePen(PS_SOLID,1,RGB(255,255,255));
    bmp_stylo_rouge       = CreatePen(PS_SOLID,1,RGB(255,  0,  0));
    bmp_stylo_vert        = CreatePen(PS_SOLID,1,RGB(  0,255,  0));
    bmp_stylo_bleu        = CreatePen(PS_SOLID,1,RGB(  0,  0,255));
  //bmp_stylo_gris        = CreatePen(PS_SOLID,1,RGB( 64, 64, 64));
    bmp_stylo_gris        = CreatePen(PS_SOLID,1,RGB( 96, 96, 96));
    bmp_stylo_jaune       = CreatePen(PS_SOLID,1,RGB(  0,255,255));
}

#define COLOR_NOIR   0
#define COLOR_BLANC  1
#define COLOR_ROUGE  2
#define COLOR_VERT   3
#define COLOR_BLEU   4
#define COLOR_GRIS   5
#define COLOR_JAUNE  6 //en fait CYAN
#define COLOR_FREE   7
int new_color=2;
int select_stylo_color(int color)
{
    switch(color)
    {
        case COLOR_BLANC: SelectObject(hdcMemTemp,bmp_stylo_blanc); break;
        case COLOR_ROUGE: SelectObject(hdcMemTemp,bmp_stylo_rouge); break;
        case COLOR_VERT : SelectObject(hdcMemTemp,bmp_stylo_vert ); break;
        case COLOR_BLEU : SelectObject(hdcMemTemp,bmp_stylo_bleu ); break;
        case COLOR_GRIS : SelectObject(hdcMemTemp,bmp_stylo_gris ); break;
        case COLOR_JAUNE: SelectObject(hdcMemTemp,bmp_stylo_jaune); break;
        default:          SelectObject(hdcMemTemp,bmp_stylo_noir ); break;
    }
}

int select_pinceau_color(int color)
{
    switch(color)
    {
        case COLOR_BLANC: SelectObject(hdcMemTemp,bmp_pinceau_blanc); break;
        case COLOR_ROUGE: SelectObject(hdcMemTemp,bmp_pinceau_rouge); break;
        case COLOR_VERT : SelectObject(hdcMemTemp,bmp_pinceau_vert ); break;
        case COLOR_BLEU : SelectObject(hdcMemTemp,bmp_pinceau_bleu ); break;
        case COLOR_GRIS : SelectObject(hdcMemTemp,bmp_pinceau_gris ); break;
        case COLOR_JAUNE: SelectObject(hdcMemTemp,bmp_pinceau_jaune); break;
        default:          SelectObject(hdcMemTemp,bmp_pinceau_noir ); break;
    }
}

void EasyTextOut(int x, int y, char* sz)
{
    TextOut(hdc,x,y,sz,strlen(sz));
}

void EasyLine(int x1, int y1, int x2, int y2)
{
    if(x1<=x2) { MoveToEx(hdc,x1,y1,NULL); LineTo(hdc,x2,y2); }  //sinon certains segments ne s'affichent pas
    else       { MoveToEx(hdc,x2,y2,NULL); LineTo(hdc,x1,y1); }
}

void EasyTextOutTemp(int x, int y, char* sz)
{
    TextOut(hdcMemTemp,x,y,sz,strlen(sz));
}

void EasyLineTemp(int x1, int y1, int x2, int y2)
{
    if(x1<=x2) { MoveToEx(hdcMemTemp,x1,y1,NULL); LineTo(hdcMemTemp,x2,y2); }
    else       { MoveToEx(hdcMemTemp,x2,y2,NULL); LineTo(hdcMemTemp,x1,y1); }
}

HBITMAP hbitmapMask;

void sprite_fill_inv(void);

void init_hdc_mem(void)
{
    HBITMAP hbitmap;
    long c,i,j;
    hbitmap=(HBITMAP)CreateCompatibleBitmap(hdc,1280,1024);
    hdcMemTemp=CreateCompatibleDC(hdc);
    SelectObject(hdcMemTemp,hbitmap);
}

#define AFF_MODE_RESEAU          0
//#define AFF_MODE_SPRITES         1
#define AFF_MODE_CONTAINERS_DEPL 3
#define AFF_MODE_CARTE           4
#define AFF_MODE_BAT             5
#define AFF_MODE_INIT            7
#define AFF_MODE_CHANGE_LIGNE    8
int aff_mode=AFF_MODE_INIT;
int aff_step=0;
int stat_pt,stat_line,stat_seg,stat_aig,stat_geo,stat_bat,stat_txt,stat_link,stat_tr;


//
void get_wid_txt(char* sz)
{
    SendMessage(GetDlgItem(ghwnd,800), WM_GETTEXT, 900, (LPARAM) sz);
}

void set_wid_txt(char* sz)
{
    SendMessage(GetDlgItem(ghwnd,800), WM_SETTEXT, 0, (LPARAM) sz);
}

/*****************************************************************************/
/* CLASS IMG (pour l'affichage des images)                                   */
/*****************************************************************************/

/*------------------------------------------------------------------------------
NAME  : cImg

DESCR : class cImg: Permet l'affichage des images.

NOTES :
------------------------------------------------------------------------------*/
class cImg
{
    public:

    HDC tr_hdc;
    HDC tr_hdc_inv;
    HDC tr_hdc_msk;
    HDC tr_hdc_msk_inv;
    HBITMAP tr_hbitmap;
    int tr_loaded;
    int tr_dx,tr_dy;
    int tr_en_trans,tr_en_inv;

         cImg(void);                // constructeur
    void load(char* filename, int dx, int dy, int en_trans, int en_inv);
    void load(char* filename, int en_trans, int en_inv);
    void unload(void);
    void draw(int x, int y, int do_inv);
    void draw_centerlow(int x, int y, int do_inv);
    void drawsub(int x, int y, int do_inv, int x0, int y0, int x1, int y1);
    void drawsub_centerlow(int x, int y, int do_inv, int x0, int y0, int x1, int y1);
    void draw_rect(int x, int y, int fill);
    void draw_rect_centerlow(int x, int y, int fill);
};

/*------------------------------------------------------------------------------
NAME  : cImg::cImg
DESCR : constructeur de la classe cImg
        (indique qu'aucune image n'est chargee)
ARG   : void
RETURN: void
NOTES : none
------------------------------------------------------------------------------*/
cImg::cImg(void)
{
    tr_loaded=0;
    tr_en_trans=0;
    tr_en_inv=0;
}

/*------------------------------------------------------------------------------
NAME  : load
DESCR : charge une image BMP
ARG   : filename: fichier
        dx/dy: taille de l'image
        en_trans: activation de la transparence
        en_inv: activation de l'inversion
RETURN: void
NOTES : none
------------------------------------------------------------------------------*/
void cImg::load(char* filename, int dx, int dy, int en_trans, int en_inv)
{
    int x,y;
    long c;

    //if(tr_loaded!=0) return;
    if(tr_loaded!=0) unload();

    tr_dx=dx; tr_dy=dy;
    tr_en_trans=en_trans; tr_en_inv=en_inv;

    tr_hbitmap=(HBITMAP)LoadImage(ghInstance,filename,IMAGE_BITMAP,tr_dx,tr_dy,LR_LOADFROMFILE);
    tr_hdc=CreateCompatibleDC(hdc);
    SelectObject(tr_hdc,tr_hbitmap);
    DeleteObject(tr_hbitmap);

    if(tr_en_inv)
    {
    tr_hbitmap=(HBITMAP)LoadImage(ghInstance,filename,IMAGE_BITMAP,tr_dx,tr_dy,LR_LOADFROMFILE);
    tr_hdc_inv=CreateCompatibleDC(hdc);
    SelectObject(tr_hdc_inv,tr_hbitmap);
    DeleteObject(tr_hbitmap);
    }

    if(tr_en_trans)
    {
    tr_hbitmap=(HBITMAP)LoadImage(ghInstance,filename,IMAGE_BITMAP,tr_dx,tr_dy,LR_LOADFROMFILE);
    tr_hdc_msk=CreateCompatibleDC(hdc);
    SelectObject(tr_hdc_msk,tr_hbitmap);
    DeleteObject(tr_hbitmap);
    }

    if(tr_en_inv && tr_en_trans)
    {
    tr_hbitmap=(HBITMAP)LoadImage(ghInstance,filename,IMAGE_BITMAP,tr_dx,tr_dy,LR_LOADFROMFILE);
    tr_hdc_msk_inv=CreateCompatibleDC(hdc);
    SelectObject(tr_hdc_msk_inv,tr_hbitmap);
    DeleteObject(tr_hbitmap);
    }

    if(tr_en_inv ||tr_en_trans)
    for(y=0;y<tr_dy;y++) for(x=0;x<tr_dx;x++)
    {
        c=GetPixel(tr_hdc,x,y);
        if(tr_en_inv) { SetPixel(tr_hdc_inv,tr_dx-1-x,y,c); }
        if(tr_en_trans)
        {
            if(c==RGB(255,255,255))
            {
                SetPixel(tr_hdc,x,y,0); // remplace les blancs (=transparent) par noir pour le OU
                if(tr_en_inv) SetPixel(tr_hdc_inv,tr_dx-1-x,y,0);
                SetPixel(tr_hdc_msk,x,y,RGB(255,255,255)); // cree les masques pour le ET
                if(tr_en_inv) SetPixel(tr_hdc_msk_inv,tr_dx-1-x,y,RGB(255,255,255));
            }
            else
            {
                SetPixel(tr_hdc_msk,x,y,0); // cree les masques pour le ET
                if(tr_en_inv) SetPixel(tr_hdc_msk_inv,tr_dx-1-x,y,0);
            }
        }
    }

    tr_loaded=1;
}

/*------------------------------------------------------------------------------
NAME  : load
DESCR : charge une image BMP
ARG   : filename: fichier
        en_trans: activation de la transparence
        en_inv: activation de l'inversion
RETURN: void
NOTES : none
------------------------------------------------------------------------------*/
void cImg::load(char* filename, int en_trans, int en_inv)
{
    char* pc; char ca;
    int pos,xi=0,yi=0,ok;
    char sz[1000];

    pc=filename;
    pos=0; ok=0;
    while(ca=*pc++)
    {
        if(ca=='_') { pos=1; xi=yi=0; continue; }
        if(pos==1) { if(ca>='0' && ca<='9') xi=10*xi+ca-'0';
                     else if(ca=='x' || ca=='X') { pos=2; continue; }
                     else pos=0; }
        if(pos==2) { if(ca>='0' && ca<='9') { yi=10*yi+ca-'0'; ok=1; } else pos=0; }
    }
    if(ok==0) return;

    load(filename,xi,yi,en_trans,en_inv);
}

/*------------------------------------------------------------------------------
NAME  : unload
DESCR : decharge l'image (et donc libere les ressources)
ARG   : void
RETURN: void
NOTES : none
------------------------------------------------------------------------------*/
void cImg::unload(void)
{
    if(tr_loaded!=1) return;

    DeleteDC(tr_hdc);
    //DeleteObject(tr_hbitmap);

    tr_loaded=0;
}

/*------------------------------------------------------------------------------
NAME  : draw
DESCR : dessine l'image
ARG   : x,y: coordonees (du coin gauche haut)
RETURN: void
NOTES : none
------------------------------------------------------------------------------*/
void cImg::draw(int x, int y, int do_inv)
{
    if(tr_loaded==0) return;

    if(tr_en_trans==0)
    {
        if(do_inv==0 || tr_en_inv==0) BitBlt(hdcMemTemp,x,y,tr_dx,tr_dy,tr_hdc,0,0,SRCCOPY);
        else                          BitBlt(hdcMemTemp,x,y,tr_dx,tr_dy,tr_hdc_inv,0,0,SRCCOPY);
    }
    else
    {
        if(do_inv==0 || tr_en_inv==0)
        {
             BitBlt(hdcMemTemp,x,y,tr_dx,tr_dy,tr_hdc_msk,0,0,SRCAND);    //met en noir la destination qui va etre remplacee
             BitBlt(hdcMemTemp,x,y,tr_dx,tr_dy,tr_hdc,0,0,SRCPAINT);      //met en detination le sprite (OR) le fond noir du sprite ne modifie pas le fond, l'etapeprecedente ne modifie pas le sprite
        }
        else
        {
             BitBlt(hdcMemTemp,x,y,tr_dx,tr_dy,tr_hdc_msk_inv,0,0,SRCAND); //met en noir la destination qui va etre remplacee
             BitBlt(hdcMemTemp,x,y,tr_dx,tr_dy,tr_hdc_inv,0,0,SRCPAINT);   //met en detination le sprite (OR) le fond noir du sprite ne modifie pas le fond, l'etapeprecedente ne modifie pas le sprite
        }
    }
}

/*------------------------------------------------------------------------------
NAME  : draw
DESCR : dessine l'image
ARG   : x,y: coordonees (du centre bas)
RETURN: void
NOTES : none
------------------------------------------------------------------------------*/
void cImg::draw_centerlow(int x, int y, int do_inv)
{
    draw(x-(tr_dx/2),y-tr_dy,do_inv);
}

/*------------------------------------------------------------------------------
NAME  : drawsub
DESCR : dessine une partie de l'image
ARG   : x,y: coordonees (du coin gauche haut)
RETURN: void
NOTES : none
------------------------------------------------------------------------------*/
void cImg::drawsub(int x, int y, int do_inv, int x0, int y0, int x1, int y1)
{
    if(tr_loaded==0) return;

    int xg,xd,yh,yb;
    xg=x0; xd=x1; if(xg>xd) {xg=x1; xd=x0; }
    yh=y0; yb=y1; if(yh>yb) {yh=y1; yb=y0; }

    if(tr_en_trans==0)
    {
        if(do_inv==0 || tr_en_inv==0) BitBlt(hdcMemTemp,x,y,xd-xg+1,yb-yh+1,tr_hdc,xg,yh,SRCCOPY);
        else                          BitBlt(hdcMemTemp,x,y,xd-xg+1,yb-yh+1,tr_hdc_inv,tr_dx-1-xg,yh,SRCCOPY);
    }
    else
    {
        if(do_inv==0 || tr_en_inv==0)
        {
             BitBlt(hdcMemTemp,x,y,xd-xg+1,yb-yh+1,tr_hdc_msk,xg,yh,SRCAND);    //met en noir la destination qui va etre remplacee
             BitBlt(hdcMemTemp,x,y,xd-xg+1,yb-yh+1,tr_hdc,xg,yh,SRCPAINT);      //met en detination le sprite (OR) le fond noir du sprite ne modifie pas le fond, l'etapeprecedente ne modifie pas le sprite
        }
        else
        {
             BitBlt(hdcMemTemp,x,y,xd-xg+1,yb-yh+1,tr_hdc_msk_inv,tr_dx-1-xg,yh,SRCAND); //met en noir la destination qui va etre remplacee
             BitBlt(hdcMemTemp,x,y,xd-xg+1,yb-yh+1,tr_hdc_inv,tr_dx-1-xg,yh,SRCPAINT);   //met en detination le sprite (OR) le fond noir du sprite ne modifie pas le fond, l'etapeprecedente ne modifie pas le sprite
        }
    }
}

/*------------------------------------------------------------------------------
NAME  : draw
DESCR : dessine l'image
ARG   : x,y: coordonees (du centre bas)
RETURN: void
NOTES : none
------------------------------------------------------------------------------*/
void cImg::drawsub_centerlow(int x, int y, int do_inv, int x0, int y0, int x1, int y1)
{
    int t;
    if(x0>x1) { t=x0; x0=x1; x1=t; }
    if(y0>y1) { t=y0; y0=y1; y1=t; }

    //drawsub(x-(tr_dx/2),y-tr_dy,do_inv,x0,y0,x1,y1);
    drawsub(x-(x1-x0)/2,y-(y1-y0),0,x0,y0,x1,y1);
}

/*------------------------------------------------------------------------------
NAME  : draw
DESCR : dessine l'image
ARG   : x,y: coordonees (du coin gauche haut)
RETURN: void
NOTES : none
------------------------------------------------------------------------------*/
void cImg::draw_rect(int x, int y, int fill)
{
    SelectObject(hdcMemTemp,bmp_pinceau_jaune);
    SelectObject(hdcMemTemp,bmp_stylo_rouge);
    if(fill==1) Rectangle(hdcMemTemp,x+0,y+0,x+tr_dx,y+tr_dy);
    if(fill==0)
    {
        EasyLineTemp(x+0,y+0,x+tr_dx,y+0);
        EasyLineTemp(x+0,y+tr_dy,x+tr_dx,y+tr_dy);
        EasyLineTemp(x+0,y+0,x+0,y+tr_dy);
        EasyLineTemp(x+tr_dx,y+0,x+tr_dx,y+tr_dy);
    }
}

/*------------------------------------------------------------------------------
NAME  : draw
DESCR : dessine l'image
ARG   : x,y: coordonees (du coin gauche haut)
RETURN: void
NOTES : none
------------------------------------------------------------------------------*/
void cImg::draw_rect_centerlow(int x, int y, int fill)
{
    draw_rect(x-(tr_dx/2), y-tr_dy, fill);
}

/*****************************************************************************/
/* UTILISATION CLASS IMG                                                     */
/*****************************************************************************/

cImg img_carte;

#define NB_IMG_TR 1000
#define NB_IMG_BAT 2000
cImg img_tr[NB_IMG_TR];
cImg img_bat[NB_IMG_BAT];
int img_tr_free=0;
int img_bat_free=0;

cImg img_tr_pose;
cImg img_bat_pose;

/*****************************************************************************/
/* FIN CLASS IMG (pour l'affichage des images)                               */
/*****************************************************************************/




//-----------------------------------------------------------------
// GESTION DE LA CARTE 2
//-----------------------------------------------------------------

int x0=0,y0=0;
int next_ligne=0;

int carte2_bmp[CARTE2_NB];
int carte2_pt[CARTE2_NB_PT][5];
#define CARTE2_PT_IND_CARTE 0
#define CARTE2_PT_IND_X 1
#define CARTE2_PT_IND_Y 2
#define CARTE2_PT_IND_TXT 3
#define CARTE2_PT_IND_ACT 4
int carte2_next_pt=0;
int carte2_num=0;
int carte2_x=0;
int carte2_y=0;

void carte2_init(void)
{
    int i;

    for(i=0;i<CARTE2_NB;i++) carte2_bmp[i]=-1;
    carte2_next_pt=0;
    for(i=0;i<CARTE2_NB_PT;i++) carte2_pt[i][CARTE2_PT_IND_CARTE]=-1;
    carte2_num=0;
    carte2_x=0;
    carte2_y=0;
}

void carte2_load(void) // pas besoin, traitement commun ds load_file
{
}

int stat_carte2_pt=0;
void carte2_save(void)
{
    FILE* pf;
    int i,j,x,y,a,t;
    char str[1000],str2[1000];

    stat_carte2_pt=0;
    pf=fopen(szInfraFileName,"at"); if(pf==NULL) return;

    fprintf(pf,"\n\n\n#========================================");
    fprintf(pf,    "\n# 2 bis. Carte 2 (img et pt2)");
    fprintf(pf,    "\n#========================================");

    for(j=0;j<CARTE2_NB;j++)
    {
        strcpy(str,""); if(carte2_bmp[j]!=-1) strcpy(str,&szTxtBuff[carte2_bmp[j]]);
        fprintf(pf,"\n\ncarte2 %d \"%s\"\n\npt2",j,str);

        for(i=0;i<carte2_next_pt;i++) if(carte2_pt[i][CARTE2_PT_IND_CARTE]==j)
        {
            x=carte2_pt[i][CARTE2_PT_IND_X]; if(x==-1) continue;
            y=carte2_pt[i][CARTE2_PT_IND_Y];
            t=carte2_pt[i][CARTE2_PT_IND_TXT]; strcpy(str, ""); if(t!=-1) strcpy(str,&szTxtBuff[t]);
            a=carte2_pt[i][CARTE2_PT_IND_ACT]; strcpy(str2,""); if(a!=-1) strcpy(str2,&szTxtBuff[a]);

            fprintf(pf,"\n%d %d \"%s\" \"%s\"",x,y,str,str2);

            stat_carte2_pt++;
        }
    }

    fclose(pf);
}

void carte2_select(int sel)
{
    int ind;
    char szMapFileName[1000];

    img_carte.unload();
    ind=carte2_bmp[sel];
    if(ind!=-1)
    {
        sprintf(szMapFileName,"%s%s%s",szBasePstDir,"cartes\\",&szTxtBuff[ind]); //passer en absolu
        img_carte.load(szMapFileName,0,0);
    }
    carte2_num=sel;
}

int carte2_aff_pt=1;
int carte2_cli_pt=0;
int carte2_cpt=0;
int carte2_cli_state=0;

void carte2_draw(void)
{
    int i,x,y,t,a;

    carte2_cpt=(carte2_cpt+1)%20;  //0-19
    if(carte2_cpt==9 ) carte2_cli_state=1;
    if(carte2_cpt==19) carte2_cli_state=0;

    //if((carte2_cpt%5)!=0) return; // affiche une fois sur 10 car pas besoin d'un rafraichissement si rapide

    img_carte.draw(0-carte2_x,0-carte2_y,0);

    if(carte2_aff_pt) if(carte2_cli_pt==0 || (carte2_cli_pt==1 && carte2_cli_state==1))
    for(i=0;i<carte2_next_pt;i++) if(carte2_pt[i][CARTE2_PT_IND_CARTE]==carte2_num)
    {
        x=carte2_pt[i][CARTE2_PT_IND_X]; if(x==-1) continue;
        y=carte2_pt[i][CARTE2_PT_IND_Y];
      //t=carte2_pt[i][CARTE2_PT_IND_TXT]; strcpy(str, ""); if(t!=-1) strcpy(str,&szTxtBuff[t]);
      //a=carte2_pt[i][CARTE2_PT_IND_ACT]; strcpy(str2,""); if(a!=-1) strcpy(str2,&szTxtBuff[a]);

        x-=carte2_x; y-=carte2_y;

        SelectObject(hdcMemTemp,bmp_pinceau_rouge);
        SelectObject(hdcMemTemp,bmp_stylo_rouge);
        Rectangle(hdcMemTemp,x-5,y-5,x+5,y+5);
        //SelectObject(hdcMemTemp,bmp_pinceau_jaune);
        //SelectObject(hdcMemTemp,bmp_stylo_jaune);
        //EasyLineTemp(x-5,y-5,x+5,y-5);
        //EasyLineTemp(x-5,y+5,x+5,y+5);
        //EasyLineTemp(x-5,y-5,x-5,y+5);
        //EasyLineTemp(x+5,y-5,x+5,y+5);
    }
}

void carte2_prep_edit_for_ins(void)
{
    char sz[1000];
    sprintf(sz,"ligne-> %d %d %d / carte-> # / action",current_ligne,x0,y0); set_wid_txt(sz);
}

void carte2_op_menu_ins(void)
{
    carte2_prep_edit_for_ins();
    MessageBox(NULL,"Pour inserer un point\n- Renseignez les actions dans la zone de saisie\n- Fermez la zone de saisie\n- Amenez le curseur au point d'insertion\n- Appuyez sur la touche INS\n\nConcerant la zone de saisie:\n- Pour un saut sur une ligne \"ligne-> numero_de_ligne x_ligne _y_ligne\" (ces information sont pre-remplit a l'ouverture de ce menu avec la derniere position en ligne)\n- Pur un saut vers une autre carte \"carte-> numero_de_la_carte\"\n- Pour une action sur l'ordinateur \"L'action\" (ex: open c:\\son1.wav)","PST info",MB_OK);
}

void carte2_op_menu_del(void)
{
    MessageBox(NULL,"Pour supprimer un point\n- Amenez le curseur sur le point a supprimer\n- Appuyez sur la touche DEL (ou Suppr)","PST info",MB_OK);
}

void carte2_op_change_img(char* filename)
{
    carte2_bmp[carte2_num]=txtBuff_Add(&filename[strlen(szBasePstDir)+strlen("cartes\\")]); // convertion absolu -> relatif
    carte2_select(carte2_num);
}

void carte2_op_del_img(void)
{
    carte2_bmp[carte2_num]=-1;
    carte2_select(carte2_num);
}

void carte2_op_sel_carte()
{
    char sz[1000]; int i;
    get_wid_txt(sz);
    i=atoi(sz);
    if(i<CARTE2_NB) carte2_select(i);
}

void carte2_exe(char* szOrdre)
{
    int l,x,y,c;
    if(strnicmp(szOrdre,"ligne-> ",strlen("ligne-> "))==0)
    {
        sscanf(&szOrdre[7]," %d %d %d",&l,&x,&y);
        if(l>=0) { next_ligne=l; x0=x; y0=y; aff_mode=AFF_MODE_RESEAU; }
    }
    if(strnicmp(szOrdre,"carte-> ",strlen("carte-> "))==0)
    {
        sscanf(&szOrdre[7]," %d",&c);
        carte2_select(c);
    }
    else ShellExecute(NULL,"open",szOrdre, NULL, NULL, SW_SHOWNA);
}

void carte2_op_key_ins(void)
{
    int x,y;
    char sz[1000];

    x=x_mouse_move+carte2_x; y=y_mouse_move+carte2_y;

    get_wid_txt(sz);
    carte2_pt[carte2_next_pt][CARTE2_PT_IND_CARTE]=carte2_num;
    carte2_pt[carte2_next_pt][CARTE2_PT_IND_X]=x;
    carte2_pt[carte2_next_pt][CARTE2_PT_IND_Y]=y;
    carte2_pt[carte2_next_pt][CARTE2_PT_IND_TXT]=-1; // pas de texte pour l'instant
    carte2_pt[carte2_next_pt][CARTE2_PT_IND_ACT]=-1;
    if(sz!='\0') carte2_pt[carte2_next_pt][CARTE2_PT_IND_ACT]=txtBuff_Add(sz);
    carte2_next_pt++;
}

void carte2_op_key_del(void)
{
    int i,x,y,xp,yp;

    x=x_mouse_move+carte2_x; y=y_mouse_move+carte2_y;

    for(i=0;i<carte2_next_pt;i++) if(carte2_pt[i][CARTE2_PT_IND_CARTE]==carte2_num)
    {
        xp=carte2_pt[i][CARTE2_PT_IND_X]; if(xp==-1) continue;
        yp=carte2_pt[i][CARTE2_PT_IND_Y];
        if( x>xp-5 && x<xp+5 && y>yp-5 && y<yp+5) carte2_pt[i][CARTE2_PT_IND_X]=-1;
    }
}

void carte2_click(int x, int y)
{
    int i,xp,yp,a;
    x=x+carte2_x; y=y+carte2_y;
    //char szDebug[1000];

    for(i=0;i<carte2_next_pt;i++) if(carte2_pt[i][CARTE2_PT_IND_CARTE]==carte2_num)
    {
        xp=carte2_pt[i][CARTE2_PT_IND_X]; if(xp==-1) continue;
        yp=carte2_pt[i][CARTE2_PT_IND_Y];
        if( x>xp-5 && x<xp+5 && y>yp-5 && y<yp+5)
        {
            //MessageBox(NULL,"coucou","debug",MB_OK);
            a=carte2_pt[i][CARTE2_PT_IND_ACT];
            if(a!=-1) carte2_exe(&szTxtBuff[a]);
        }
    }
}

void carte2_deplace(int old_ligne, int x_g, int y_h, int x_d, int y_b, int x_src, int y_src, int new_ligne, int x_dst, int y_dst)
{
    int i,t,l,x,y,new_x,new_y;
    char str[1000];

    if(x_g>x_d) { t=x_g; x_g=x_d; x_d=t; }
    if(y_h>y_b) { t=y_h; y_h=y_b; y_b=t; }

    for(i=0;i<carte2_next_pt;i++) if(carte2_pt[i][CARTE2_PT_IND_X]!=-1) //pr chaque pt non efface
    {
        t=carte2_pt[i][CARTE2_PT_IND_TXT]; strcpy(str, ""); if(t!=-1) strcpy(str,&szTxtBuff[t]);
        if(strnicmp(str,"ligne->",strlen("ligne->"))==0)              //dont action commence par ligne
        {
            sscanf(&str[strlen("ligne->")]," %d %d %d",&l,&x,&y);
            if(l>=0) if(l==old_ligne)
            if(x>=x_g && x<=x_d && y>=y_h && y<=y_b)                    //dont saut correspond a la source a deplacer
            {
                new_x=x+x_dst-x_src; new_y=y+y_dst-y_src;               //depalcer a nouvelle destination
                sprintf(&str[strlen("ligne->")],"ligne-> %d %d %d",new_ligne,new_x,new_y);
                carte2_pt[i][CARTE2_PT_IND_ACT]=txtBuff_Add(str);
            }
        }

    }
}

void  carte2_delete(int ligne, int x_g, int y_h, int x_d, int y_b)
{
    int i,l,x,y,t;
    char str[1000];

    if(x_g>x_d) { t=x_g; x_g=x_d; x_d=t; }
    if(y_h>y_b) { t=y_h; y_h=y_b; y_b=t; }

    for(i=0;i<carte2_next_pt;i++) if(carte2_pt[i][CARTE2_PT_IND_X]!=-1) //pr chaque pt non efface
    {
        t=carte2_pt[i][CARTE2_PT_IND_TXT]; strcpy(str, ""); if(t!=-1) strcpy(str,&szTxtBuff[t]);
        if(strnicmp(str,"ligne->",strlen("ligne->"))==0)              //dont action commence par ligne
        {
            sscanf(&str[strlen("ligne->")]," %d %d %d",&l,&x,&y);
            if(l>=0) if(l==ligne)
            if(x>=x_g && x<=x_d && y>=y_h && y<=y_b)                    //dont point dans la selection
            {
                carte2_pt[i][CARTE2_PT_IND_X]=-1;                       //effacer
            }
        }
    }
}

//-----------------------------------------------------------------
// FIN DE LA CARTE 2
//-----------------------------------------------------------------




//-----------------------------------------------------------------
// GESTION DE LA CARTE
//-----------------------------------------------------------------

//int x0=0,y0=0;
//int next_ligne=0;

char szDebug[1000];
FILE* pf; //pour fichier de debug

int carte_x=0;
int carte_y=0;
int carte_zoom=1;
int carte_txt=1;

//si color==99: pt ou seg a supprimer

//#define CARTE_NB_SEG 50000 // definit au debut maintenant
#define CARTE_IND_SEG_X1 0
#define CARTE_IND_SEG_Y1 1
#define CARTE_IND_SEG_X2 2
#define CARTE_IND_SEG_Y2 3
#define CARTE_IND_SEG_C  4
int carte_seg[CARTE_NB_SEG][5]; //0=x 1=y 2=color
int carte_next_seg=0;

//#define CARTE_NB_PT 10000 // definit au debut maintenant
#define CARTE_IND_PT_X 0
#define CARTE_IND_PT_Y 1
#define CARTE_IND_PT_C 2
#define CARTE_IND_PT_LIGNE   3 //-1 si action
#define CARTE_IND_PT_X_LIGNE 4
#define CARTE_IND_PT_Y_LIGNE 5
#define CARTE_IND_PT_X_T 6
#define CARTE_IND_PT_Y_T 7
#define CARTE_IND_PT_TXT 8
#define CARTE_IND_PT_ACT 9
int carte_pt[CARTE_NB_PT][10];
int carte_next_pt=0;

//#define CARTE_LEN_TXT 200000 // definit au debut maintenant
char szcarte_txt[CARTE_LEN_TXT];
int carte_txt_free=0;


void carte_load(void) // pas besoin, traitement commun ds load_file
{
}

void carte_save(void)
{
    FILE* pf;
    int i,x1,x2,y1,y2,color;

    pf=fopen(szInfraFileName,"at"); if(pf==NULL) return;

    fprintf(pf,"\n\n\n#========================================");
    fprintf(pf,    "\n# 2. Carte (pt et line)");
    fprintf(pf,    "\n#========================================");

    fprintf(pf,"\n\npt"); stat_pt=0;
    for(i=0;i<carte_next_pt;i++)
    {
         x1=carte_pt[i][CARTE_IND_PT_X];
         y1=carte_pt[i][CARTE_IND_PT_Y];
         color=carte_pt[i][CARTE_IND_PT_C]; if(color==99) continue;

         fprintf(pf,"\n%d %d %d %d %d %d %d %d \"%s\" \"%s\""
                   ,x1,y1,color
                   ,carte_pt[i][CARTE_IND_PT_LIGNE],carte_pt[i][CARTE_IND_PT_X_LIGNE],carte_pt[i][CARTE_IND_PT_Y_LIGNE]
                   ,carte_pt[i][CARTE_IND_PT_X_T],carte_pt[i][CARTE_IND_PT_Y_T]
                   ,&szcarte_txt[carte_pt[i][CARTE_IND_PT_TXT]],&szcarte_txt[carte_pt[i][CARTE_IND_PT_ACT]]);
         stat_pt++;
    }

    fprintf(pf,"\n\nline"); stat_line=0;
    for(i=0;i<carte_next_seg;i++)
    {
         x1=carte_seg[i][CARTE_IND_SEG_X1];
         y1=carte_seg[i][CARTE_IND_SEG_Y1];
         x2=carte_seg[i][CARTE_IND_SEG_X2];
         y2=carte_seg[i][CARTE_IND_SEG_Y2];
         color=carte_seg[i][CARTE_IND_SEG_C]; if(color==99) continue;

         fprintf(pf,"\n%d %d %d %d %d",x1,y1,x2,y2,color);
         stat_line++;
    }

    fclose(pf);
}

void carte_draw(void)
{
    int i,x1,x2,y1,y2,x0,y0,z,l,color,forme;
    char* ptxt;
    char sz[100];

    x0=carte_x;
    y0=carte_y;
    z=carte_zoom;

   SelectObject(hdcMemTemp,bmp_fonte);
   SelectObject(hdcMemTemp,bmp_stylo_rouge);
   SetBkMode(hdcMemTemp,TRANSPARENT);
   SetTextColor(hdcMemTemp,RGB(0,0,0));

   select_stylo_color(new_color);
   select_pinceau_color(new_color);
   Rectangle(hdcMemTemp,0,0,4,4);

   select_stylo_color(5);
   for(i=0;i<13;i++) if(z==1)
   {
         EasyLineTemp(0,100*i,1024,100*i);
         sprintf(sz,"%02d",i+y0/100);
         EasyTextOutTemp(0,100*i+50,sz);

         EasyLineTemp(100*i,0,100*i,1000);
         if((i+x0/100)>=0) sprintf(sz,"%02d-%c%c",i+x0/100,((i+x0/100)/26)+'A',((i+x0/100)%26)+'A');
         else if((i+x0/100>=-26)) sprintf(sz,"%02d-%c",i+x0/100,26+(i+x0/100)+'A');
         else sprintf(sz,"%02d",i+x0/100);
         EasyTextOutTemp(100*i+50,0,sz);
   }

    for(i=0;i<carte_next_seg;i++)
    {
         x1=carte_seg[i][CARTE_IND_SEG_X1];
         y1=carte_seg[i][CARTE_IND_SEG_Y1];
         x2=carte_seg[i][CARTE_IND_SEG_X2];
         y2=carte_seg[i][CARTE_IND_SEG_Y2];
         color=carte_seg[i][CARTE_IND_SEG_C];

         if(color==99) continue;
         if( (x1>(x0-(1500*z))) && (x1<(x0+(2500*z))) && (x2>(x0-(1500*z))) && (x2<(x0+(2500*z))) )
         if( (y1>(y0-(1000*z))) && (y1<(y0+(2000*z))) && (y2>(y0-(1000*z))) && (y2<(y0+(2000*z))) )
         {
             select_stylo_color(color);
             EasyLineTemp((x1-x0)/z,(y1-y0)/z,(x2-x0)/z,(y2-y0)/z);
         }
    }

    for(i=0;i<carte_next_pt;i++)
    {
         x1=carte_pt[i][CARTE_IND_PT_X];
         y1=carte_pt[i][CARTE_IND_PT_Y];
         color=carte_pt[i][CARTE_IND_PT_C];
         x2=carte_pt[i][CARTE_IND_PT_X_T];
         y2=carte_pt[i][CARTE_IND_PT_Y_T];
         ptxt=&szcarte_txt[carte_pt[i][CARTE_IND_PT_TXT]];
         l=carte_pt[i][CARTE_IND_PT_LIGNE];

         if(color==99) continue;
         if( (x1>(x0-(1500*z))) && (x1<(x0+(2500*z))) )
         if( (y1>(y0-(1000*z))) && (y1<(y0+(2000*z))) )
         {
                 select_stylo_color(color);
                 select_pinceau_color(color);
                 //if( carte_aff_pt_ligne_only==0 || (carte_aff_pt_ligne_only && l>=0))
                 Rectangle(hdcMemTemp,(x1-x0)/z-3,(y1-y0)/z-3,(x1-x0)/z+3,(y1-y0)/z+3);

                 if(l>=0 || szcarte_txt[carte_pt[i][CARTE_IND_PT_ACT]]!='\0')
                 {
                     EasyLineTemp((x1-x0)/z-5,(y1-y0)/z-5,(x1-x0)/z-5,(y1-y0)/z+4);
                     EasyLineTemp((x1-x0)/z+4,(y1-y0)/z-5,(x1-x0)/z+4,(y1-y0)/z+4);
                     EasyLineTemp((x1-x0)/z-5,(y1-y0)/z-5,(x1-x0)/z+4,(y1-y0)/z-5);
                     EasyLineTemp((x1-x0)/z-5,(y1-y0)/z+4,(x1-x0)/z+4,(y1-y0)/z+4);
                 }

                 if(carte_txt) EasyTextOutTemp((x1-x0)/z+x2+5,(y1-y0)/z+y2-5,ptxt);
         }
    }

}

int uabs(int x)
{
   if(x>=0) return (x%100);
   x=0-x;
   x=x%100;
   if(x==0) x=100;
   x=100-x;
   return (100+x)%100;
}

void carte_panel(void)
{
    int i,x1,y1,x2,y2,x,y;
    int x_p,y_p,color,ligne,x_l,y_l,x_t,y_t;

    SelectObject(hdcMemTemp,bmp_stylo_jaune);
    SelectObject(hdcMemTemp,bmp_pinceau_jaune);
    Rectangle(hdcMemTemp,0,panel_base,x_res,y_res);

    //SelectObject(hdc,bmp_fonte);
    //SetBkMode(hdcMemTemp,TRANSPARENT);
    //SetTextColor(hdcMemTemp,RGB(0,0,0));
    //EasyTextOutTemp(10,panel_base,szDebug);

    sprintf(szDisp,"x=%d y=%d dx=%d dy=%d zoom-=%d"
        ,x_mouse_move+carte_x,y_mouse_move+carte_y
        ,uabs(x_mouse_move+carte_x),uabs(y_mouse_move+carte_y)
        ,carte_zoom);
    EasyTextOutTemp(10,panel_base+20,szDisp);

    //detection des points
    for(i=0;i<carte_next_pt;i++)
    {
         x1=carte_pt[i][CARTE_IND_PT_X];
         y1=carte_pt[i][CARTE_IND_PT_Y];
         color=carte_pt[i][CARTE_IND_PT_C];

         if(x_mouse_move>(x1-carte_x-4) && x_mouse_move<(x1-carte_x+4) && y_mouse_move>(y1-carte_y-4) && y_mouse_move<(y1-carte_y+4))
         {
             x_p=carte_pt[i][CARTE_IND_PT_X];
             y_p=carte_pt[i][CARTE_IND_PT_Y];
             color=carte_pt[i][CARTE_IND_PT_C];
             ligne=carte_pt[i][CARTE_IND_PT_LIGNE];
             x_l=carte_pt[i][CARTE_IND_PT_X_LIGNE];
             y_l=carte_pt[i][CARTE_IND_PT_Y_LIGNE];
             x_t=carte_pt[i][CARTE_IND_PT_X_T];
             y_t=carte_pt[i][CARTE_IND_PT_Y_T];
             if(color==99) continue;
          
             sprintf(szDisp,"POINT: x_p=%d y_p=%d color=%d ligne=%d x_l=%d y_l=%d x_t=%d y_t=%d txt=\"%s\" act=\"%s\""
                           ,x_p,y_p,color,ligne,x_l,y_l,x_t,y_t
                           ,&szcarte_txt[carte_pt[i][CARTE_IND_PT_TXT]]
                           ,&szcarte_txt[carte_pt[i][CARTE_IND_PT_ACT]]);
             EasyTextOutTemp(10,panel_base+40,szDisp);
        }
    }

    //detection des segments
    for(i=0;i<carte_next_seg;i++)
    {
         x1=carte_seg[i][CARTE_IND_SEG_X1];
         y1=carte_seg[i][CARTE_IND_SEG_Y1];
         x2=carte_seg[i][CARTE_IND_SEG_X2];
         y2=carte_seg[i][CARTE_IND_SEG_Y2];
         color=carte_seg[i][CARTE_IND_SEG_C];

         if(color==99) continue;

         if(x1>x2) { x=x1; x1=x2; x2=x; y=y1; y1=y2; y2=y; }

         if((x_mouse_move+carte_x)>x1 && (x_mouse_move+carte_x)<x2)
         {
             double dyp, dy1, dy2, dx1, dx2, dxp;
             dxp=(double)x_mouse_move+(double)carte_x;
             dx1=(double)x1; dx2=(double)x2;
             dy1=(double)y1; dy2=(double)y2;
             //yp=y1+(y2-y1)*(x_mouse_move-x1)/(x2-x1);
             dyp=dy1+(dy2-dy1)*(dxp-dx1)/(dx2-dx1);
             y_p=(int)dyp;

             if((y_mouse_move+carte_y)>(y_p-3) && (y_mouse_move+carte_y)<(y_p+3))
             {
                 sprintf(szDisp,"SEG: x1=%d y1=%d x2=%d y2=%d color=%d"
                               ,carte_seg[i][CARTE_IND_SEG_X1],carte_seg[i][CARTE_IND_SEG_Y1]
                               ,carte_seg[i][CARTE_IND_SEG_X2],carte_seg[i][CARTE_IND_SEG_Y2]
                               ,color);
                 EasyTextOutTemp(10,panel_base+60,szDisp);
             }
         }
    }
}

void carte_del(void)
{
    int i,x1,y1,x2,y2,x,y;
    int x_p,y_p,color,ligne,x_l,y_l,x_t,y_t;

    //detection des points
    for(i=0;i<carte_next_pt;i++)
    {
         x1=carte_pt[i][CARTE_IND_PT_X];
         y1=carte_pt[i][CARTE_IND_PT_Y];
         color=carte_pt[i][CARTE_IND_PT_C];  if(color==99) continue;

         if(x_mouse_move>(x1-carte_x-4) && x_mouse_move<(x1-carte_x+4) && y_mouse_move>(y1-carte_y-4) && y_mouse_move<(y1-carte_y+4))
         {
             carte_pt[i][CARTE_IND_PT_C]=99;
         }
    }

    //detection des segments
    for(i=0;i<carte_next_seg;i++)
    {
         x1=carte_seg[i][CARTE_IND_SEG_X1];
         y1=carte_seg[i][CARTE_IND_SEG_Y1];
         x2=carte_seg[i][CARTE_IND_SEG_X2];
         y2=carte_seg[i][CARTE_IND_SEG_Y2];
         color=carte_seg[i][CARTE_IND_SEG_C];  if(color==99) continue;

         if(x1>x2) { x=x1; x1=x2; x2=x; y=y1; y1=y2; y2=y; }

         if((x_mouse_move+carte_x)>x1 && (x_mouse_move+carte_x)<x2)
         {
             double dyp, dy1, dy2, dx1, dx2, dxp;
             dxp=(double)x_mouse_move+(double)carte_x;
             dx1=(double)x1; dx2=(double)x2;
             dy1=(double)y1; dy2=(double)y2;
             //yp=y1+(y2-y1)*(x_mouse_move-x1)/(x2-x1);
             dyp=dy1+(dy2-dy1)*(dxp-dx1)/(dx2-dx1);
             y_p=(int)dyp;

             if((y_mouse_move+carte_y)>(y_p-3) && (y_mouse_move+carte_y)<(y_p+3))
             {
                 carte_seg[i][CARTE_IND_SEG_C]=99;
             }
         }
     }
}

void carte_key(char c) // pas besoin, traitement commun ds le handler de fenetre
{
}

void carte_mouse(int x, int y)
{
    int i,ok,x1,y1,ligne,x_l,y_l,color;
    char* pact;

    //1. recherche du point
    ok=0;
    for(i=0;i<carte_next_pt;i++)
    {
         x1=carte_pt[i][CARTE_IND_PT_X];
         y1=carte_pt[i][CARTE_IND_PT_Y];
         color=carte_pt[i][CARTE_IND_PT_C];
         if(color==99) continue;

         if(x_mouse_move>(x1-carte_x-4) && x_mouse_move<(x1-carte_x+4) && y_mouse_move>(y1-carte_y-4) && y_mouse_move<(y1-carte_y+4)) {ok=1; break;}
    }
    if(ok==0) return;

    ligne=carte_pt[i][CARTE_IND_PT_LIGNE];
    x_l=carte_pt[i][CARTE_IND_PT_X_LIGNE];
    y_l=carte_pt[i][CARTE_IND_PT_Y_LIGNE];
    pact=&szcarte_txt[carte_pt[i][CARTE_IND_PT_ACT]];

    //2. saut sur la ligne (si saut a executer)
    if(ligne>=0)
    {
        next_ligne=ligne;
        x0=x_l; //x0=x_l-500;
        y0=y_l; //y0=y_l-400;
        aff_mode=AFF_MODE_RESEAU;
        // chargements specifiques a la ligne si necessaire
    }

    //3. execution de l'action (si une action a executer)
    if(*pact!='\0') ShellExecute(NULL,"open",pact, NULL, NULL, SW_SHOWNA);
}


//-----------------------------------------------------------------
// GESTION DES
// - SEGMENTS
// - POINTS
// - AIGS
// - LIGNES
// - LINKS
// - GEO
// - TXT
// - BAT
//-----------------------------------------------------------------

//#define MAX_LIGNE 100  // definit au debut maintenant
//int current_ligne=0;
//int next_ligne=0;   //declare plus haut pour etre accessible par la carte
int load_ligne=0;     //lors du chargement du fichier
int infra_aff_sens=0; //pr voir des 2 cotes de la voie
int ligne[MAX_LIGNE][6];
#define IND_LIGNE_X0 0
#define IND_LIGNE_Y0 1
#define IND_LIGNE_NAME 2   //utilise char szcarte_txt[CARTE_LEN_TXT];
#define IND_LIGNE_IMG 3  //        int carte_txt_free=0;
#define IND_LIGNE_X0_INIT 4
#define IND_LIGNE_Y0_INIT 5

//#define MAX_PT 100000  // definit au debut maintenant
int pt[MAX_PT][6];
#define IND_PT_X     0 // x
#define IND_PT_Y     1 // y
#define IND_PT_AIG   2 // (-2: pt a supprimer) / -1: pt entre 2 segments / 0-999: pt d'aiguillage / 10000-10999: pt link
#define IND_PT_LIGNE 3 //
#define IND_PT_SEG_A 4 // un des segments (uniquement utile lorsque point entre 2 segments)
#define IND_PT_SEG_B 5 // l'autre segment (uniquement utile lorsque point entre 2 segments)
int pt_free=0;

//#define MAX_SEG 100000  // definit au debut maintenant
int seg[MAX_SEG][3];     // pas besoin de ligne car definie par pt
#define IND_SEG_PT_G  0  // pt gauche
#define IND_SEG_PT_D  1  // pt droit
#define IND_SEG_TYPE  2  // type
int seg_free=0;
#define SEG_TYPE_DELETE        -1
#define SEG_TYPE_NORMAL         0
#define SEG_TYPE_TUNEL          1
#define SEG_TYPE_PONT_METAL_B   2
#define SEG_TYPE_QUAI_H         3
#define SEG_TYPE_QUAI_B         4
#define SEG_TYPE_PONT_METAL_H   5
#define SEG_TYPE_QUAI_H_LARGE   6
#define SEG_TYPE_TRANSPARENT    7
#define SEG_TYPE_LIAISON        8
#define SEG_TYPE_OLD_NORMAL     9
#define SEG_TYPE_LOOP          10

int old_draw=1;
#define OLD_DRAW_NO  0
#define OLD_DRAW_RED 1
#define OLD_DRAW_STD 2

//#define MAX_LINK 1000 // definit au debut maintenant
int link[MAX_LINK][2];
#define IND_LINK_PTA 0  //-1 link non utilise
#define IND_LINK_PTB 1
int link_free=0;

//#define MAX_AIG 500  // par ligne // definit au debut maintenant
int aig[MAX_LIGNE][MAX_AIG][5];
#define IND_AIG_ETAT       0     // etat 0=diret 1=devie -1 non utilise
#define IND_AIG_SEG_COMMUN 1
#define IND_AIG_SEG_DIRECT 2
#define IND_AIG_SEG_DEVIE  3
#define IND_AIG_ETAT_INIT  4
int aig_free=0;

//#define MAX_GEO 20000 // definit au debut maintenant
int geo[MAX_GEO][9];
#define IND_GEO_x1    0
#define IND_GEO_y1    1
#define IND_GEO_x2    2
#define IND_GEO_y2    3
#define IND_GEO_color 4
#define IND_GEO_forme 5
#define IND_GEO_pos   6
#define IND_GEO_ligne 7
#define IND_GEO_sens  8 //sens dans lequel doit etre affiche (pas encore utilise)
int geo_free=0;
#define GEO_DELETE   -1
#define GEO_LINE      1
#define GEO_RECT      2
#define GEO_RECT_FILL 3

//#define MAX_TXT 10000 // definit au debut maintenant
int txt[MAX_TXT][6];
#define IND_TXT_x          0
#define IND_TXT_y          1
#define IND_TXT_pt_texte   2  //-1 for delete
#define IND_TXT_pt_action  3
#define IND_TXT_ligne      4
#define IND_TXT_sens       5  //sens dans lequel doit etre affiche (pas encore utilise)
int txt_free=0;

//#define MAX_BAT 10000 // definit au debut maintenant
int bat[MAX_BAT][11];            //pas de triple tableau car recharge a chaque changement de ligne
#define IND_BAT_SRC_X1        0  //gauche ds fichier
#define IND_BAT_SRC_X2        1  //bas ds fichier
#define IND_BAT_SRC_Y1        2  //droite ds fichier
#define IND_BAT_SRC_Y2        3  //haut ds fichier
#define IND_BAT_X             4  //bas centre sur ecran
#define IND_BAT_Y             5  //bas centre sur ecran
#define IND_BAT_DISP          6  //affichage (sinon affiche son encombrement)  1=aff 0=encombrement -1=detruire
#define IND_BAT_LIGNE         7  //ligne ou doit etre affiche
#define IND_BAT_SENS          8  //sens dans lequel doit etre affiche (pas encore utilise)
#define IND_BAT_FILENAME      9  //index sur fichier contenant le sprite
#define IND_BAT_IMG           10 //index sur l'image

int bat_free=0;

//#define MAX_DISP_SEG 10000  //definit plus haut maintenant
int disp_seg[MAX_DISP_SEG];
int disp_seg_free=0;
//#define MAX_DISP_GEO 2000   //definit plus haut maintenant
int disp_geo[MAX_DISP_GEO];
int disp_geo_free=0;
//#define MAX_DISP_BAT 1000   //definit plus haut maintenant
int disp_bat[MAX_DISP_BAT];
int disp_bat_free=0;
//#define MAX_DISP_TXT 200    //definit plus haut maintenant
int disp_txt[MAX_DISP_TXT];
int disp_txt_free=0;
char szhot_txt[1000]="";

void init_img_filename_bat(int num, char* szFilename)
{
    int ind,i;
    char sz[1000],sz2[1000];

    ind=txtBuffBat_Find(szFilename);

    if(ind==-1)//nouvelle image
    {
        ind=txtBuffBat_Add(szFilename);
        bat[num][IND_BAT_FILENAME]=ind;
    }
    else //un autre sprite utilise la meme image, recherche de ce sprite et recuperation du pointeur image
    {
        bat[num][IND_BAT_FILENAME]=ind;
    }
}

void load_reload_bat_img_for_line(int ligne)
{
    int i,j,ind,ok,trans;
    char sz[1000];
    char szFile[1000];

    for(i=0;i<img_bat_free;i++) img_bat[i].unload(); //unload images
    img_bat_free=0;

    for(i=0;i<bat_free;i++) bat[i][IND_BAT_IMG]=-1; //remove image index

    for(i=0;i<bat_free;i++) if(bat[i][IND_BAT_DISP]!=-1) if(bat[i][IND_BAT_LIGNE]==ligne) //load images
    {
        ok=0;
        ind=bat[i][IND_BAT_FILENAME];
        for(j=0;j<i;j++) if(bat[j][IND_BAT_DISP]!=-1) if(bat[j][IND_BAT_LIGNE]==ligne) if(bat[j][IND_BAT_FILENAME]==ind) //un autre sprite utilise la meme image
        {
            bat[i][IND_BAT_IMG]=bat[j][IND_BAT_IMG];
            ok=1;
            break;
        }
        if(ok==0) //nouvelle image
        {
            strcpy(szFile,&szTxtBuffBat[bat[i][IND_BAT_FILENAME]]);
            trans=1; if(strstr(szFile,"__")!=NULL) trans=0;

            sprintf(sz,"%s%s%s",szBasePstDir,"bat\\",szFile);
            img_bat[img_bat_free].load(sz,trans,0);  // trans=1 inv=0
            bat[i][IND_BAT_IMG]=img_bat_free;
            img_bat_free++;
        }

        //sprintf(sz2,"num=%d filename=%s sz=%s ind=%d file[index]=%s img=%d",num,szFilename,sz,bat[num][IND_BAT_FILENAME],&szTxtBuffBat[ind],bat[num][IND_BAT_IMG]);
        //MessageBox(NULL,sz2,"debug",MB_OK);
    }
}

/*------------------------------------------
    fill_pt_sega_segb

    indique 2 segements d'un point pour aller plus vite lors de la gestion du deplacement des sprite
    si le point est le coeur d'un aiguillage alors il faudra utiliser les segements definits dans aig
    si le point est un heurtoire alors SEG_B vaut -1
    a appeler apres chargement et creation/destruction de segments
------------------------------------------*/
void fill_pt_sega_segb(void)
{
    int i,ptg,ptd;

    for(i=0;i<MAX_PT;i++) pt[i][IND_PT_SEG_A]=pt[i][IND_PT_SEG_B]=-1;

    for(i=0;i<seg_free;i++) if(seg[i][IND_SEG_PT_G]!=-1) if(seg[i][IND_SEG_TYPE]!=SEG_TYPE_DELETE)
    {
        ptg=seg[i][IND_SEG_PT_G];

        if(pt[ptg][IND_PT_SEG_A]==-1) pt[ptg][IND_PT_SEG_A]=i;
        else if(pt[ptg][IND_PT_SEG_B]==-1) pt[ptg][IND_PT_SEG_B]=i;

        ptd=seg[i][IND_SEG_PT_D];

        if(pt[ptd][IND_PT_SEG_A]==-1) pt[ptd][IND_PT_SEG_A]=i;
        else if(pt[ptd][IND_PT_SEG_B]==-1) pt[ptd][IND_PT_SEG_B]=i;
    }

    //rajouter triage si necessaire
}

// remplissage de la liste des segments / geo / txt / bat de la zone (ligne,x,y)
// se fait automatiquement si depassement de la zone
// ou manuellement en forcant avec le parametre a 1 si creation/destruction d'un de ces elements
#define DISP_LEN 10000
void disp_seg_geo_txt_bat_fill(int force) //force: suite a un ajout par exemple
{
    static int lold=-1,xold,yold;
    int i,ptg,disp,x,y;

    disp=0;
    if(lold!=current_ligne) {lold=current_ligne; disp=1; xold=x0; yold=y0; }
    if( abs(xold-x0)>DISP_LEN || abs(yold-y0)>DISP_LEN) {disp=1; xold=x0; yold=y0; }
    if(force) disp=1;
    if(disp==0) return;

    //MessageBox(NULL,"Refill","info",MB_OK);

    disp_seg_free=0;
    for(i=0;i<seg_free;i++) if(seg[i][IND_SEG_PT_G]!=-1) if(seg[i][IND_SEG_TYPE]!=SEG_TYPE_DELETE)
    {
        ptg=seg[i][IND_SEG_PT_G]; if(pt[ptg][IND_PT_LIGNE]!=current_ligne) continue;
        x=pt[ptg][IND_PT_X]; y=pt[ptg][IND_PT_Y];
        if(x>(xold-DISP_LEN-2000) && x<(xold+DISP_LEN+2000) && y>(yold-DISP_LEN-2000) && y<(yold+DISP_LEN+2000))
        {
            disp_seg[disp_seg_free++]=i;
            if(disp_seg_free==MAX_DISP_SEG) { sprintf(szDebug,"Erreur:trop de seg pour le buffer d'affichage"); break; }
        }
    }

    disp_geo_free=0;
    for(i=0;i<geo_free;i++) if(geo[i][IND_GEO_forme]!=GEO_DELETE) if(geo[i][IND_GEO_ligne]==current_ligne)
    {
        x=geo[i][IND_GEO_x1]; y=geo[i][IND_GEO_y1];
        if(x>(xold-DISP_LEN-2000) && x<(xold+DISP_LEN+2000) && y>(yold-DISP_LEN-2000) && y<(yold+DISP_LEN+2000))
        {
            disp_geo[disp_geo_free++]=i;
            if(disp_geo_free==MAX_DISP_GEO) { sprintf(szDebug,"Erreur:trop de geo pour le buffer d'affichage"); break; }
        }
    }

    disp_bat_free=0;
    for(i=0;i<bat_free;i++) if(bat[i][IND_BAT_DISP]!=-1) if(bat[i][IND_BAT_LIGNE]==current_ligne)
    {
        x=bat[i][IND_BAT_X]; y=bat[i][IND_BAT_Y];
        if(x>(xold-DISP_LEN-2000) && x<(xold+DISP_LEN+2000) && y>(yold-DISP_LEN-2000) && y<(yold+DISP_LEN+2000))
        {
            disp_bat[disp_bat_free++]=i;
            if(disp_bat_free==MAX_DISP_BAT) { sprintf(szDebug,"Erreur:trop de bat pour le buffer d'affichage"); break; }
        }
    }

    disp_txt_free=0;
    for(i=0;i<txt_free;i++) if(txt[i][IND_TXT_pt_texte]!=-1) if(txt[i][IND_TXT_ligne]==current_ligne)
    {
        x=txt[i][IND_TXT_x]; y=txt[i][IND_TXT_y];
        if(x>(xold-DISP_LEN-2000) && x<(xold+DISP_LEN+2000) && y>(yold-DISP_LEN-2000) && y<(yold+DISP_LEN+2000))
        {
            disp_txt[disp_txt_free++]=i;
            if(disp_txt_free==MAX_DISP_TXT) { sprintf(szDebug,"Erreur:trop de txt pour le buffer d'affichage"); break; }
        }
    }
}

void ligne_init(void)
{
    int i;

    szcarte_txt[carte_txt_free]='\0';
    for(i=0;i<MAX_LIGNE;i++)
    {
        ligne[i][IND_LIGNE_X0]=ligne[i][IND_LIGNE_X0_INIT]=0;
        ligne[i][IND_LIGNE_Y0]=ligne[i][IND_LIGNE_Y0_INIT]=0;
        ligne[i][IND_LIGNE_NAME]=carte_txt_free;
        ligne[i][IND_LIGNE_IMG]=carte_txt_free;
    }
    carte_txt_free++;
}

void ligne_init_one(int num, int x0, int y0, char* szname, char* szimg)
{
    ligne[num][IND_LIGNE_X0]=ligne[num][IND_LIGNE_X0_INIT]=x0;
    ligne[num][IND_LIGNE_Y0]=ligne[num][IND_LIGNE_Y0_INIT]=y0;

    strcpy(&szcarte_txt[carte_txt_free],szname);
    ligne[num][IND_LIGNE_NAME]=carte_txt_free; //utilisation de la chaine: &szcarte_txt[carte_txt_free];
    carte_txt_free+=strlen(szname)+1;

    strcpy(&szcarte_txt[carte_txt_free],szimg);
    ligne[num][IND_LIGNE_IMG]=carte_txt_free;
    carte_txt_free+=strlen(szimg)+1;
}

void change_ligne_name(void)
{
    char sz[1000];

    get_wid_txt(sz);

    strcpy(&szcarte_txt[carte_txt_free],sz);
    ligne[current_ligne][IND_LIGNE_NAME]=carte_txt_free;
    carte_txt_free+=strlen(sz)+1;

}

void set_current_ligne_name(void)
{
    char sz[1000];

    strcpy(sz,&szcarte_txt[ligne[current_ligne][IND_LIGNE_NAME]]);
    set_wid_txt(sz);
}

void disp_lignes_names(void)
{
    int i,j;
    char sz[100000];
    char sz2[1000];
    char sz3[1000];

    i=0; j=0;
    while(i<MAX_LIGNE)
    {
        sz[0]='\0';
        while(i<MAX_LIGNE)
        {
            strcpy(sz2,&szcarte_txt[ligne[i][IND_LIGNE_NAME]]);
            if(sz2[0]!='\0')
            {
                if(i==current_ligne) sprintf(sz3,"\n%02d => %s",i,sz2);
                else                 sprintf(sz3,"\n%02d -> %s",i,sz2);
                strcat(sz,sz3);
                if(i==current_ligne) strcat(sz," <=");
                j++;
            }
            i++;
            if(j==30) { j=0; break; }
        }
        MessageBox(NULL,sz,"PST",MB_OK|MB_ICONINFORMATION);
    }
}

int bat_del=-1;

int aff_bat_sel(void)
{
    int i,x,y,dx,dy,k;

    bat_del=-1;
    //if(bat_free!=0) for(i=bat_free-1;i>=0;i--) if(bat[i][IND_BAT_LIGNE]==current_ligne) if(bat[i][IND_BAT_DISP]!=-1)   //a l'envers pour prendre le premier affiche
    if(disp_bat_free!=0) for(k=disp_bat_free-1;k>=0;k--)
    {
        i=disp_bat[k]; if(bat[i][IND_BAT_DISP]==-1) continue;

        x=bat[i][IND_BAT_X]-x0;
        y=bat[i][IND_BAT_Y]-y0;
        dx=bat[i][IND_BAT_SRC_X2]-bat[i][IND_BAT_SRC_X1]; if(dx<0) dx=0-dx;
        dy=bat[i][IND_BAT_SRC_Y2]-bat[i][IND_BAT_SRC_Y1]; if(dy<0) dy=0-dy;

        if( x_mouse_move>(x-(dx/2)) && x_mouse_move<(x+(dx/2)) && y_mouse_move>(y-dy) && y_mouse_move<y )
        {
            bat_del=i;
            sprintf(szDisp,"BAT: num=%d x=%d y=%d",i,x,y);
            EasyTextOutTemp(410,panel_base+60,szDisp);
            return 1;
        }
    }
    return 0;
}

int delete_bat(int bat_del)
{
    if(bat_del==-1) return 0;
    bat[bat_del][IND_BAT_DISP]=-1; //detruire
    return 1;
}

void hide_unhide_bat(void)
{
    if(bat_del==-1) return;
    if(bat[bat_del][IND_BAT_DISP]==0 || bat[bat_del][IND_BAT_DISP]==1) bat[bat_del][IND_BAT_DISP]^=1;
}

void pt_init_one(int num,int ligne,int x,int y,int aig)
{
    pt[num][IND_PT_LIGNE]=ligne;
    pt[num][IND_PT_X]=x;
    pt[num][IND_PT_Y]=y;
    pt[num][IND_PT_AIG]=aig;
}

void seg_init_one(int num,int pt_g,int pt_d)
{
    seg[num][IND_SEG_PT_G]=pt_g;
    seg[num][IND_SEG_PT_D]=pt_d;
}

void aig_init_one(int ligne,int num, int seg_commun, int seg_direct, int seg_devie, int etat)
{
    aig[ligne][num][IND_AIG_SEG_COMMUN]=seg_commun;
    aig[ligne][num][IND_AIG_SEG_DIRECT]=seg_direct;
    aig[ligne][num][IND_AIG_SEG_DEVIE]=seg_devie;
    aig[ligne][num][IND_AIG_ETAT]=etat;
    aig[ligne][num][IND_AIG_ETAT_INIT]=etat;
}

void pt_seg_aig_ligne_init(void)
{
    int j,i;

    for(i=0;i<MAX_PT;i++) pt[i][IND_PT_X]=-1;       //pas trop necessire car pt_free
    for(i=0;i<MAX_PT;i++) pt[i][IND_PT_SEG_A]=pt[i][IND_PT_SEG_B]=-1;
    for(i=0;i<MAX_SEG;i++) seg[i][IND_SEG_PT_G]=-1; //pas trop necessire car seg_free
    for(j=0;j<MAX_LIGNE;j++) for(i=0;i<MAX_AIG;i++) aig[j][i][IND_AIG_ETAT]=-1; //necessaire
    ligne_init();
}

int seg_del=-1;

int aff_seg_sel(void)
{
    int i,ptg,ptd,xg,yg,xd,yd,aig_no,j,ag,ad,xt,yt,k;
    int x1,y1,x2,y2,x,y;
    int x_p,y_p,color,ligne,x_l,y_l,x_t,y_t;

    seg_del=-1;
    //for(i=0;i<seg_free;i++) if(seg[i][IND_SEG_PT_G]!=-1) if(seg[i][IND_SEG_TYPE]!=SEG_TYPE_DELETE)
    for(k=0;k<disp_seg_free;k++)
    {
        i=disp_seg[k];
        if(seg[i][IND_SEG_PT_G]==-1) continue;
        if(seg[i][IND_SEG_TYPE]==SEG_TYPE_DELETE) continue;

        ptg=seg[i][IND_SEG_PT_G];   //if(pt[ptg][IND_PT_LIGNE]!=current_ligne) continue;
        ptd=seg[i][IND_SEG_PT_D];
        x1=xg=pt[ptg][IND_PT_X];
        y1=yg=pt[ptg][IND_PT_Y];
        x2=xd=pt[ptd][IND_PT_X];
        y2=yd=pt[ptd][IND_PT_Y];
        ag=pt[ptg][IND_PT_AIG];
        ad=pt[ptd][IND_PT_AIG];

        if(x1>x2) {x=x1;x1=x2;x2=x; y=y1;y1=y2;y2=y;}

         if((x_mouse_move+x0)>x1 && (x_mouse_move+x0)<x2)
         {
             double dyp, dy1, dy2, dx1, dx2, dxp;
             dxp=(double)x_mouse_move+(double)x0;
             dx1=(double)x1; dx2=(double)x2;
             dy1=(double)y1; dy2=(double)y2;
             //yp=y1+(y2-y1)*(x_mouse_move-x1)/(x2-x1);
             dyp=dy1+(dy2-dy1)*(dxp-dx1)/(dx2-dx1);
             y_p=(int)dyp;

             if((y_mouse_move+y0)>(y_p-3) && (y_mouse_move+y0)<(y_p+3))
             {
                 seg_del=i;
                 sprintf(szDisp,"SEG: x1=%d y1=%d x2=%d y2=%d",x1,y1,x2,y2);
                 EasyTextOutTemp(410,panel_base+60,szDisp);
             }
         }
    }

    if(seg_del==-1) return 0; else return 1;
}

int txt_del=-1;
int aff_txt_sel(void)
{
    int i,x,y,k;

    txt_del=-1;
    //for(i=0;i<txt_free;i++) if(txt[i][IND_TXT_ligne]==current_ligne) if(txt[i][IND_TXT_pt_texte]!=-1)
    for(k=0;k<disp_txt_free;k++)
    {
        i=disp_txt[k];
        if(txt[i][IND_TXT_pt_texte]==-1) continue;

        x=txt[i][IND_TXT_x];
        y=txt[i][IND_TXT_y];

         if((x_mouse_move+x0)>(x-20) && (x_mouse_move+x0)<(x+20))
         if((y_mouse_move+y0)>(y   ) && (y_mouse_move+y0)<(y+20))
         {
             txt_del=i;
             sprintf(szDisp,"TXT: nb=%d x=%d y=%d",i,x,y);
             EasyTextOutTemp(410,panel_base+60,szDisp);
             return 1;
         }
    }
    return 0;
}

int delete_txt(int txt_del)
{
    if(txt_del==-1) return 0;
    txt[txt_del][IND_TXT_pt_texte]=-1;
    return 1;
}

int geo_del=-1;
int aff_geo_sel(void)
{
    int i,x1,x2,y1,y2,color,forme,k;

    geo_del=-1;
    //for(i=0;i<geo_free;i++) if(geo[i][IND_GEO_ligne]==current_ligne) if(geo[i][IND_GEO_forme]!=GEO_DELETE)
    for(k=0;k<disp_geo_free;k++)
    {
         i=disp_geo[k];
         if(geo[i][IND_GEO_forme]==GEO_DELETE) continue;

         x1=geo[i][IND_GEO_x1];
         y1=geo[i][IND_GEO_y1];
         x2=geo[i][IND_GEO_x2];
         y2=geo[i][IND_GEO_y2];
         color=geo[i][IND_GEO_color];
         forme=geo[i][IND_GEO_forme];

         if((x_mouse_move+x0)>(x1-3) && (x_mouse_move+x0)<(x1+3))
         if((y_mouse_move+y0)>(y1-3) && (y_mouse_move+y0)<(y1+3))
         {
             geo_del=i;
             sprintf(szDisp,"GEO: x1=%d y1=%d x2=%d y2=%d",x1,y1,x2,y2);
             EasyTextOutTemp(410,panel_base+60,szDisp);
         }
    }

    if(geo_del==-1) return 0; else return 1;
}

int delete_geo(int geo_del)
{
    if(geo_del==-1) return 0;
    geo[geo_del][IND_GEO_forme]=GEO_DELETE;
    return 1;
}

void geo_change_dessus_dessous(void)
{
    if(geo_del==-1) return;
    if(geo[geo_del][IND_GEO_forme]!=GEO_DELETE) geo[geo_del][IND_GEO_pos]=(geo[geo_del][IND_GEO_pos]&1)^1;
}

/*------------------------------------------
    delete _seg

    destruction du segment selectionne
    si une des extremitee est
    - un coeur d'aiguillage
    - ou un link
    alors ils seront egalement detruits
-------------------------------------------*/
int delete_seg(int seg_del)
{
    int  ptd,ptg,laig;

    if(seg_del<0) return 0;
    seg[seg_del][IND_SEG_TYPE]=SEG_TYPE_DELETE;

    ptg=seg[seg_del][IND_SEG_PT_G];
    ptd=seg[seg_del][IND_SEG_PT_D];

    laig=pt[ptg][IND_PT_AIG];
    if(laig>=0 && laig<=999)       { pt[ptg][IND_PT_AIG]=-1; aig[current_ligne][laig][0]=-1; /*non utilise*/     }
    if(laig>=10000 && laig<=10999) { pt[ptg][IND_PT_AIG]=-1; link[laig-10000][IND_LINK_PTA]=-1; link[laig-10000][IND_LINK_PTB]=-1; }

    laig=pt[ptd][IND_PT_AIG];
    if(laig>=0 && laig<=999)       { pt[ptd][IND_PT_AIG]=-1; aig[current_ligne][laig][0]=-1; /*non utilise*/     }
    if(laig>=10000 && laig<=10999) { pt[ptd][IND_PT_AIG]=-1; link[laig-10000][IND_LINK_PTA]=-1; link[laig-10000][IND_LINK_PTB]=-1; }

    return 1;
}

void seg_change_type(void)
{
    if(seg_del==-1) return;
    if(seg[seg_del][IND_SEG_TYPE]!=-1) seg[seg_del][IND_SEG_TYPE]++;
    if(seg[seg_del][IND_SEG_TYPE]==SEG_TYPE_LOOP) seg[seg_del][IND_SEG_TYPE]=0;
}

int start_ligne=0;
void save_var(int save_view)
{
    FILE* pf;
    int val;

    pf=fopen(szInfraFileName,"at"); if(pf==NULL) return;

    fprintf(pf,"\n\n\n#========================================");
    fprintf(pf,    "\n# 1. Variables (var_)");
    fprintf(pf,    "\n#========================================\n");

  //fprintf(pf,"\n#save_view=%d",save_view);

    fprintf(pf,"\nvar_config_vers %d",CONFIG_VERS);
    fprintf(pf,"\nvar_x_res       %d",x_res );
    fprintf(pf,"\nvar_y_res       %d",y_res );
    fprintf(pf,"\nvar_y_panel     %d",panel_base);
    fprintf(pf,"\nvar_panel_on    %d",panel_on  );
    fprintf(pf,"\nvar_zoom_moins  %d",zoom_moins);
    fprintf(pf,"\nvar_use_mask    %d",use_mask  );
    if(save_view) { if(aff_mode==AFF_MODE_CARTE) val=-1; else val=current_ligne; } else val=start_ligne;
    fprintf(pf,"\nvar_old_draw    %d",old_draw  );
    fprintf(pf,"\nvar_start_ligne %d",val       );
    fprintf(pf,"\nvar_carte_x0    %d",carte_x   );
    fprintf(pf,"\nvar_carte_y0    %d",carte_y   );
    fprintf(pf,"\nvar_carte_zoom  %d",carte_zoom);
  //fprintf(pf,"\nvar_spritefile  \"%s\"",szSpriteFileName);
  //fprintf(pf,"\nvar_start_x0    %d",x0        ); //ne sert plus maintenant car un x0/y0 par ligne
  //fprintf(pf,"\nvar_start_y0    %d",y0        );

    fclose(pf);

//non sauvegardees car plus utiles:
//                if(!stricmp(szVarName,"base_x"    )) base_x=val;
//                if(!stricmp(szVarName,"base_y"    )) base_y=val;
//                if(!stricmp(szVarName,"base_loco" )) base_loco=val;
//                if(!stricmp(szVarName,"base_aig"  )) base_aig=val;
}

void save_seg_aig_geo_bat_txt_link(int aig_actual,int save_view)
{
    FILE* pf;
    int l,i,ptg,ptd,x1,x2,xc,aig_x0,aig_x1,aig_x2,y1,y2,yc,aig_y0,aig_y1,aig_y2,x,y,t,color,e;
    int seg_commun,seg_direct,seg_devie;
    int commun_g_x,commun_g_y,commun_d_x,commun_d_y,direct_g_x,direct_g_y,direct_d_x,direct_d_y,devie_g_x,devie_g_y,devie_d_x,devie_d_y;

    pf=fopen(szInfraFileName,"at"); if(pf==NULL) return;

    ligne[current_ligne][IND_LIGNE_X0]=x0; //mise a jour necessaire car aucune mis a jour vu qu'il n'y a pas eu de changement de ligne
    ligne[current_ligne][IND_LIGNE_Y0]=y0;

    fprintf(pf,"\n\n\n#========================================");
    fprintf(pf,    "\n# 3. Infrastructure ligne par ligne      ");
    fprintf(pf,    "\n#    (seg / aig / geo / bat /txt)        ");
    fprintf(pf,    "\n#========================================");

    stat_seg=0; stat_aig=0; stat_geo=0; stat_bat=0; stat_txt=0;
    for(l=0;l<MAX_LIGNE;l++)
    {
        if(save_view)  fprintf(pf,"\n\nligne %d %d %d \"%s\" \"%s\"",l,ligne[l][IND_LIGNE_X0]     ,ligne[l][IND_LIGNE_Y0]     ,&szcarte_txt[ligne[l][IND_LIGNE_NAME]],&szcarte_txt[ligne[l][IND_LIGNE_IMG ]] );
        else           fprintf(pf,"\n\nligne %d %d %d \"%s\" \"%s\"",l,ligne[l][IND_LIGNE_X0_INIT],ligne[l][IND_LIGNE_Y0_INIT],&szcarte_txt[ligne[l][IND_LIGNE_NAME]],&szcarte_txt[ligne[l][IND_LIGNE_IMG ]] );

        fprintf(pf,"\n\nseg");
        for(i=0;i<seg_free;i++) if(seg[i][IND_SEG_PT_G]!=-1) if(seg[i][IND_SEG_TYPE]!=SEG_TYPE_DELETE)
        {
            ptg=seg[i][IND_SEG_PT_G]; if(pt[ptg][IND_PT_LIGNE]!=l) continue;
            ptd=seg[i][IND_SEG_PT_D];
            x1=pt[ptg][IND_PT_X];
            y1=pt[ptg][IND_PT_Y];
            x2=pt[ptd][IND_PT_X];
            y2=pt[ptd][IND_PT_Y];
            t=seg[i][IND_SEG_TYPE];

            if(x1>x2) {x=x1; x1=x2; x2=x; y=y1; y1=y2; y2=y;}

            fprintf(pf,"\n%-5d %-5d %-5d %-5d  %d #%d",x1,x2,y1,y2,t,i);
            stat_seg++;
        }

        fprintf(pf,"\n\naig");
        for(i=0;i<MAX_AIG;i++) if(aig[l][i][IND_AIG_ETAT]!=-1)
        {
            seg_commun=aig[l][i][IND_AIG_SEG_COMMUN];
            seg_direct=aig[l][i][IND_AIG_SEG_DIRECT];
            seg_devie=aig[l][i][IND_AIG_SEG_DEVIE];
            if(aig_actual==1) e=aig[l][i][IND_AIG_ETAT];       //position actuelle
            if(aig_actual==0) e=aig[l][i][IND_AIG_ETAT_INIT];  //position intitiale

            commun_g_x=pt[seg[seg_commun][IND_SEG_PT_G]][IND_PT_X]; commun_g_y=pt[seg[seg_commun][IND_SEG_PT_G]][IND_PT_Y];
            commun_d_x=pt[seg[seg_commun][IND_SEG_PT_D]][IND_PT_X]; commun_d_y=pt[seg[seg_commun][IND_SEG_PT_D]][IND_PT_Y];
            direct_g_x=pt[seg[seg_direct][IND_SEG_PT_G]][IND_PT_X]; direct_g_y=pt[seg[seg_direct][IND_SEG_PT_G]][IND_PT_Y];
            direct_d_x=pt[seg[seg_direct][IND_SEG_PT_D]][IND_PT_X]; direct_d_y=pt[seg[seg_direct][IND_SEG_PT_D]][IND_PT_Y];
            devie_g_x =pt[seg[seg_devie ][IND_SEG_PT_G]][IND_PT_X]; devie_g_y =pt[seg[seg_devie ][IND_SEG_PT_G]][IND_PT_Y];
            devie_d_x =pt[seg[seg_devie ][IND_SEG_PT_D]][IND_PT_X]; devie_d_y =pt[seg[seg_devie ][IND_SEG_PT_D]][IND_PT_Y];

            if((commun_g_x==direct_g_x && commun_g_y==direct_g_y)||(commun_g_x==direct_d_x && commun_g_y==direct_d_y))
                                             { xc=commun_g_x; yc=commun_g_y; } else { xc=commun_d_x; yc=commun_d_y; }
            if(xc==commun_g_x && yc==commun_g_y) { aig_x0=commun_d_x; aig_y0=commun_d_y; } else { aig_x0=commun_g_x; aig_y0=commun_g_y; }
            if(xc==direct_g_x && yc==direct_g_y) { aig_x1=direct_d_x; aig_y1=direct_d_y; } else { aig_x1=direct_g_x; aig_y1=direct_g_y; }
            if(xc==devie_g_x  && yc==devie_g_y ) { aig_x2=devie_d_x ; aig_y2=devie_d_y ; } else { aig_x2=devie_g_x ; aig_y2=devie_g_y ; }

            fprintf(pf,"\n%5d %5d %5d %5d %5d %5d %5d %5d %5d %5d #%d",i,e,xc,yc,aig_x0,aig_y0,aig_x1,aig_y1,aig_x2,aig_y2,i);
            stat_aig++;
        }

        fprintf(pf,"\n\ngeo");
        for(i=0;i<geo_free;i++) if(geo[i][IND_GEO_forme]!=GEO_DELETE) if(geo[i][IND_GEO_ligne]==l)
        {
            fprintf(pf,"\n%5d %5d %5d %5d  %d %d %d #%d",geo[i][IND_GEO_x1],geo[i][IND_GEO_x2],geo[i][IND_GEO_y1],geo[i][IND_GEO_y2]
                                                        ,geo[i][IND_GEO_forme],geo[i][IND_GEO_color],geo[i][IND_GEO_pos],i);
            stat_geo++;
        }

        fprintf(pf,"\n\nbat");
        for(i=0;i<bat_free;i++) if(bat[i][IND_BAT_DISP]!=-1) if(bat[i][IND_BAT_LIGNE]==l)
        {
            fprintf(pf,"\n%5d %5d %5d %5d    %5d %5d    \"%s\" #%d",bat[i][IND_BAT_SRC_X1],bat[i][IND_BAT_SRC_Y1]
                                                                   ,bat[i][IND_BAT_SRC_X2],bat[i][IND_BAT_SRC_Y2]
                                                                   ,bat[i][IND_BAT_X],bat[i][IND_BAT_Y]
                                                                   ,&szTxtBuffBat[bat[i][IND_BAT_FILENAME]]
                                                                   ,i);
            stat_bat++;
        }

        fprintf(pf,"\n\ntxt");
        for(i=0;i<txt_free;i++) if(txt[i][IND_TXT_pt_texte]!=-1) if(txt[i][IND_TXT_ligne]==l)
        {
            fprintf(pf,"\n%5d %5d \"%s\" \"%s\" #%d",txt[i][IND_TXT_x],txt[i][IND_TXT_y],
                                                     &szcarte_txt[txt[i][IND_TXT_pt_texte]],
                                                     &szcarte_txt[txt[i][IND_TXT_pt_action]],
                                                     i);
            stat_txt++;
        }
    }

    fprintf(pf,"\n\n\n#========================================");
    fprintf(pf,    "\n# 4. Liens entre les lignes (link)       ");
    fprintf(pf,    "\n#========================================");

    fprintf(pf,"\n\nlink"); stat_link=0;
    for(i=0;i<link_free;i++) if(link[i][IND_LINK_PTA]!=-1)
    {
        int pta,ptb;
        pta=link[i][IND_LINK_PTA]; ptb=link[i][IND_LINK_PTB];
        fprintf(pf,"\n%3d %8d %5d   %3d %8d %5d  #%d",pt[pta][IND_PT_LIGNE],pt[pta][IND_PT_X],pt[pta][IND_PT_Y],
                                                      pt[ptb][IND_PT_LIGNE],pt[ptb][IND_PT_X],pt[ptb][IND_PT_Y],
                                                      i);
        stat_link++;
    }

    fclose(pf);
}

void pt_seg_aig_txt_draw(void)
{
    int i,ptg,ptd,xg,yg,xd,yd,aig_no,j,ag,ad,xt,yt,l,k;
    int x0m,x0p,y0m,y0p;
    char szPt[255];

    x0m=x0-1500; x0p=x0+x_res+1500;
    y0m=y0-1000; y0p=y0+y_res+1000;

    SelectObject(hdcMemTemp,bmp_fonte);
    SelectObject(hdcMemTemp,bmp_stylo_rouge);
    //EasyLineTemp(0,0,100,100);

    for(k=0;k<disp_seg_free;k++)
    {
        i=disp_seg[k];
        if(seg[i][IND_SEG_PT_G]==-1) continue;
        if(seg[i][IND_SEG_TYPE]==SEG_TYPE_DELETE) continue;

        ptg=seg[i][IND_SEG_PT_G];    //l=pt[ptg][IND_PT_LIGNE]; if(l!=current_ligne) continue;
        ptd=seg[i][IND_SEG_PT_D];
        xg=pt[ptg][IND_PT_X];
        yg=pt[ptg][IND_PT_Y];
        xd=pt[ptd][IND_PT_X];
        yd=pt[ptd][IND_PT_Y];
        ag=pt[ptg][IND_PT_AIG];
        ad=pt[ptd][IND_PT_AIG];


        //if( (xg>(x0-1500)) && (xg<(x0+2500)) && (yg>(y0-1000)) && (yg<(y0+2000)) )
        if( (xg>x0m) && (xg<x0p) && (yg>y0m) && (yg<y0p) )
        {
            SelectObject(hdcMemTemp,bmp_stylo_rouge);  // couleur par defaut
            SelectObject(hdcMemTemp,bmp_pinceau_rouge);  // couleur par defaut
            Rectangle(hdcMemTemp,xg-x0-2,yg-y0-2,xg-x0+2,yg-y0+2);
            Rectangle(hdcMemTemp,xd-x0-2,yd-y0-2,xd-x0+2,yd-y0+2);

            if(coord_on)
            {
                SetBkMode(hdcMemTemp,TRANSPARENT);
                SetTextColor(hdcMemTemp,RGB(255,0,0));
                //sprintf(szPt,"(%d,%d)",xg,yg); EasyTextOutTemp(xg-x0-20,yg-y0+2,szPt);
                //sprintf(szPt,"(%d,%d)",xd,yd); EasyTextOutTemp(xd-x0-20,yd-y0+2,szPt);
                sprintf(szPt,"%d",xg); EasyTextOutTemp(xg-x0-12,yg-y0+2,szPt);
                sprintf(szPt,"%d",yg); EasyTextOutTemp(xg-x0-12,yg-y0+14,szPt);
                sprintf(szPt,"%d",xd); EasyTextOutTemp(xd-x0-12,yd-y0+2,szPt);
                sprintf(szPt,"%d",yd); EasyTextOutTemp(xd-x0-12,yd-y0+14,szPt);

                SetTextColor(hdcMemTemp,RGB(0,0,255));
                if(ag>=0 && ag<=999) { sprintf(szPt,"aig%d",ag); if(aig[current_ligne][ag][IND_AIG_ETAT]) strcat(szPt,"/"); else strcat(szPt,"-"); EasyTextOutTemp(xg-x0-12,yg-y0-10,szPt); }
                if(ad>=0 && ad<=999) { sprintf(szPt,"aig%d",ad); if(aig[current_ligne][ad][IND_AIG_ETAT]) strcat(szPt,"/"); else strcat(szPt,"-"); EasyTextOutTemp(xd-x0-12,yd-y0-10,szPt); }
                if(ag>=10000 && ag<=10999) { sprintf(szPt,"link%d",ag-10000); EasyTextOutTemp(xg-x0-12,yg-y0-10,szPt); }
                if(ad>=10000 && ad<=10999) { sprintf(szPt,"link%d",ad-10000); EasyTextOutTemp(xd-x0-12,yd-y0-10,szPt); }
            }
            if(ag>=10000 && ag<=10999) { EasyLineTemp(xg-x0-4,yg-y0-4,xg-x0+4,yg-y0); EasyLineTemp(xg-x0-4,yg-y0+4,xg-x0+4,yg-y0); EasyLineTemp(xg-x0-4,yg-y0-4,xg-x0-4,yg-y0+4); }
            if(ad>=10000 && ad<=10999) { EasyLineTemp(xd-x0-4,yd-y0-4,xd-x0+4,yd-y0); EasyLineTemp(xd-x0-4,yd-y0+4,xd-x0+4,yd-y0); EasyLineTemp(xd-x0-4,yd-y0-4,xd-x0-4,yd-y0+4); }

            if(seg[i][IND_SEG_TYPE]==SEG_TYPE_TUNEL)
            {
              //SelectObject(hdcMemTemp,bmp_stylo_gris);
                SelectObject(hdcMemTemp,bmp_stylo_noir);
                SelectObject(hdcMemTemp,bmp_pinceau_noir);  // couleur par defaut
                Rectangle(hdcMemTemp,xg-x0,yg-y0+10,xd-x0,yd-y0-70);
                SelectObject(hdcMemTemp,bmp_stylo_gris);
                EasyLineTemp(xg-x0,yg-y0+10,xg-x0,yg-y0-70);
                EasyLineTemp(xd-x0,yg-y0+10,xd-x0,yg-y0-70);
            }
            if(seg[i][IND_SEG_TYPE]==SEG_TYPE_PONT_METAL_B)
            {
                SelectObject(hdcMemTemp,bmp_stylo_gris);  // couleur par defaut
                SelectObject(hdcMemTemp,bmp_pinceau_gris);  // couleur par defaut
              //Rectangle(hdcMemTemp,xg-x0,yg-y0,xd-x0,yd-y0+20);
                for(j=xg;j<=xd;j=j+25)
                {
                    EasyLineTemp(j-x0,yg-y0+1,j-x0,yd-y0+25);
                    if(j!=xg)
                    {
                        EasyLineTemp(j-x0,yg-y0+1,j-x0-25,yd-y0+25);
                        EasyLineTemp(j-x0,yg-y0+25,j-x0-25,yd-y0+1);
                        EasyLineTemp(j-x0,yg-y0+25,j-x0-25,yd-y0+25);
                    }
                }
            }
            if(seg[i][IND_SEG_TYPE]==SEG_TYPE_PONT_METAL_H)
            {
                SelectObject(hdcMemTemp,bmp_stylo_gris);  // couleur par defaut
                SelectObject(hdcMemTemp,bmp_pinceau_gris);  // couleur par defaut
              //Rectangle(hdcMemTemp,xg-x0,yg-y0,xd-x0,yd-y0+20);
                for(j=xg;j<=xd;j=j+50)
                {
                    EasyLineTemp(j-x0,yg-y0+1,j-x0,yd-y0-50);
                    if(j!=xg)
                    {
                        EasyLineTemp(j-x0,yg-y0+1,j-x0-50,yd-y0-50);
                        EasyLineTemp(j-x0,yg-y0-50,j-x0-50,yd-y0+1);
                        EasyLineTemp(j-x0,yg-y0-50,j-x0-50,yd-y0-50);
                    }
                }
            }
            if(seg[i][IND_SEG_TYPE]==SEG_TYPE_QUAI_H_LARGE)
            {
                SelectObject(hdcMemTemp,bmp_stylo_gris);  // couleur par defaut
                SelectObject(hdcMemTemp,bmp_pinceau_gris);  // couleur par defaut
                Rectangle(hdcMemTemp,xg-x0,yg-y0-2,xd-x0,yd-y0-80);
            }
            if(seg[i][IND_SEG_TYPE]==SEG_TYPE_QUAI_H)
            {
                SelectObject(hdcMemTemp,bmp_stylo_gris);  // couleur par defaut
                SelectObject(hdcMemTemp,bmp_pinceau_gris);  // couleur par defaut
                Rectangle(hdcMemTemp,xg-x0,yg-y0-2,xd-x0,yd-y0-30);
            }
            if(seg[i][IND_SEG_TYPE]==SEG_TYPE_QUAI_B)
            {
                SelectObject(hdcMemTemp,bmp_stylo_gris);  // couleur par defaut
                SelectObject(hdcMemTemp,bmp_pinceau_gris);  // couleur par defaut
                Rectangle(hdcMemTemp,xg-x0,yg-y0+2,xd-x0,yd-y0+30);
            }
            if(seg[i][IND_SEG_TYPE]==SEG_TYPE_TRANSPARENT)
            {
                continue; // no draw
            }
            if(seg[i][IND_SEG_TYPE]==SEG_TYPE_LIAISON)
            {
                continue; // no draw
            }
            //if(seg[i][IND_SEG_TYPE]==SEG_TYPE_NORMAL)

            SelectObject(hdcMemTemp,bmp_stylo_noir);  // couleur par defaut

            if(seg[i][IND_SEG_TYPE]==SEG_TYPE_OLD_NORMAL)
            {
                if(old_draw==OLD_DRAW_NO) continue; //no draw
                if(old_draw==OLD_DRAW_RED) SelectObject(hdcMemTemp,bmp_stylo_rouge);
              //if(old_draw==OLD_DRAW_STD) SelectObject(hdcMemTemp,bmp_stylo_rouge); (deja fait)
            }

            aig_no=pt[ptg][IND_PT_AIG];
            if(aig_no>=0 && aig_no<=999) // couleur differente pour la branche de l'aiguillage non utilisee
            {
                 if(aig[current_ligne][aig_no][IND_AIG_ETAT]==0 && aig[current_ligne][aig_no][IND_AIG_SEG_DEVIE] ==i) SelectObject(hdcMemTemp,bmp_stylo_jaune); //gris
                 if(aig[current_ligne][aig_no][IND_AIG_ETAT]==1 && aig[current_ligne][aig_no][IND_AIG_SEG_DIRECT]==i) SelectObject(hdcMemTemp,bmp_stylo_jaune); //gris
            }
            aig_no=pt[ptd][IND_PT_AIG];
            if(aig_no>=0 && aig_no<=999) // couleur differente pour la branche de l'aiguillage non utilisee
            {
                 if(aig[current_ligne][aig_no][IND_AIG_ETAT]==0 && aig[current_ligne][aig_no][IND_AIG_SEG_DEVIE] ==i) SelectObject(hdcMemTemp,bmp_stylo_jaune); //gris
                 if(aig[current_ligne][aig_no][IND_AIG_ETAT]==1 && aig[current_ligne][aig_no][IND_AIG_SEG_DIRECT]==i) SelectObject(hdcMemTemp,bmp_stylo_jaune); //gris
            }

            if(seg[i][IND_SEG_TYPE]==SEG_TYPE_TUNEL) SelectObject(hdcMemTemp,bmp_stylo_gris);
            EasyLineTemp(xg-x0,yg-y0,xd-x0,yd-y0);
        }
    }

    for(k=0;k<disp_txt_free;k++)
    {
        i=disp_txt[k];
        //if(txt[i][IND_TXT_ligne]!=current_ligne) continue;
         if(txt[i][IND_TXT_pt_texte]==-1) continue;

        xt=txt[i][IND_TXT_x];
        yt=txt[i][IND_TXT_y];

        SelectObject(hdcMemTemp,bmp_stylo_bleu);
        SetBkMode(hdcMemTemp,TRANSPARENT);

        //if( (xt>(x0-1500)) && (xt<(x0+2500)) && (yt>(y0-1000)) && (yt<(y0+2000)) )
        if( (xt>x0m) && (xt<x0p) && (yt>y0m) && (yt<y0p) )
        {
            SetTextColor(hdcMemTemp,RGB(0,0,255));
            EasyTextOutTemp(xt-x0,yt-y0,&szcarte_txt[txt[i][IND_TXT_pt_texte]]);
            if( xt>x0 && xt<(x0+1000) && (yt>y0) && yt<(y0+1000) ) strcpy(szhot_txt,&szcarte_txt[txt[i][IND_TXT_pt_texte]]);

            if(szcarte_txt[txt[i][IND_TXT_pt_action]]!='\0')
            {
                EasyLineTemp(xt-x0-20,yt-y0   ,xt-x0-20,yt-y0+10);
                EasyLineTemp(xt-x0-20,yt-y0   ,xt-x0-10,yt-y0+5);
                EasyLineTemp(xt-x0-20,yt-y0+10,xt-x0-10,yt-y0+5);
            }

        }
    }

}

#define GEO_LINE      1
#define GEO_RECT      2
#define GEO_RECT_FILL 3
void geo_draw(int pos)
{
    int i,x1,x2,y1,y2,color,forme,k;

    for(k=0;k<disp_geo_free;k++)
    {
        i=disp_geo[k];
        //if(geo[i][IND_GEO_ligne]!=current_ligne) continue;
        if(geo[i][IND_GEO_pos]!=pos) continue;

         x1=geo[i][IND_GEO_x1];
         y1=geo[i][IND_GEO_y1];
         x2=geo[i][IND_GEO_x2];
         y2=geo[i][IND_GEO_y2];
         color=geo[i][IND_GEO_color];
         forme=geo[i][IND_GEO_forme];

         if( (x1>(x0-1500)) && (x1<(x0+2500)) && (x2>(x0-1500)) && (x2<(x0+2500)) )
         if( (y1>(y0-1000)) && (y1<(y0+2000)) && (y2>(y0-1000)) && (y2<(y0+2000)) )
         {

             if(forme==GEO_LINE)
             {
                 select_stylo_color(color);
                 EasyLineTemp(x1-x0,y1-y0,x2-x0,y2-y0);
             }

             if(forme==GEO_RECT)
             {
                 select_stylo_color(color);
                 EasyLineTemp(x1-x0,y1-y0,x2-x0,y1-y0);
                 EasyLineTemp(x1-x0,y1-y0,x1-x0,y2-y0);
                 EasyLineTemp(x2-x0,y2-y0,x1-x0,y2-y0);
                 EasyLineTemp(x2-x0,y2-y0,x2-x0,y1-y0);
             }

             if(forme==GEO_RECT_FILL)
             {
                 select_stylo_color(color);
                 select_pinceau_color(color);
                 Rectangle(hdcMemTemp,x1-x0,y1-y0,x2-x0,y2-y0);
             }

         }
    }

}

int find_seg_for_sprite(int pos_ligne,int pos_x, int pos_y)
{
    int seg_no,i,ptg,ptd,xg,yg,xd,yd,yh,yb;

    seg_no=-1;

    // recherche des segments horizontaux (en priorite)
    for(i=0;i<seg_free;i++)
    {
        ptg=seg[i][IND_SEG_PT_G]; xg=pt[ptg][IND_PT_X]; yg=pt[ptg][IND_PT_Y]; if(pt[ptg][IND_PT_LIGNE]!=pos_ligne) continue;
        ptd=seg[i][IND_SEG_PT_D]; xd=pt[ptd][IND_PT_X]; yd=pt[ptd][IND_PT_Y];
        if(seg[i][IND_SEG_TYPE]!=SEG_TYPE_LIAISON)
        if(yg==yd) if(pos_x>=xg && pos_x<=xd) if(pos_y>(yg-2) && pos_y<(yg+2)) {seg_no=i; break; }
    }

    // recherche des segments penches
    if(seg_no==-1)
    for(i=0;i<seg_free;i++)
    {
        ptg=seg[i][IND_SEG_PT_G]; xg=pt[ptg][IND_PT_X]; yg=pt[ptg][IND_PT_Y]; if(pt[ptg][IND_PT_LIGNE]!=pos_ligne) continue;
        ptd=seg[i][IND_SEG_PT_D]; xd=pt[ptd][IND_PT_X]; yd=pt[ptd][IND_PT_Y];
        if(yg>=yd) { yh=yg; yb=yd; } else { yh=yd; yb=yg; }
        if(seg[i][IND_SEG_TYPE]!=SEG_TYPE_LIAISON)
        if(pos_x>=xg && pos_x<=xd) if(pos_y>(yb-2) && pos_y<(yh+2)) {seg_no=i; break; }
    }

    // recherche des segments penches (ou horizontux, mais un peu plus loin)
    if(seg_no==-1)
    for(i=0;i<seg_free;i++)
    {
        ptg=seg[i][IND_SEG_PT_G]; xg=pt[ptg][IND_PT_X]; yg=pt[ptg][IND_PT_Y]; if(pt[ptg][IND_PT_LIGNE]!=pos_ligne) continue;
        ptd=seg[i][IND_SEG_PT_D]; xd=pt[ptd][IND_PT_X]; yd=pt[ptd][IND_PT_Y];
        if(yg>=yd) { yh=yg; yb=yd; } else { yh=yd; yb=yg; }
        if(seg[i][IND_SEG_TYPE]!=SEG_TYPE_LIAISON)
        if(pos_x>=xg && pos_x<=xd) if(pos_y>(yb-5) && pos_y<(yh+5)) {seg_no=i; break; }
    }

    return seg_no;
}


//-----------------------------------------------------------------
// GESTION DES SPRITES
//-----------------------------------------------------------------

//#define MAX_SPRITE 10000 // definit au debut maintenant
int sprite[MAX_SPRITE][30];
#define IND_SPRITE_SRC_X1        0  //gauche ds fichier
#define IND_SPRITE_SRC_X2        1  //bas ds fichier
#define IND_SPRITE_SRC_Y1        2  //droite ds fichier
#define IND_SPRITE_SRC_Y2        3  //haut ds fichier
#define IND_SPRITE_X             4  //bas centre sur ecran
#define IND_SPRITE_Y             5  //bas centre sur ecran
#define IND_SPRITE_SEG           6  //segment sur ecran //-2 for delete
#define IND_SPRITE_MOT           7  //loco actuellement moteur
#define IND_SPRITE_PRE_X         8  //
#define IND_SPRITE_PRE_Y         9  //
#define IND_SPRITE_PRE_SEG       10 //
#define IND_SPRITE_LOCO          11 //numero de loco
#define IND_SPRITE_INV           12 //inversion de deplacementnumero de loco
#define IND_SPRITE_PRE_INV       13 //
#define IND_SPRITE_INV_TYPE      14 //type d'inversion (0=pas, 1=inversion, 2=inversion_egale_sprite_suivant 3=sprite_inutilise_qui_sert_juste_a_l'inversion)
#define IND_SPRITE_ON            15 //
#define IND_SPRITE_INV_AFF       16 //
#define IND_SPRITE_PRE_INV_AFF   17 //
#define IND_SPRITE_CONTAINER_X   18 //par rapport au sprite porteur
#define IND_SPRITE_CONTAINER_Y   19 //
#define IND_SPRITE_CONTAINER_INV 20 //etat d'inversion d'affichage du sprite porteur pour x,y dessus (sinon inverser x)
#define IND_SPRITE_CONTAINER_INV_AFF 21 //onversion d'affichage du container par rapport au porteur
#define IND_SPRITE_INV_INIT      22 //initialisation d'inversion
#define IND_SPRITE_INV_AFF_INIT  23 //initialisation d'inversion
#define IND_SPRITE_X_INIT        24 //initialisation d'inversion
#define IND_SPRITE_Y_INIT        25 //initialisation d'inversion
#define IND_SPRITE_MOT_INIT      26 //initialisation d'inversion
#define IND_SPRITE_LIGNE_INIT    27 //initialisation d'inversion
#define IND_SPRITE_FILENAME      28 //index sur fichier contenant le sprite
#define IND_SPRITE_IMG           29 //index sur l'image

int sprite_order[MAX_SPRITE+MAX_BAT];
int sprite_free=0;
int sprite_sel=-1;
int sprite_acrochage=-1;
int cam_sprite=-1;
int x_sprite_cam=0;
int x_sprite_cam_old=0;
int y_sprite_cam=0;
int y_sprite_cam_old=0;
int l_sprite_cam=0;
int l_sprite_cam_old=0;
int en_y_cam=1;

//#define MAX_MOT 1000  // definit au debut maintenant
int mot[MAX_MOT][10];
#define IND_MOT_VIT 0
#define IND_MOT_PB  1
int script_loco_mode_auto[SCRIPT_LOCO_NB];

void sprite_init_one(int num,int x1,int y1,int x2, int y2, int ligne, int x, int y, int seg, int loc, int mot, int inv_type, int inv_aff_init,int inv_init,char* szFilename)
{

    sprite[num][IND_SPRITE_SRC_X1]=x1;
    sprite[num][IND_SPRITE_SRC_X2]=x2;
    sprite[num][IND_SPRITE_SRC_Y1]=y1+1; //amelioration
    sprite[num][IND_SPRITE_SRC_Y2]=y2+1; //amelioration
    sprite[num][IND_SPRITE_X]=x; sprite[num][IND_SPRITE_X_INIT]=x;
    sprite[num][IND_SPRITE_Y]=y; sprite[num][IND_SPRITE_Y_INIT]=y;
    sprite[num][IND_SPRITE_LIGNE_INIT]=ligne;
    sprite[num][IND_SPRITE_SEG]=seg;
    sprite[num][IND_SPRITE_LOCO]=loc;
    sprite[num][IND_SPRITE_MOT]=mot; sprite[num][IND_SPRITE_MOT_INIT]=mot;
    sprite[num][IND_SPRITE_INV]=inv_init; sprite[num][IND_SPRITE_INV_INIT]=inv_init;
    sprite[num][IND_SPRITE_INV_TYPE]=inv_type&3;
    sprite[num][IND_SPRITE_ON]=1; if(inv_type==3 || inv_type==-1) sprite[num][IND_SPRITE_ON]=0;
    sprite[num][IND_SPRITE_INV_AFF]=inv_aff_init; sprite[num][IND_SPRITE_INV_AFF_INIT]=inv_aff_init;

    int ind,i;
    char sz[1000],sz2[1000];

    ind=txtBuff_Find(szFilename);

    if(ind==-1)//nouvelle image
    {
        ind=txtBuff_Add(szFilename);
        sprite[num][IND_SPRITE_FILENAME]=ind;

        sprintf(sz,"%s%s%s",szBasePstDir,"tr\\",szFilename);
        img_tr[img_tr_free].load(sz,1,1);
        sprite[num][IND_SPRITE_IMG]=img_tr_free;
        img_tr_free++;
    }
    else //un autre sprite utilise la meme image, recherche de ce sprite et recuperation du pointeur image
    {
        sprite[num][IND_SPRITE_FILENAME]=ind;
        for(i=0;i<sprite_free;i++)
            //if(sprite[i][IND_SPRITE_ON]==1 || sprite[i][IND_SPRITE_INV_TYPE]==3)  //commenter SPRITE_ON car peut etre image d'un sprite supprimer
                if(sprite[i][IND_SPRITE_FILENAME]==ind)                               //si decommenter, trouvera nom ds la base dans etape precedente mais pas d'image ici d'ou image 0
                    { sprite[num][IND_SPRITE_IMG]=sprite[i][IND_SPRITE_IMG]; break; } //break tres important sinon on tombera sur lui meme si on teste pas ON car initialise avec l'index
    }

    //sprintf(sz2,"num=%d filename=%s sz=%s ind=%d file[index]=%s img=%d",num,szFilename,sz,sprite[num][IND_SPRITE_FILENAME],&szTxtBuff[ind],sprite[num][IND_SPRITE_IMG]);
    //MessageBox(NULL,sz2,"debug",MB_OK);
}

int sprite_get_ligne(int spr)
{
    int seg_no,ptg;

    seg_no=sprite[spr][IND_SPRITE_SEG];
        if(seg_no==-2) return current_ligne; //pour visible durant pose
        if(seg_no==-1) return -1; //segment du sprite
    ptg=seg[seg_no][IND_SEG_PT_G];
        if(ptg==-1) return -1; //un des popint du segment
    return pt[ptg][IND_PT_LIGNE]; //ligne du point
}

int sprite_get_ligne_pr_save(int i)
{
    int l;

    l=sprite_get_ligne(i);
    if(l==-1) l=sprite[i][IND_SPRITE_LIGNE_INIT];

    return l;
}

#define MAX_DISP_SPRITE 1000
int disp_sprite[MAX_DISP_SPRITE];
int disp_sprite_free=0;

// remplissage du tableau d'affichage des sprites
// (automatique) si changement de ligne ou depassement du secteur x,y
// force avec parametre a 1 si demande de remplissage suite a l'ajout/delete d'un sprite
void disp_sprite_fill(int force)
{
    static int lold=-1,xold,yold;
    int i,ptg,disp,x,y;

    disp=0;
    if(lold!=current_ligne) {lold=current_ligne; disp=1; xold=x0; yold=y0; }
    if( abs(xold-x0)>DISP_LEN || abs(yold-y0)>DISP_LEN) {disp=1; xold=x0; yold=y0; }
    if(force) disp=1;
    if(disp==0) return;

    disp_sprite_free=0;
    for(i=0;i<sprite_free;i++)
    {
        if(sprite_get_ligne(i)!=current_ligne) continue;
        if(sprite[i][IND_SPRITE_ON]==0) continue;

        x=sprite[i][IND_SPRITE_X]; y=pt[i][IND_SPRITE_Y];
        if(x>(xold-DISP_LEN-2000) && x<(xold+DISP_LEN+2000) && y>(yold-DISP_LEN-2000) && y<(yold+DISP_LEN+2000))
        {
            disp_sprite[disp_sprite_free++]=i;
            if(disp_sprite_free==MAX_DISP_SPRITE) break;
        }
    }
}


int sprite_del=-1;

int aff_sprite_sel(void)
{
    int i,x,y,dx,dy,k;

    sprite_del=-1;
    //if(sprite_free!=0) for(i=sprite_free-1;i>=0;i--) if(sprite_get_ligne(i)==current_ligne) if(sprite[i][IND_SPRITE_ON])   //a l'envers pour prendre le premier affiche
    if(disp_sprite_free!=0) for(k=disp_sprite_free-1;k>=0;k--)
    {
        i=disp_sprite[k];
        if(sprite[i][IND_SPRITE_ON]==0) continue;

        x=sprite[i][IND_SPRITE_X]-x0;
        y=sprite[i][IND_SPRITE_Y]-y0;
        dx=sprite[i][IND_SPRITE_SRC_X2]-sprite[i][IND_SPRITE_SRC_X1]; if(dx<0) dx=0-dx;
        dy=sprite[i][IND_SPRITE_SRC_Y2]-sprite[i][IND_SPRITE_SRC_Y1]; if(dy<0) dy=0-dy;

        if( x_mouse_move>(x-(dx/2)) && x_mouse_move<(x+(dx/2)) && y_mouse_move>(y-dy) && y_mouse_move<y )
        {
            sprite_del=i;
            sprintf(szDisp,"SPRITE: num=%d x=%d y=%d loc=%d loc_mot=%d auto=%d inv=%d inv_aff=%d",i,x,y,sprite[i][IND_SPRITE_LOCO],sprite[i][IND_SPRITE_MOT],script_loco_mode_auto[i],sprite[i][IND_SPRITE_INV],sprite[i][IND_SPRITE_INV_AFF]);
            EasyTextOutTemp(410,panel_base+60,szDisp);
            return 1;
        }
    }
    return 0;
}

int delete_sprite(int sprite_del)
{
    if(sprite_del==-1) return 0;

    //deleter le sprite
    sprite[sprite_del][IND_SPRITE_ON]=0;    //disable display
    sprite[sprite_del][IND_SPRITE_SEG]=-2;  //destruct the sprite at the end

    //si sprite suivant, sprite d'inversion, le deleter aussi
    if((sprite_del+1)<sprite_free) if(sprite[sprite_del+1][IND_SPRITE_INV_TYPE]==3)
    {
        sprite[sprite_del+1][IND_SPRITE_ON]=0;    //disable display mais deja a 0 normalement
        sprite[sprite_del+1][IND_SPRITE_SEG]=-2;  //destruct the sprite at the end
    }

    return 1;
}

void sprite_init(void)
{
    int i,xd;

    for(i=0;i<MAX_SPRITE;i++) sprite[i][IND_SPRITE_ON]=0;
    for(i=0;i<MAX_SPRITE;i++) sprite[i][IND_SPRITE_INV]=0;
    for(i=0;i<MAX_MOT;i++) mot[i][IND_MOT_VIT]=0;
}

void save_sprite(int actual) //0=position initiale 1=position actuelle
{
    FILE* pf;
    int i;
    pf=fopen(szInfraFileName,"at"); if(pf==NULL) return;

    fprintf(pf,"\n\n\n#========================================");
    fprintf(pf,    "\n# 5. Trains (tr)                         ");
    fprintf(pf,    "\n#========================================");

    fprintf(pf,"\n\ntr"); stat_tr=0;
    if(actual==0) fprintf(pf," #initial position"); else fprintf(pf," #last position");
    for(i=0;i<sprite_free;i++) if(sprite[i][IND_SPRITE_ON]==1 || sprite[i][IND_SPRITE_INV_TYPE]==3)
    {
        fprintf(pf,"\n");
        //if(config_version<3)
        //{
        //    fprintf(pf,"%4d %4d %4d %4d    ",
        //    sprite[i][IND_SPRITE_SRC_X1],sprite[i][IND_SPRITE_SRC_Y1]-1,  /*car on a fait +a au chargement*/
        //    sprite[i][IND_SPRITE_SRC_X2],sprite[i][IND_SPRITE_SRC_Y2]-1);
        //}
        if(actual==1)
        fprintf(pf,"%3d %8d %5d    %3d %3d    %d %d %d   \"%s\"  #%d",
            sprite_get_ligne_pr_save(i),sprite[i][IND_SPRITE_X],sprite[i][IND_SPRITE_Y],
            sprite[i][IND_SPRITE_LOCO],sprite[i][IND_SPRITE_MOT],
            sprite[i][IND_SPRITE_INV_TYPE],sprite[i][IND_SPRITE_INV_AFF],sprite[i][IND_SPRITE_INV],
            &szTxtBuff[sprite[i][IND_SPRITE_FILENAME]], i);

        if(actual==0)
        fprintf(pf,"%3d %8d %5d    %3d %3d    %d %d %d   \"%s\"  #%d",
            sprite[i][IND_SPRITE_LIGNE_INIT],sprite[i][IND_SPRITE_X_INIT],sprite[i][IND_SPRITE_Y_INIT],
            sprite[i][IND_SPRITE_LOCO],sprite[i][IND_SPRITE_MOT_INIT],
            sprite[i][IND_SPRITE_INV_TYPE],sprite[i][IND_SPRITE_INV_AFF_INIT],sprite[i][IND_SPRITE_INV_INIT],
            &szTxtBuff[sprite[i][IND_SPRITE_FILENAME]],i);

        stat_tr++;
    }

    fclose(pf);
}

void save_stat(void)
{
    FILE* pf;
    int i;
    pf=fopen(szInfraFileName,"at"); if(pf==NULL) return;

    fprintf(pf,"\n\n\n#========================================");
    fprintf(pf,    "\n# 6. Statisitcs                          ");
    fprintf(pf,    "\n#========================================");

    fprintf(pf,"\n\n#Carte");
    fprintf(pf,"\n# pt2  = %d / %d",stat_carte2_pt,CARTE2_NB_PT);
  //fprintf(pf,"\n# pt   = %d / %d",stat_pt,CARTE_NB_PT);
  //fprintf(pf,"\n# line = %d / %d",stat_line,CARTE_NB_SEG);
    fprintf(pf,"\n# txt_len = %d / %d",carte_txt_free,CARTE_LEN_TXT);

    fprintf(pf,"\n\n#Infra");
    fprintf(pf,"\n# seg  = %d / %d",stat_seg,MAX_SEG);
    fprintf(pf,"\n# aig  = %d / (500 par ligne)",stat_aig);
    fprintf(pf,"\n# geo  = %d / %d",stat_geo,MAX_GEO);
    fprintf(pf,"\n# bat  = %d / %d",stat_bat,MAX_BAT);
    fprintf(pf,"\n# txt  = %d / %d (stockage ds txt_len)",stat_txt,MAX_TXT);

    fprintf(pf,"\n\n#Trains (locomotives et wagons)");
    fprintf(pf,"\n# tr  = %d / %d",stat_tr,MAX_SPRITE);

    fclose(pf);
}


//-----------------------------------------------------------------
// DESSIN DES SPRITES
//-----------------------------------------------------------------

void sprite_compute_order(void)
{
    int i,ok,spriteh,spriteb,nb,x,y,yh,yb,k;

    // reperage des sprites visibles (les bat ont en indice +10000)
    nb=0;
    //for(i=0;i<sprite_free;i++)
    //{
    //    if(sprite_get_ligne(i)!=current_ligne) continue;
    for(k=0;k<disp_sprite_free;k++)
    {
        i=disp_sprite[k];

        x=sprite[i][IND_SPRITE_X];
        y=sprite[i][IND_SPRITE_Y];
        //if(x>(x0-1000) && x<(x0+2000) && y>(y0-1000) && y<(y0+2000))
        if(x>(x0-300) && x<(x0+1500) && y>(y0-300) && y<(y0+1300))
        sprite_order[nb++]=i;
    }
    //for(i=0;i<bat_free;i++) if(bat[i][IND_BAT_LIGNE]==current_ligne)
    for(k=0;k<disp_bat_free;k++)
    {
        i=disp_bat[k];

        x=bat[i][IND_BAT_X];
        y=bat[i][IND_BAT_Y];
        //if(x>(x0-1000) && x<(x0+2000) && y>(y0-1000) && y<(y0+2000))
        if(x>(x0-300) && x<(x0+1500) && y>(y0-300) && y<(y0+1300))
        sprite_order[nb++]=10000+i;
    }
    sprite_order[nb]=-1;
    sprite_order[nb+1]=-1;

    // classement par y (du plus grand au plus petit)
    do
    {
        ok=1;
        for(i=0;i<nb;i++)
        {
            spriteh=sprite_order[i];
            spriteb=sprite_order[i+1];
            if(spriteh==-1 || spriteb==-1) break;
            if(spriteh<10000) yh=sprite[spriteh][IND_SPRITE_Y]; else yh=bat[spriteh-10000][IND_BAT_Y];
            if(spriteb<10000) yb=sprite[spriteb][IND_SPRITE_Y]; else yb=bat[spriteb-10000][IND_BAT_Y];

            if(yb<yh)
            {
                sprite_order[i]=spriteb;
                sprite_order[i+1]=spriteh;
                ok=0;
            }
        }
    }
    while(ok==0);
}

int bat_all_disp_off=0;
void sprite_draw(void)
{
    int i,j,x,y,inv;
    int xa,ya,dxa,dya,xb,yb;
    int xa_1,ya_1,dxa_1,dya_1,xb_1,yb_1;
    int x1,y1,x2,y2;

    sprite_compute_order();

    j=0;
    while(sprite_order[j]!=-1)
    {
        i=sprite_order[j];
        j++;
        if(i<10000) if(sprite[i][IND_SPRITE_ON])
        {
             x=sprite[i][IND_SPRITE_X];
             y=sprite[i][IND_SPRITE_Y];
             xa=x-x0;
             ya=y-y0;
             if(sprite[i][IND_SPRITE_INV_AFF]==0 || sprite[i][IND_SPRITE_INV_TYPE]==0) inv=0; // aucune inversion
             else if(sprite[i][IND_SPRITE_INV_TYPE]==1) inv=1; // inversion
             else inv=0; // sprite suivant (non gere)
             img_tr[sprite[i][IND_SPRITE_IMG]].draw_centerlow(xa,ya,inv);
        }
        if(i>=10000)
        {
             i=i-10000;
             x=bat[i][IND_BAT_X];
             y=bat[i][IND_BAT_Y];

             if(bat[i][IND_BAT_DISP]==1 && bat_all_disp_off==0)
             {
                 xa=x-x0;
                 ya=y-y0;
                 x1=bat[i][IND_BAT_SRC_X1]; y1=bat[i][IND_BAT_SRC_Y1];
                 x2=bat[i][IND_BAT_SRC_X2]; y2=bat[i][IND_BAT_SRC_Y2];
                 img_bat[bat[i][IND_BAT_IMG]].drawsub_centerlow(xa, ya, 0, x1, y1, x2, y2);
             }

             if(bat[i][IND_BAT_DISP]==0 || bat_all_disp_off==1)
             {
                SelectObject(hdcMemTemp,bmp_stylo_rouge);
                xa=x-x0-(bat[i][IND_BAT_SRC_X2]-bat[i][IND_BAT_SRC_X1])/2;
                xb=x-x0+(bat[i][IND_BAT_SRC_X2]-bat[i][IND_BAT_SRC_X1])/2;
                ya=y-y0-(bat[i][IND_BAT_SRC_Y2]-bat[i][IND_BAT_SRC_Y1]);
                yb=y-y0;
                EasyLineTemp(xa,ya,xb,ya);
                EasyLineTemp(xa,yb,xb,yb);
                EasyLineTemp(xa,ya,xa,yb);
                EasyLineTemp(xb,ya,xb,yb);
             }

         }
    }
}


void sprite_fill_inv_one(int i)
{
    int x1,x2,x,y1,y2,y;
    long c;

    if(sprite[i][IND_SPRITE_ON])
    {
        x1=sprite[i][IND_SPRITE_SRC_X1];  y1=sprite[i][IND_SPRITE_SRC_Y1];
        x2=sprite[i][IND_SPRITE_SRC_X2];  y2=sprite[i][IND_SPRITE_SRC_Y2];

        if(x1>x2) { x=x1; x1=x2; x2=x; } //{ x1^=x2; x2^=x1; x1^=x2; } //echange x1 et x2 sans seconde variable !
        if(y1>y2) { y=y1; y1=y2; y2=y; } //{ y1^=y2; y2^=y1; y1^=y2; } //echange x1 et x2 sans seconde variable !

        for(x=x1;x<=x2;x++) for(y=y1;y<=y2;y++)
        {
            c=GetPixel(hdcMem,x-1,y);
            //SetPixel(hdcMemInv,x1+x2-x,y,c); //c=r+256*v+256*256*b;
            //SetPixel(hdcMemInv,x1+x2-x-1,y,c); //-1 pour mieux afficher   //UU:verif !
            SetPixel(hdcMemInv,x1+x2-x,y,c); //-1 en get pour mieux afficher   //UU:verif !
            if(use_mask) // creation du mask associe
            {
                if(c==RGB(0,0,0)) SetPixel(hdcMemInvMask,x1+x2-x,y,RGB(255,255,255));
                else              SetPixel(hdcMemInvMask,x1+x2-x,y,0);
            }

        }
    }

}

void sprite_fill_inv(void)
{
    int i;

    for(i=0;i<sprite_free;i++) sprite_fill_inv_one(i);
}


//-----------------------------------------------------------------
// REACTION AUX ACTIONS DE LA SOURIS
//-----------------------------------------------------------------

BOOL sprite_click_select(int click_x,int click_y)
{
    int i,x,y,dx,dy;

    sprite_acrochage=-1;
  //for(i=0;i<sprite_free;i++) if(sprite[i][IND_SPRITE_ON])
    if(sprite_free!=0) for(i=sprite_free-1;i>=0;i--) if(sprite[i][IND_SPRITE_ON])   //a l'envers pour prendre le premier affiche
    {
        x=sprite[i][IND_SPRITE_X]-x0;
        y=sprite[i][IND_SPRITE_Y]-y0;
        dx=sprite[i][IND_SPRITE_SRC_X2]-sprite[i][IND_SPRITE_SRC_X1]; if(dx<0) dx=0-dx;
        dy=sprite[i][IND_SPRITE_SRC_Y2]-sprite[i][IND_SPRITE_SRC_Y1]; if(dy<0) dy=0-dy;

        if( click_x>(x-(dx/2)) && click_x<(x+(dx/2)) && click_y>(y-dy) && click_y<y )
        {
            sprite_sel=i;
            sprite_acrochage=i;
            sprintf(szDebug,"sprite=%d",sprite_sel); //MessageBox(NULL,szDebug,"Debug",MB_OK);
            return 1;
        }
    }
    return 0;
}

int get_spriteid_for_loco(int loc)
{
    int i;

    if(loc>=0)
        for(i=0;i<sprite_free;i++)
            if(sprite[i][IND_SPRITE_ON])
                if(sprite[i][IND_SPRITE_LOCO]==loc)
                    return i;
    return -1;
}

void inv_sprite(int sprite_id)
{
    int loc,i;

    // premiere implementation mais non suffisante
    //sprite[sprite_sel][IND_SPRITE_INV]^=1;
    //sprite[sprite_sel][IND_SPRITE_INV_AFF]^=1;
    //if(sprite_id<0) return;

    //si locomotive active, inverser sens et affichage locomotive, mais egalement sens du reste de la rame
    loc=sprite[sprite_id][IND_SPRITE_LOCO];
    if(loc>=0) if(loc==sprite[sprite_id][IND_SPRITE_MOT])
    {
        for(i=0;i<sprite_free;i++) if(sprite[i][IND_SPRITE_ON]) if(loc==sprite[i][IND_SPRITE_MOT])
        {
            sprite[i][IND_SPRITE_INV]^=1;
        }
      //sprite[sprite_id][IND_SPRITE_INV]^=1;  (deja fait pendant le for)
        sprite[sprite_id][IND_SPRITE_INV_AFF]^=1;
    }

    //si pas locomotive en activite ou wagon alors inverser juste l'affichage
    if(loc!=sprite[sprite_id][IND_SPRITE_MOT])
    {
        sprite[sprite_id][IND_SPRITE_INV_AFF]^=1;
    }
}

void inv_current_sprite(void)
{
    return inv_sprite(sprite_sel);
}

void accr_sprite(int spriteid, int mot)
{
    int spriteid_loco;

    if(spriteid==-1) return;
    if(mot==-1) return;

    spriteid_loco=get_spriteid_for_loco(mot);
    if(spriteid_loco==-1) return;

    sprite[spriteid][IND_SPRITE_MOT]=mot;
    sprite[spriteid][IND_SPRITE_INV]=sprite[spriteid_loco][IND_SPRITE_INV];
}

void decr_sprite(int sprite_id)
{
    if(sprite_id==-1) return;

    sprite[sprite_id][IND_SPRITE_MOT]=sprite[sprite_id][IND_SPRITE_LOCO]; //vaut -1 si wagon
    sprite[sprite_id][IND_SPRITE_INV]=sprite[sprite_id][IND_SPRITE_INV_AFF];
}

BOOL sprite_click_acrochage_decrochage(int click_x,int click_y)   //fct appellee au click droit uniquement
{
    int i,j,x,y,dx,dy,loc,mot_acroche,inv;

    //for(i=0;i<sprite_free;i++) if(sprite[i][IND_SPRITE_ON])
    if(sprite_free!=0) for(i=sprite_free-1;i>=0;i--) if(sprite[i][IND_SPRITE_ON]) //a l'envers pour prendre le premier affiche
    {
        x=sprite[i][IND_SPRITE_X]-x0;
        y=sprite[i][IND_SPRITE_Y]-y0;
        dx=sprite[i][IND_SPRITE_SRC_X2]-sprite[i][IND_SPRITE_SRC_X1]; if(dx<0) dx=0-dx;
        dy=sprite[i][IND_SPRITE_SRC_Y2]-sprite[i][IND_SPRITE_SRC_Y1]; if(dy<0) dy=0-dy;

        if( click_x>(x-(dx/2)) && click_x<(x+(dx/2)) && click_y>(y-dy) && click_y<y )
        {
            //if(sprite[i][IND_SPRITE_SEG]==-1) return 0; // sprite imobile
            if(sprite[i][IND_SPRITE_LOCO]==-2) return 0; // sprite imobile

            if(sprite_acrochage==-1) //decrochage
            {
                loc=sprite[i][IND_SPRITE_LOCO];
                if(loc>=0) for(j=0;j<sprite_free;j++) if(sprite[j][IND_SPRITE_MOT]==loc) sprite[j][IND_SPRITE_MOT]=-1;
                sprite[i][IND_SPRITE_MOT]=loc; // qui vaut -1 si pas une loco
                if(loc<0) sprite[i][IND_SPRITE_MOT]=-1;
                sprite[i][IND_SPRITE_INV]=sprite[i][IND_SPRITE_INV_AFF];
            }
            else //acrochage
            {
                if(sprite[i][IND_SPRITE_LOCO]==-3)
                {
                    sprite[i][IND_SPRITE_CONTAINER_X]=sprite[i][IND_SPRITE_X]-sprite[sprite_acrochage][IND_SPRITE_X];
                    sprite[i][IND_SPRITE_CONTAINER_Y]=sprite[i][IND_SPRITE_Y]-sprite[sprite_acrochage][IND_SPRITE_Y];
                    sprite[i][IND_SPRITE_CONTAINER_INV]=sprite[sprite_acrochage][IND_SPRITE_INV_AFF];
                    sprite[i][IND_SPRITE_MOT]=sprite_acrochage;

                    inv=0; if(sprite[i][IND_SPRITE_INV_AFF]!=sprite[sprite_acrochage][IND_SPRITE_INV_AFF]) inv=1;
                    sprite[i][IND_SPRITE_CONTAINER_INV_AFF]=inv;

                    return 1;
                }

                else
                {
                    mot_acroche=sprite[i][IND_SPRITE_MOT];
                    if(mot_acroche==-1)
                    {
                        sprite[i][IND_SPRITE_MOT]=sprite[sprite_acrochage][IND_SPRITE_MOT];
                        sprite[i][IND_SPRITE_INV]=sprite[sprite_acrochage][IND_SPRITE_INV];
                    }
                    else
                    {
                        for(j=0;j<sprite_free;j++) if(sprite[j][IND_SPRITE_ON]) if(sprite[j][IND_SPRITE_MOT]==mot_acroche)
                        {
                            sprite[j][IND_SPRITE_MOT]=sprite[sprite_acrochage][IND_SPRITE_MOT];
                            sprite[j][IND_SPRITE_INV]=sprite[sprite_acrochage][IND_SPRITE_INV];
                        }
                    }
                }

            }

            sprite_sel=i;
            sprite_acrochage=i;
            sprintf(szDebug,"sprite=%d",sprite_sel);
            //MessageBox(NULL,szDebug,"Debug",MB_OK);
            return 1;
        }
    }
    return 0;
}

int txt_action(int click_x,int click_y)
{
    int i,xt,yt;

    for(i=0;i<txt_free;i++) if(txt[i][IND_TXT_ligne]==current_ligne)
    {
        xt=txt[i][IND_TXT_x];
        yt=txt[i][IND_TXT_y];

        if( (click_x>(xt-x0-20)) && (click_x<(xt-x0-10)) && (click_y>(yt-y0)) && (click_y<(yt-y0+10)) )
        if(szcarte_txt[txt[i][IND_TXT_pt_action]]!='\0')
            ShellExecute(NULL,"open",&szcarte_txt[txt[i][IND_TXT_pt_action]], NULL, NULL, SW_SHOWNA);
    }
}

int aig_click_change(int click_x,int click_y)
{
    int i,x,y,aig_no,ret,link_no,next_pt;

    ret=0;
    for(i=0;i<pt_free;i++) if(pt[i][IND_PT_LIGNE]==current_ligne) if(pt[i][IND_PT_X]!=-1) if(pt[i][IND_PT_AIG]!=-1)
    {
        x=pt[i][IND_PT_X]-x0;
        y=pt[i][IND_PT_Y]-y0;

        if( click_x>(x-20) && click_x<(x+20) && click_y>(y-20) && click_y<(y+20) )
        {
            aig_no=pt[i][IND_PT_AIG];

            if(aig_no>=0 && aig_no<=999)
            {
                aig[current_ligne][aig_no][IND_AIG_ETAT]^=1;
                sprintf(szDebug,"aig=%d pos=%d",aig_no,aig[current_ligne][aig_no][IND_AIG_ETAT]);
                ret=1;
            }

            if(aig_no>=10000 && aig_no<=10999)
            {
                link_no=aig_no-10000;
                if(i==link[link_no][IND_LINK_PTA]) next_pt=link[link_no][IND_LINK_PTB];
                if(i==link[link_no][IND_LINK_PTB]) next_pt=link[link_no][IND_LINK_PTA];
                if(next_pt!=-1)
                {
                    next_ligne=pt[next_pt][IND_PT_LIGNE];
                    x0=pt[next_pt][IND_PT_X]-400;
                    y0=pt[next_pt][IND_PT_Y]-300;
                }
                ret=1;
            }

        }
    }

    return ret;
}


//-----------------------------------------------------------------
// DEPLACEMENT DES SPRITES
//-----------------------------------------------------------------

void maj_pt_x_y(int seg_no, int* ptg, int* ptd, int* xg, int* yg, int* xd, int* yd)
{
    *ptg=seg[seg_no][IND_SEG_PT_G];
    *ptd=seg[seg_no][IND_SEG_PT_D];
    *xg=pt[*ptg][IND_PT_X];
    *yg=pt[*ptg][IND_PT_Y];
    *xd=pt[*ptd][IND_PT_X];
    *yd=pt[*ptd][IND_PT_Y];
}

#define INC_X if(seg[seg_no][IND_SEG_TYPE]==SEG_TYPE_LIAISON) x=pt[seg[seg_no][IND_SEG_PT_D]][IND_PT_X]; else x++;
#define DEC_X if(seg[seg_no][IND_SEG_TYPE]==SEG_TYPE_LIAISON) x=pt[seg[seg_no][IND_SEG_PT_G]][IND_PT_X]; else x--;

int aig_state(int ligne_no, int aig_no, int sprite_no);
int link_det=0; //detection de lien pour mettre a jour les sprites a afficher

int pre_depl_one_sprite(int sprite_no, int depl)
{
    int i,j;
    int ptg,ptd,xg,yg,xd,yd,x,y,seg_no,aig_no,inv,inv_aff,ligne_no,sega,segb;
    int ok,loop;
    int nb,sens,find;
    int link_no,pta,ptb,ptsrc,ptdst;

    x=sprite[sprite_no][IND_SPRITE_X];
    y=sprite[sprite_no][IND_SPRITE_Y];
    seg_no=sprite[sprite_no][IND_SPRITE_SEG];
    ok=0,loop=0;
    inv=sprite[sprite_no][IND_SPRITE_INV];
    inv_aff=sprite[sprite_no][IND_SPRITE_INV_AFF];

    // calcul du nouveau segment et du nouveau x

    nb=depl; if(nb<0) nb=0-nb;
    for(i=0;i<nb;i++)
    {
        maj_pt_x_y(seg_no,&ptg,&ptd,&xg,&yg,&xd,&yd);

        if(depl>0 && inv==0) sens=1;  //sens 1 -->
        if(depl>0 && inv==1) sens=0;
        if(depl<0 && inv==0) sens=0;
        if(depl<0 && inv==1) sens=1;

        if(sens)
        {
            loop++;
            if(x==xd)
            {
                aig_no=pt[ptd][IND_PT_AIG];
                ligne_no=pt[ptd][IND_PT_LIGNE];
                if(aig_no==-1)
                {
                    find=0;
                    //            for(j=0;j<seg_free;j++) if(seg[j][IND_SEG_TYPE]!=SEG_TYPE_DELETE) if(j!=seg_no) if(seg[j][IND_SEG_PT_G]==ptd) { seg_no=j;                     INC_X /*x++*/; ok++; find=1; break; }
                    //if(find==0) for(j=0;j<seg_free;j++) if(seg[j][IND_SEG_TYPE]!=SEG_TYPE_DELETE) if(j!=seg_no) if(seg[j][IND_SEG_PT_D]==ptd) { seg_no=j; inv^=1; inv_aff^=1; DEC_X /*x--*/; ok++; find=1; break; }
                    sega=pt[ptd][IND_PT_SEG_A]; segb=pt[ptd][IND_PT_SEG_B];
                    if(seg_no==sega && segb!=-1) { seg_no=segb; find=1; } else if(seg_no==segb && sega!=-1) { seg_no=sega; find=1; }
                    if(find)
                    {
                        if(ptd==seg[seg_no][IND_SEG_PT_G]) {                     INC_X /*x++*/; ok++; }
                        else                               { inv^=1; inv_aff^=1; DEC_X /*x--*/; ok++; }
                    }
                }
                else if(aig_no>=0 && aig_no<=999)
                {
                    if(seg_no==aig[ligne_no][aig_no][IND_AIG_SEG_COMMUN])
                    {
                        //if(aig[ligne_no][aig_no][IND_AIG_ETAT]==0)
                        if(aig_state(ligne_no,aig_no,sprite_no)==0) { seg_no=aig[ligne_no][aig_no][IND_AIG_SEG_DIRECT]; INC_X /*x++;*/ ok++; }
                        else                                        { seg_no=aig[ligne_no][aig_no][IND_AIG_SEG_DEVIE];  INC_X /*x++;*/ ok++; }
                    }
                    else { seg_no=aig[ligne_no][aig_no][IND_AIG_SEG_COMMUN]; INC_X /*x++;*/ ok++; }
                }
                else // 10000+link
                {
                    link_no=aig_no-10000; link_det=1;
                    pta=link[link_no][IND_LINK_PTA]; ptb=link[link_no][IND_LINK_PTB];
                    if(pta!=-1 && ptb!=-1)
                    {
                        if(pta==ptd) { ptsrc=pta; ptdst=ptb; } if(ptb==ptd) { ptsrc=ptb; ptdst=pta; } //pts:source ptd:destination
                        find=0; //recherche du segment destination
                                    for(j=0;j<seg_free;j++) if(seg[j][IND_SEG_PT_G]==ptdst) { seg_no=j; x=pt[ptdst][IND_PT_X];                     ok++; find=1; break; }
                        if(find==0) for(j=0;j<seg_free;j++) if(seg[j][IND_SEG_PT_D]==ptdst) { seg_no=j; x=pt[ptdst][IND_PT_X]; inv^=1; inv_aff^=1; ok++; find=1; break; }
                    }
                }
            }
            else { x++; ok++; }
        }

        else
        {
            loop++;
            if(x==xg)
            {
                aig_no=pt[ptg][IND_PT_AIG];
                ligne_no=pt[ptg][IND_PT_LIGNE];
                if(aig_no==-1)
                {
                    find=0;
                    //            for(j=0;j<seg_free;j++) if(seg[j][IND_SEG_TYPE]!=SEG_TYPE_DELETE) if(j!=seg_no) if(seg[j][IND_SEG_PT_D]==ptg) { seg_no=j;                     DEC_X /*x--*/; ok++; find=1; break; }
                    //if(find==0) for(j=0;j<seg_free;j++) if(seg[j][IND_SEG_TYPE]!=SEG_TYPE_DELETE) if(j!=seg_no) if(seg[j][IND_SEG_PT_G]==ptg) { seg_no=j; inv^=1; inv_aff^=1; INC_X /*x++*/; ok++; find=1; break; }
                    sega=pt[ptg][IND_PT_SEG_A]; segb=pt[ptg][IND_PT_SEG_B];
                    if(seg_no==sega && segb!=-1) { seg_no=segb; find=1; } else if(seg_no==segb && sega!=-1) { seg_no=sega; find=1; }
                    if(find)
                    {
                        if(ptg==seg[seg_no][IND_SEG_PT_D]) {                     DEC_X /*x--*/; ok++; }
                        else                               { inv^=1; inv_aff^=1; INC_X /*x++*/; ok++; }
                    }

                }
                else if(aig_no>=0 && aig_no<=999)
                {
                    if(seg_no==aig[ligne_no][aig_no][IND_AIG_SEG_COMMUN])
                    {
                        //if(aig[ligne_no][aig_no][IND_AIG_ETAT]==0)
                        if(aig_state(ligne_no,aig_no,sprite_no)==0) { seg_no=aig[ligne_no][aig_no][IND_AIG_SEG_DIRECT]; DEC_X /*x--*/; ok++; }
                        else                                        { seg_no=aig[ligne_no][aig_no][IND_AIG_SEG_DEVIE];  DEC_X /*x--*/; ok++; }
                    }
                    else { seg_no=aig[ligne_no][aig_no][IND_AIG_SEG_COMMUN]; DEC_X /*x--*/; ok++; }
                }
                else // 10000+link
                {
                    link_no=aig_no-10000; link_det=1;
                    pta=link[link_no][IND_LINK_PTA]; ptb=link[link_no][IND_LINK_PTB];
                    if(pta!=-1 && ptb!=-1)
                    {
                        if(pta==ptg) { ptsrc=pta; ptdst=ptb; } if(ptb==ptg) { ptsrc=ptb; ptdst=pta; } //pts:source ptd:destination
                        find=0; //recherche du segment destination
                                    for(j=0;j<seg_free;j++) if(seg[j][IND_SEG_PT_D]==ptdst) { seg_no=j; x=pt[ptdst][IND_PT_X];                     ok++; find=1; break; }
                        if(find==0) for(j=0;j<seg_free;j++) if(seg[j][IND_SEG_PT_G]==ptdst) { seg_no=j; x=pt[ptdst][IND_PT_X]; inv^=1; inv_aff^=1; ok++; find=1; break; }
                    }
                }
            }
            else { x--; ok++; }
        }
    }

    sprite[sprite_no][IND_SPRITE_PRE_X]=x;
    sprite[sprite_no][IND_SPRITE_PRE_SEG]=seg_no;
    sprite[sprite_no][IND_SPRITE_PRE_INV]=inv;
    sprite[sprite_no][IND_SPRITE_PRE_INV_AFF]=inv_aff;

    // calcul du nouveau y

    maj_pt_x_y(seg_no,&ptg,&ptd,&xg,&yg,&xd,&yd);
    y= yg + ((yd-yg)*(x-xg))/(xd-xg);
    sprite[sprite_no][IND_SPRITE_PRE_Y]=y;
    //char szDebug[100];
    //sprintf(szDebug,"seg=seg_no,%d",y);
    //MessageBox(NULL,szDebug,"Debug",MB_OK);

    if(ok!=0 && ok==loop) return 1;
    return 0;
}

int final_depl_one_sprite(int sprite_no)
{
    sprite[sprite_no][IND_SPRITE_X      ]=sprite[sprite_no][IND_SPRITE_PRE_X];
    sprite[sprite_no][IND_SPRITE_Y      ]=sprite[sprite_no][IND_SPRITE_PRE_Y];
    sprite[sprite_no][IND_SPRITE_SEG    ]=sprite[sprite_no][IND_SPRITE_PRE_SEG];
    sprite[sprite_no][IND_SPRITE_INV    ]=sprite[sprite_no][IND_SPRITE_PRE_INV];
    sprite[sprite_no][IND_SPRITE_INV_AFF]=sprite[sprite_no][IND_SPRITE_PRE_INV_AFF];
}

void sprite_mot_vit(int touche)
{
    int mot_no;

    mot_no=sprite[sprite_sel][IND_SPRITE_MOT];
    if(mot_no==-1) return;
    if(mot_no<SCRIPT_LOCO_NB) if(script_loco_mode_auto[mot_no]) return; //pas d'interaction sur une loco en automatique
    if(touche=='+') mot[mot_no][IND_MOT_VIT]++;
    if(touche=='-') mot[mot_no][IND_MOT_VIT]--;
    if(touche=='*') mot[mot_no][IND_MOT_VIT]=0;
    if(touche=='/') mot[mot_no][IND_MOT_VIT]=0-mot[mot_no][IND_MOT_VIT];
}

void sprite_depl_all(void)
{
    int i,mot_no,ok,inv,vit;

    link_det=0; //detection de lien pour mettre a jour les sprites a afficher

    for(i=0;i<MAX_MOT;i++) mot[i][IND_MOT_PB]=0;

    for(i=0;i<sprite_free;i++) if(sprite[i][IND_SPRITE_ON])
    {
        mot_no=sprite[i][IND_SPRITE_MOT];
        if(mot_no!=-1) if(sprite[i][IND_SPRITE_LOCO]>=-1)
        {
            ok=pre_depl_one_sprite(i,mot[mot_no][IND_MOT_VIT]);
            if(ok==0) mot[mot_no][IND_MOT_PB]=1;
        }
    }

    for(i=0;i<sprite_free;i++) if(sprite[i][IND_SPRITE_ON])
    {
        mot_no=sprite[i][IND_SPRITE_MOT];
        if(mot_no!=-1) if(sprite[i][IND_SPRITE_LOCO]>=-1)
        {
            if(mot[mot_no][IND_MOT_PB]==0) final_depl_one_sprite(i);
        }
    }

    if(cam_sprite!=-1)
    {
         x_sprite_cam=sprite[cam_sprite][IND_SPRITE_X];
         x0+=x_sprite_cam-x_sprite_cam_old;
         x_sprite_cam_old=x_sprite_cam;

         l_sprite_cam=sprite_get_ligne(cam_sprite);
         if(l_sprite_cam!=-1) if(l_sprite_cam!=l_sprite_cam_old) next_ligne=l_sprite_cam;
         l_sprite_cam_old=l_sprite_cam;

        if(en_y_cam)
        {
          y_sprite_cam=sprite[cam_sprite][IND_SPRITE_Y];
          y0+=y_sprite_cam-y_sprite_cam_old;
          y_sprite_cam_old=y_sprite_cam;
        }
    }

    // mise a jour des sprites a afficher si au moins un a (essaye de) change de ligne
    if(link_det) disp_sprite_fill(1);
}

void containers_maj_xy(void)
{
    int i,porteur,inv;

    for(i=0;i<sprite_free;i++) if(sprite[i][IND_SPRITE_ON])
    if(sprite[i][IND_SPRITE_LOCO]==-3) if(sprite[i][IND_SPRITE_MOT]!=-1)
    {
        porteur=sprite[i][IND_SPRITE_MOT];
        if(sprite[i][IND_SPRITE_CONTAINER_INV]==sprite[porteur][IND_SPRITE_INV_AFF]) inv=0; else inv=1;

        sprite[i][IND_SPRITE_Y]=sprite[porteur][IND_SPRITE_Y]+sprite[i][IND_SPRITE_CONTAINER_Y];
        if(inv==0) sprite[i][IND_SPRITE_X]=sprite[porteur][IND_SPRITE_X]+sprite[i][IND_SPRITE_CONTAINER_X];
        if(inv==1) sprite[i][IND_SPRITE_X]=sprite[porteur][IND_SPRITE_X]-sprite[i][IND_SPRITE_CONTAINER_X];

        sprite[i][IND_SPRITE_INV_AFF]=sprite[porteur][IND_SPRITE_INV_AFF]^sprite[i][IND_SPRITE_CONTAINER_INV_AFF];
    }
}


//-----------------------------------------------------------------
// CREATION DE NOUVEAUX ELEMENTS
//-----------------------------------------------------------------

int new_seg_l1=0; int new_seg_l2=0;
int new_seg_x1=0; int new_seg_x2=0;
int new_seg_y1=0; int new_seg_y2=0;

int grip_50(int val)
{
    int val_ret;
    //if(val>=0) return 25*(int)((val+12)/25);       //return 50*(int)((val+25)/50);
    //else       return 0-25*(int)(((0-val)+12)/25); //return 0-50*(int)(((0-val)+25)/50);

    if(val>=0) {     val_ret=25*(val/25); if((val%25)>12) val_ret+=25; }
    else { val=-val; val_ret=25*(val/25); if((val%25)>12) val_ret+=25; val_ret=-val_ret; }

    return val_ret;
}

void new_seg_lxy(int new_seg_l1, int new_seg_x1, int new_seg_y1, int new_seg_l2, int new_seg_x2, int new_seg_y2, int new_seg_t)
{
    int i,pt1,pt2,ptd,ptg;
    char szDebug[1000];

    // creation d'un lien si lignes differentes ou segment de plus de 2000 pixels
    if( (new_seg_l1!=new_seg_l2) ||  ((abs(new_seg_x1-new_seg_x2))>2000) )
    {
        pt1=-1; for(i=0;i<pt_free;i++) if(pt[i][IND_PT_LIGNE]==new_seg_l1) if(pt[i][IND_PT_X]==new_seg_x1 && pt[i][IND_PT_Y]==new_seg_y1) pt1=i;
        pt2=-1; for(i=0;i<pt_free;i++) if(pt[i][IND_PT_LIGNE]==new_seg_l2) if(pt[i][IND_PT_X]==new_seg_x2 && pt[i][IND_PT_Y]==new_seg_y2) pt2=i;
        if(pt1==-1 || pt2==-1)
        {
            sprintf(szDebug,"Impossible de creer le lien car ne trouve pas les 2 points\nl1=%d x1=%d y1=%d l2=%d x2=%d y2=%d",new_seg_l1,new_seg_x1,new_seg_y1,new_seg_l2,new_seg_x2,new_seg_y2);
            MessageBox(NULL,szDebug,"PST - Erreur",MB_OK);
            return;
        }
        link[link_free][IND_LINK_PTA]=pt1;
        link[link_free][IND_LINK_PTB]=pt2;
        pt[pt1][IND_PT_AIG]=10000+link_free;
        pt[pt2][IND_PT_AIG]=10000+link_free;
        link_free++;
        new_seg_l1=new_seg_l2; new_seg_x1=new_seg_x2; new_seg_y1=new_seg_y2;
        return;
    }

    // creation d'un segment
    if(new_seg_x2==new_seg_x1)
    {
        MessageBox(NULL,"Interdiction de creer des segments verticaux","Erreur",MB_OK);
        return;
    }

    pt1=-1;
    for(i=0;i<pt_free;i++) if(pt[i][IND_PT_LIGNE]==current_ligne) if(pt[i][IND_PT_X]==new_seg_x1 && pt[i][IND_PT_Y]==new_seg_y1) pt1=i;
    if(pt1==-1) { pt_init_one(pt_free,current_ligne,new_seg_x1,new_seg_y1,-1); pt1=pt_free; pt_free++; }
    // remplissage du point 2
    pt2=-1;
    for(i=0;i<pt_free;i++) if(pt[i][IND_PT_LIGNE]==current_ligne) if(pt[i][IND_PT_X]==new_seg_x2 && pt[i][IND_PT_Y]==new_seg_y2) pt2=i;
    if(pt2==-1) { pt_init_one(pt_free,current_ligne,new_seg_x2,new_seg_y2,-1); pt2=pt_free; pt_free++; }
    // remplissage du segment
    if(new_seg_x1<new_seg_x2) { ptg=pt1; ptd=pt2; } else { ptg=pt2; ptd=pt1; }
    seg[seg_free][IND_SEG_TYPE]=new_seg_t; // remplissage du type
    seg_init_one(seg_free,ptg,ptd); seg_free++;
}

void new_seg(int next)
{
    if(next==0)
    {
        new_seg_l1=current_ligne;
        new_seg_x1=grip_50(x0+x_mouse_move);
        new_seg_y1=grip_50(y0+y_mouse_move);
        return;
    }

    new_seg_l2=current_ligne;
    new_seg_x2=grip_50(x0+x_mouse_move);
    new_seg_y2=grip_50(y0+y_mouse_move);

    if(new_seg_x2<new_seg_x1) new_seg_lxy(new_seg_l1,new_seg_x1,new_seg_y1,new_seg_l2,new_seg_x2,new_seg_y2,0);
    else                      new_seg_lxy(new_seg_l2,new_seg_x2,new_seg_y2,new_seg_l1,new_seg_x1,new_seg_y1,0);

    new_seg_x1=new_seg_x2;
    new_seg_y1=new_seg_y2;
}
/*
void new_seg(int next)
{
    int t,pt1,pt2,ptd,ptg,i,new_x,new_y;

    if(next==0)
    {
        new_seg_l1=current_ligne;
        new_seg_x1=grip_50(x0+x_mouse_move);
        new_seg_y1=grip_50(y0+y_mouse_move);
        return;
    }
    new_seg_l2=current_ligne;
    new_x=new_seg_x2=grip_50(x0+x_mouse_move);
    new_y=new_seg_y2=grip_50(y0+y_mouse_move);

    // creation d'un lien
    if(new_seg_l1!=new_seg_l2)
    {
        pt1=-1; for(i=0;i<pt_free;i++) if(pt[i][IND_PT_LIGNE]==new_seg_l1) if(pt[i][IND_PT_X]==new_seg_x1 && pt[i][IND_PT_Y]==new_seg_y1) pt1=i;
        pt2=-1; for(i=0;i<pt_free;i++) if(pt[i][IND_PT_LIGNE]==new_seg_l2) if(pt[i][IND_PT_X]==new_seg_x2 && pt[i][IND_PT_Y]==new_seg_y2) pt2=i;
        if(pt1==-1 || pt2==-1)
        {
            MessageBox(NULL,"Impossible de creer le lien car ne trouve pas les 2 points","PST - Erreur",MB_OK);
            return;
        }
        link[link_free][IND_LINK_PTA]=pt1;
        link[link_free][IND_LINK_PTB]=pt2;
        pt[pt1][IND_PT_AIG]=10000+link_free;
        pt[pt2][IND_PT_AIG]=10000+link_free;
        link_free++;
        new_seg_l1=new_seg_l2; new_seg_x1=new_seg_x2; new_seg_y1=new_seg_y2;
        return;
    }

    // creation d'un segment
    if(new_seg_x2==new_seg_x1)
    {
        MessageBox(NULL,"Interdiction de creer des segments verticaux","Erreur",MB_OK);
        return;
    }

    if(new_seg_x2<new_seg_x1) { t=new_seg_x1; new_seg_x1=new_seg_x2; new_seg_x2=t;
                                t=new_seg_y1; new_seg_y1=new_seg_y2; new_seg_y2=t; }
    pt1=-1;
    for(i=0;i<pt_free;i++) if(pt[i][IND_PT_LIGNE]==current_ligne) if(pt[i][IND_PT_X]==new_seg_x1 && pt[i][IND_PT_Y]==new_seg_y1) pt1=i;
    if(pt1==-1) { pt_init_one(pt_free,current_ligne,new_seg_x1,new_seg_y1,-1); pt1=pt_free; pt_free++; }
    // remplissage du point 2
    pt2=-1;
    for(i=0;i<pt_free;i++) if(pt[i][IND_PT_LIGNE]==current_ligne) if(pt[i][IND_PT_X]==new_seg_x2 && pt[i][IND_PT_Y]==new_seg_y2) pt2=i;
    if(pt2==-1) { pt_init_one(pt_free,current_ligne,new_seg_x2,new_seg_y2,-1); pt2=pt_free; pt_free++; }
    // remplissage du segment
    if(new_seg_x1<new_seg_x2) { ptg=pt1; ptd=pt2; } else { ptg=pt2; ptd=pt1; }
    seg[seg_free][IND_SEG_TYPE]=0; // remplissage du type
    seg_init_one(seg_free,ptg,ptd); seg_free++;

    new_seg_x1=new_x;   //=new_seg_x2;
    new_seg_y1=new_y;   //new_seg_y2;
}
*/

int new_aig_coeur_x=0;
int new_aig_coeur_y=0;
int new_aig_commun_x=0;
int new_aig_commun_y=0;
int new_aig_direct_x=0;
int new_aig_direct_y=0;
int new_aig_devie_x=0;
int new_aig_devie_y=0;

void fill_new_aig(int num);

void new_aig(int next)
{
    int i,fa,num_aig;
    char szEdit[1000];
    char* pc;

    if(next==0)
    {
        new_aig_coeur_x=grip_50(x0+x_mouse_move);
        new_aig_coeur_y=grip_50(y0+y_mouse_move);

        fa=-1;
        for(i=0;i<MAX_AIG;i++) if(aig[current_ligne][i][IND_AIG_ETAT]==-1) { fa=i; break; }
        sprintf(szEdit,"numero_aig=%d (0-%d)",fa,MAX_AIG-1);
        set_wid_txt(szEdit);
    }
    if(next==1)
    {
        new_aig_commun_x=grip_50(x0+x_mouse_move);
        new_aig_commun_y=grip_50(y0+y_mouse_move);
    }
    if(next==2)
    {
        new_aig_direct_x=grip_50(x0+x_mouse_move);
        new_aig_direct_y=grip_50(y0+y_mouse_move);
    }
    if(next==3)
    {
        new_aig_devie_x=grip_50(x0+x_mouse_move);
        new_aig_devie_y=grip_50(y0+y_mouse_move);
        fa=-1;
        for(i=0;i<MAX_AIG;i++) if(aig[current_ligne][i][IND_AIG_ETAT]==-1) { fa=i; break; }

        // Reuperation #aig   ( sprintf(szEdit,"numero_aig=%d (0-%d)",MAX_AIG-1,fa) )
        get_wid_txt(szEdit);
        if(pc=strstr(szEdit,"numero_aig=")) { num_aig=atoi(pc+strlen("numero_aig=")); fill_new_aig(num_aig); }
    }
}

void fill_new_aig(int num)
{
    int pt_coeur,pt_commun,pt_direct,pt_devie;
    int seg_commun,seg_direct,seg_devie;
    int i,ptg,ptd,xg,yg,xd,yd;

    if(aig[current_ligne][num][IND_AIG_ETAT]!=-1)
    {
        sprintf(szDebug,"Erreur, le numero de cet aiguillage est deja utilise\nUtilisez en un autre ou detruiser l'aiguillage existant");
        MessageBox(NULL,szDebug,"Error",MB_OK);
        return;
    }

    // recherche des points
    pt_coeur =-1; for(i=0;i<pt_free;i++) if(pt[i][IND_PT_LIGNE]==current_ligne) if(pt[i][IND_PT_X]==new_aig_coeur_x  && pt[i][IND_PT_Y]==new_aig_coeur_y ) pt_coeur=i ;
    pt_commun=-1; for(i=0;i<pt_free;i++) if(pt[i][IND_PT_LIGNE]==current_ligne) if(pt[i][IND_PT_X]==new_aig_commun_x && pt[i][IND_PT_Y]==new_aig_commun_y) pt_commun=i;
    pt_direct=-1; for(i=0;i<pt_free;i++) if(pt[i][IND_PT_LIGNE]==current_ligne) if(pt[i][IND_PT_X]==new_aig_direct_x && pt[i][IND_PT_Y]==new_aig_direct_y) pt_direct=i;
    pt_devie =-1; for(i=0;i<pt_free;i++) if(pt[i][IND_PT_LIGNE]==current_ligne) if(pt[i][IND_PT_X]==new_aig_devie_x  && pt[i][IND_PT_Y]==new_aig_devie_y ) pt_devie=i ;
    if(pt_coeur==-1 || pt_commun==-1 || pt_direct==-1 || pt_devie==-1) //ne devrait pas se produire
    {
        sprintf(szDebug,"Error in infra inexisting point for aig >%d<\npt_coeur=%d\npt_commun=%d\npt_direct=%d\npt_devie=%d",num,pt_coeur,pt_commun,pt_direct,pt_devie);
        MessageBox(NULL,szDebug,"Error",MB_OK);
        return;
    }

    //recherche des segments
    seg_commun=-1;
    seg_direct-1;
    seg_devie=-1;
    for(i=0;i<seg_free;i++)
    {
        ptg=seg[i][IND_SEG_PT_G]; xg=pt[ptg][IND_PT_X]; yg=pt[ptg][IND_PT_Y]; if(pt[ptg][IND_PT_LIGNE]!=current_ligne) continue;
        ptd=seg[i][IND_SEG_PT_D]; xd=pt[ptd][IND_PT_X]; yd=pt[ptd][IND_PT_Y];

        if( xg==new_aig_coeur_x && yg==new_aig_coeur_y && xd==new_aig_commun_x && yd==new_aig_commun_y ) seg_commun=i;
        if( xd==new_aig_coeur_x && yd==new_aig_coeur_y && xg==new_aig_commun_x && yg==new_aig_commun_y ) seg_commun=i;

        if( xg==new_aig_coeur_x && yg==new_aig_coeur_y && xd==new_aig_direct_x && yd==new_aig_direct_y ) seg_direct=i;
        if( xd==new_aig_coeur_x && yd==new_aig_coeur_y && xg==new_aig_direct_x && yg==new_aig_direct_y ) seg_direct=i;

        if( xg==new_aig_coeur_x && yg==new_aig_coeur_y && xd==new_aig_devie_x  && yd==new_aig_devie_y  ) seg_devie=i;
        if( xd==new_aig_coeur_x && yd==new_aig_coeur_y && xg==new_aig_devie_x  && yg==new_aig_devie_y  ) seg_devie=i;
    }
    if(seg_commun==-1 || seg_direct==-1 || seg_devie==-1) //ne devrait pas se produire
    {
        sprintf(szDebug,"Error in infra inexisting seg for aig >%d< seg_commun=%d seg_direct=%d seg_devie=%d",num,seg_commun,seg_direct,seg_devie);
        MessageBox(NULL,szDebug,"Error",MB_OK);
        return;
    }

     //remplissage des informations
     pt[pt_coeur][IND_PT_AIG]=num;
     aig[current_ligne][num][IND_AIG_ETAT]=aig[current_ligne][num][IND_AIG_ETAT_INIT]=0;
     aig[current_ligne][num][IND_AIG_SEG_COMMUN]=seg_commun;
     aig[current_ligne][num][IND_AIG_SEG_DIRECT]=seg_direct;
     aig[current_ligne][num][IND_AIG_SEG_DEVIE]=seg_devie;
}

void new_txt_ex(void)
{
    char szEdit[1000];

    sprintf(szEdit,"texte=\"\" action=\"\"");
    set_wid_txt(szEdit);
}

void new_txt(void)
{
    char szEdit[1000];
    char sz_txt[1000]; char sz_act[1000]; char c; char *pc;
    int i;

    // 1. extraction du texte et de l'action
    get_wid_txt(szEdit);
    if((pc=strstr(szEdit,"texte=\""))==0) { MessageBox(NULL,"Erreur de syntax dans la zone d'edition (trouve pas texte=\"...)","Error",MB_OK); return; }
    pc+=strlen("texte=\"");
    i=0; do { c=*pc; pc++; if(c=='\0') return; if(c!='\"') sz_txt[i++]=c; } while(c!='\"'); sz_txt[i]='\0'; //remplace le \"

    if((pc=strstr(szEdit,"action=\""))==0) { MessageBox(NULL,"Erreur de syntax dans la zone d'edition (trouve pas action=\"...)","Error",MB_OK); return; }
    pc+=strlen("action=\"");
    i=0; do { c=*pc; pc++; if(c=='\0') return; if(c!='\"') sz_act[i++]=c; } while(c!='\"'); sz_act[i]='\0'; //remplace le \"

    // 2.ajout du nouveau texte
    txt[txt_free][IND_TXT_ligne]=current_ligne;
    txt[txt_free][IND_TXT_x]=x0+x_mouse_move;
    txt[txt_free][IND_TXT_y]=y0+y_mouse_move;
    txt[txt_free][IND_TXT_pt_texte ]=carte_txt_free; strcpy(&szcarte_txt[carte_txt_free],sz_txt); carte_txt_free=carte_txt_free+strlen(sz_txt)+1;
    txt[txt_free][IND_TXT_pt_action]=carte_txt_free; strcpy(&szcarte_txt[carte_txt_free],sz_act); carte_txt_free=carte_txt_free+strlen(sz_act)+1;
    txt_free++;
}


int new_geo_x1=0;
int new_geo_y1=0;
int new_geo_x2=0;
int new_geo_y2=0;
//int new_color=2;  //plus haut pour affichage ds draw
void new_geo(int next)
{
    int forme;

    if(next==0)
    {
        new_geo_x1=grip_50(x0+x_mouse_move);
        new_geo_y1=grip_50(y0+y_mouse_move);
        return;
    }
    new_geo_x2=grip_50(x0+x_mouse_move);
    new_geo_y2=grip_50(y0+y_mouse_move);
    forme=next;

    geo[geo_free][IND_GEO_ligne]=current_ligne;
    geo[geo_free][IND_GEO_x1]=new_geo_x1;
    geo[geo_free][IND_GEO_x2]=new_geo_x2;
    geo[geo_free][IND_GEO_y1]=new_geo_y1;
    geo[geo_free][IND_GEO_y2]=new_geo_y2;
    geo[geo_free][IND_GEO_forme]=forme;
    geo[geo_free][IND_GEO_color]=new_color; //color
    geo[geo_free][IND_GEO_pos]=0;   //pos;
    geo_free++;

    new_geo_x1=new_geo_x2;
    new_geo_y1=new_geo_y2;
}

int save_geo(void)
{
    int i;

    for(i=0;i<geo_free;i++)
    fprintf(pf,"\n%d %d %d %d  %d %d %d",geo[i][IND_GEO_x1],geo[i][IND_GEO_x2]
                                        ,geo[i][IND_GEO_y1],geo[i][IND_GEO_y2]
                                        ,geo[i][IND_GEO_forme],geo[i][IND_GEO_color],geo[i][IND_GEO_pos]);
}


//calcul de prochaine loco dispo
int tr_pose_get_next_free_loc(void)
{
    int num_loc,i,ok;

    for(num_loc=0;num_loc<=100;num_loc++)
    {
        ok=1;
        for(i=0;i<sprite_free;i++) if(sprite[i][IND_SPRITE_ON]) if(sprite[i][IND_SPRITE_MOT]==num_loc) ok=0;
        if(ok==1) return num_loc;
    }

    return -1;
}

int extract_xy_from_filename(char* szFilename, int* x, int* y)
{
    char* pc; char ca;
    int pos,ok;
    int xi,yi;

    pc=szFilename;
    pos=0; ok=0;
    while(ca=*pc++)
    {
        if(ca=='_') { pos=1; xi=yi=0; continue; }
        if(pos==1) { if(ca>='0' && ca<='9') xi=10*xi+ca-'0';
                     else if(ca=='x' || ca=='X') { pos=2; continue; }
                     else pos=0; }
        if(pos==2) { if(ca>='0' && ca<='9') { yi=10*yi+ca-'0'; ok=1; } else pos=0; }
    }
    *x=xi; *y=yi;
    return ok;
}


void bat_pose_ajouter(char* szBmpFilename,int tr_pose_x,int tr_pose_y,int partielle,int x1,int y1,int x2,int y2)
{
    int xi,yi;
    char szShort[1000];

    // 1. Extraction du nom relatif du fichier par raport a baseresdir/tr
    strcpy(szShort,&szBmpFilename[strlen(szBasePstDir)+strlen("bat\\")]);

    if(extract_xy_from_filename(szShort,&xi,&yi)==0)
    {
        MessageBox(NULL,"Nom de fichier incorrect (manque la taille _XxY ex: _240x50)","Error",MB_OK);
        return;
    }

    // 2. Initialisation des champs numeriques
    if(partielle==0)
    {
    bat[bat_free][IND_BAT_SRC_X1]=0;
    bat[bat_free][IND_BAT_SRC_Y1]=0;
    bat[bat_free][IND_BAT_SRC_X2]=xi-1;
    bat[bat_free][IND_BAT_SRC_Y2]=yi-1;
    }
    else
    {
    bat[bat_free][IND_BAT_SRC_X1]=x1;
    bat[bat_free][IND_BAT_SRC_Y1]=y1;
    bat[bat_free][IND_BAT_SRC_X2]=x2;
    bat[bat_free][IND_BAT_SRC_Y2]=y2;
    }

    bat[bat_free][IND_BAT_X]=x0+tr_pose_x;
    bat[bat_free][IND_BAT_Y]=y0+tr_pose_y;
    bat[bat_free][IND_BAT_LIGNE]=current_ligne;
    bat[bat_free][IND_BAT_DISP]=1;

    // 3. Association de l'image
    int j,ok,ind;
    char sz[1000];
    int trans;

    init_img_filename_bat(bat_free,szShort);
    ok=0;
    ind=bat[bat_free][IND_BAT_FILENAME];
    for(j=0;j<bat_free;j++) if(bat[j][IND_BAT_DISP]!=-1) if(bat[j][IND_BAT_LIGNE]==current_ligne) if(bat[j][IND_BAT_FILENAME]==ind) //un autre sprite utilise la meme image
    {
        bat[bat_free][IND_BAT_IMG]=bat[j][IND_BAT_IMG];
        ok=1;
        break;
    }
    if(ok==0) //nouvelle image
    {
        trans=1; if(strstr(szBmpFilename,"__")!=NULL) trans=0;

        sprintf(sz,"%s%s%s",szBasePstDir,"bat\\",&szTxtBuffBat[bat[bat_free][IND_BAT_FILENAME]]); //mieux que szBmpFilename car marchera pas si pas ds bon repertoire
        img_bat[img_bat_free].load(sz,trans,0);  // trans=1 inv=0
        bat[bat_free][IND_BAT_IMG]=img_bat_free;
        img_bat_free++;
    }

    bat_free++;
}

int tr_last_pose_x=0;
int tr_last_pose_y=0;
int tr_last_pose_dx=0;
void tr_pose_ajouter(char* szBmpFilename,int tr_pose_x,int tr_pose_y,char* szEdit)
{
    int i,num_loc,loc_tract,inv_type,inv_aff_init,inv_cmd_init,the_seg,pos,xi=0,yi=0;;
    char szShort[1000];
    char* pc;
    
    // 1. Reuperation #de loco et type d'invertion a partir de la zone de texte
    //sprintf(szEdit,"loco=-1 (-1 wagon / %d locolibre) type_inv=1 (0 aucune / 1 invertion)",tr_pose_get_next_free_loc);
    num_loc=-1; if(pc=strstr(szEdit,"loco=")) num_loc=atoi(pc+strlen("loco="));
    inv_type=1; if(pc=strstr(szEdit,"type_inv")) inv_type=atoi(pc+strlen("type_inv="));

    if(num_loc!=-1) for(i=0;i<sprite_free;i++) if(sprite[i][IND_SPRITE_ON])
    if(num_loc==sprite[i][IND_SPRITE_MOT])
    {
        sprintf(szDebug,"Erreur: Numero de loco deja attribue");
        MessageBox(NULL,szDebug,"Error",MB_OK);
        return;
    }

    loc_tract=num_loc;         //plus facile de le faire a la souris en utilisation normale
    inv_aff_init=0;            //plus facile de le faire a la souris en utilisation normale
    inv_cmd_init=inv_aff_init; //pas la peine de la specifier car au detelage cmd=aff

    // 2. Extraction du nom relatif du fichier par raport a baseresdir/tr
    strcpy(szShort,&szBmpFilename[strlen(szBasePstDir)+strlen("tr\\")]);

    if(extract_xy_from_filename(szShort,&xi,&yi)==0)
    {
        MessageBox(NULL,"Nom de fichier incorrect (manque la taille _XxY ex: _240x50)","Error",MB_OK);
        return;
    }

    //3. calcul du segment
    the_seg=find_seg_for_sprite(current_ligne,x0+tr_pose_x,y0+tr_pose_y);
    if(the_seg==-1)
    {
        sprintf(szDebug,"Erreur: Pas de segment pour cet element");
        MessageBox(NULL,szDebug,"Error",MB_OK);
        return;
    }

    // 4. Ajout du nouveau sprite
    sprite_init_one(sprite_free++,0,0,xi-1,yi-1,
                    current_ligne,x0+tr_pose_x,y0+tr_pose_y,
                    the_seg,num_loc,loc_tract,inv_type,inv_aff_init,inv_cmd_init,szShort);

    tr_last_pose_x=tr_pose_x+x0;
    tr_last_pose_y=tr_pose_y+y0;
    tr_last_pose_dx=xi;
}

int tr_compute_xy_droite(char* sz,int* x,int* y,int droite)
{
    int dx,dy,xi,yi;

    if(extract_xy_from_filename(sz,&dx,&dy)==0)
    {
        MessageBox(NULL,"Nom de fichier incorrect (manque la taille _XxY ex: _240x50)","Error",MB_OK);
        return 0;
    }

    if(droite) xi=tr_last_pose_x+(tr_last_pose_dx+dx)/2-x0;
    else       xi=tr_last_pose_x-(tr_last_pose_dx+dx)/2-x0;
    yi=tr_last_pose_y-y0;

    //sprintf(szDebug,"x0=%d y0=%d tr_last_pose_x=%d tr_last_pose_y=%d tr_last_pose_dx=%d dx=%d xi=%d yi=%d",x0,y0,tr_last_pose_x,tr_last_pose_y,tr_last_pose_dx,dx,xi,yi);
    //MessageBox(NULL,szDebug,"debug",MB_OK);

    *x=xi; *y=yi; return 1;
}



int new_line_x1=0;
int new_line_x2=0;
int new_line_y1=0;
int new_line_y2=0;
void new_line(int next)
{
    if(next==0)
    {
        new_line_x1=/*grip_50*/(carte_x+x_mouse_move);
        new_line_y1=/*grip_50*/(carte_y+y_mouse_move);
        return;
    }
    new_line_x2=/*grip_50*/(carte_x+x_mouse_move);
    new_line_y2=/*grip_50*/(carte_y+y_mouse_move);

    carte_seg[carte_next_seg][CARTE_IND_SEG_X1]=new_line_x1;
    carte_seg[carte_next_seg][CARTE_IND_SEG_Y1]=new_line_y1;
    carte_seg[carte_next_seg][CARTE_IND_SEG_X2]=new_line_x2;
    carte_seg[carte_next_seg][CARTE_IND_SEG_Y2]=new_line_y2;
    carte_seg[carte_next_seg][CARTE_IND_SEG_C]=new_color;
    carte_next_seg++;

    new_line_x1=new_line_x2;
    new_line_y1=new_line_y2;
}



int sprite_x1=0;   int sprite_x2=800;
int sprite_y1=0;   int sprite_y2=600;
int sprite_xpos=0; int sprite_ypos=0;
int tr_inc_no=0;
int skip_ask_file=0;
void new_tr(int step) //0 creation d'un nouveau sprite (F3) - 1 enegistrement (space) - (mise  jour x/y en directe ds bcl)
{
}  //maintenant remplace

int new_bat(void)
{
    int i;

    bat[bat_free][IND_BAT_LIGNE]=current_ligne;
    bat[bat_free][IND_BAT_SRC_X1]=sprite_x1;
    bat[bat_free][IND_BAT_SRC_Y1]=sprite_y2-1;
    bat[bat_free][IND_BAT_SRC_X2]=sprite_x2;
    bat[bat_free][IND_BAT_SRC_Y2]=sprite_y1-1;
    bat[bat_free][IND_BAT_X]=x0+500;
    bat[bat_free][IND_BAT_Y]=y0+200;
    bat[bat_free][IND_BAT_DISP]=1;
    bat_free++;
}


//-----------------------------------------------------------------
// GESTION DES COPIER-COLLER
//-----------------------------------------------------------------

int copcol_l1=-1,copcol_x1,copcol_y1; // selection coin haut-gauche
int copcol_l2=-1,copcol_x2,copcol_y2; // selection coin bas-droit
int copcol_ld=-1,copcol_xd,copcol_yd; // cible
int copcol_ls=-1,copcol_xs,copcol_ys; // source
int copcol_aff=0;

void copcol_draw(void)
{
    if(copcol_aff==0) return;

    SelectObject(hdcMemTemp,bmp_stylo_rouge);  // couleur par defaut
    SelectObject(hdcMemTemp,bmp_pinceau_rouge);  // couleur par defaut

    // dessin du coin superieur gauche
    //if(copcol_step>=1)
    if(current_ligne==copcol_l1)
    if((copcol_x1-x0)>-1000 && (copcol_x1-x0)<2000)
    if((copcol_y1-y0)>-1000 && (copcol_y1-y0)<2000)
    {
        EasyLineTemp(copcol_x1-x0,copcol_y1-y0,copcol_x1-x0+100,copcol_y1-y0);
        EasyLineTemp(copcol_x1-x0,copcol_y1-y0,copcol_x1-x0,copcol_y1-y0+100);
        EasyLineTemp(copcol_x1-x0+100,copcol_y1-y0,copcol_x1-x0+100,copcol_y1-y0);
    }

    // dessin du coin inferieure droit
    //if(copcol_step>=2)
    if(current_ligne==copcol_l2)
    if((copcol_x2-x0)>-1000 && (copcol_x2-x0)<2000)
    if((copcol_y2-y0)>-1000 && (copcol_y2-y0)<2000)
    {
        EasyLineTemp(copcol_x2-x0,copcol_y2-y0,copcol_x2-x0-100,copcol_y2-y0);
        EasyLineTemp(copcol_x2-x0,copcol_y2-y0,copcol_x2-x0,copcol_y2-y0-100);
        EasyLineTemp(copcol_x2-x0-100,copcol_y2-y0,copcol_x2-x0-100,copcol_y2-y0);
    }

    // dessin de la source
    //if(copcol_step>=4)
    if(current_ligne==copcol_ls)
    if((copcol_xs-x0)>-1000 && (copcol_xs-x0)<2000)
    if((copcol_ys-y0)>-1000 && (copcol_ys-y0)<2000)
    {
        EasyLineTemp(copcol_xs-x0-50,copcol_ys-y0,copcol_xs-x0+50,copcol_ys-y0);
        EasyLineTemp(copcol_xs-x0,copcol_ys-y0-50,copcol_xs-x0,copcol_ys-y0+50);
    }

    // dessin de la cible
    //if(copcol_step>=5)
    if(current_ligne==copcol_ld)
    if((copcol_xd-x0)>-1000 && (copcol_xd-x0)<2000)
    if((copcol_yd-y0)>-1000 && (copcol_yd-y0)<2000)
    {
        EasyLineTemp(copcol_xd-x0-50,copcol_yd-y0,copcol_xd-x0+50,copcol_yd-y0);
        EasyLineTemp(copcol_xd-x0,copcol_yd-y0-50,copcol_xd-x0,copcol_yd-y0+50);
        EasyLineTemp(copcol_xd-x0-50,copcol_yd-y0,copcol_xd-x0,copcol_yd-y0-50);
        EasyLineTemp(copcol_xd-x0,copcol_yd-y0-50,copcol_xd-x0+50,copcol_yd-y0);
        EasyLineTemp(copcol_xd-x0+50,copcol_yd-y0,copcol_xd-x0,copcol_yd-y0+50);
        EasyLineTemp(copcol_xd-x0,copcol_yd-y0+50,copcol_xd-x0-50,copcol_yd-y0);
    }
}

void copcol_delete(void);
void copcol_deplace(void);
void copcol_ins(void);

void copcol_pose(int act)
{
    // pose du coin superieur gauche
    if(act==0)
    {
        copcol_l1=current_ligne; copcol_x1=grip_50(x0+x_mouse_move); copcol_y1=grip_50(y0+y_mouse_move);
        //copcol_l1=current_ligne; copcol_x1=x0+x_mouse_move; copcol_y1=y0+y_mouse_move;
    }

    // pose du coin inferieur droit
    if(act==1)
    {
        copcol_l2=current_ligne; copcol_x2=grip_50(x0+x_mouse_move); copcol_y2=grip_50(y0+y_mouse_move);
        //copcol_l2=current_ligne; copcol_x2=x0+x_mouse_move; copcol_y2=y0+y_mouse_move;
    }

    // pose de la source
    if(act==2)
    {
        copcol_ls=current_ligne; copcol_xs=grip_50(x0+x_mouse_move); copcol_ys=grip_50(y0+y_mouse_move);
    }

    // pose de la cible
    if(act==3)
    {
        copcol_ld=current_ligne; copcol_xd=grip_50(x0+x_mouse_move); copcol_yd=grip_50(y0+y_mouse_move);
    }

    // demande d'effacement
    if(act==4)
    {
        if(copcol_x1!=copcol_x2 && copcol_y1!=copcol_y2)
        if(MessageBox(ghwnd,"Voulez vous effacer tous les elements compris dans la selection ? \n\nYES - Effacer\nNO - Ne pas effacer","PST",MB_YESNO)==IDYES)
        {
            copcol_delete();
        }
    }

    // demande de deplacement
    if(act==5) if(copcol_x1!=copcol_x2 /*|| copcol_y1!=copcol_y2*/)
    {
        if(MessageBox(ghwnd,"Voulez vous deplacer tous les elements compris dans la selection de la source vers la cible ? \n\nYES - Deplacer\nNO - Ne pas deplacer","PST",MB_YESNO)==IDYES)
        {
            copcol_deplace();
        }
    }

    // demande de deplacement
    if(act==5) if(copcol_x1==copcol_x2 /*&& copcol_y1==copcol_y2*/)
    {
        if(MessageBox(ghwnd,"Voulez vous deplacer tout ce qui se trouve a droite des coins de la distance source-cible ? \n\nYES - Deplacer\nNO - Ne pas deplacer","PST",MB_YESNO)==IDYES)
        {
            copcol_ins();
        }
    }
}

void copcol_delete(void)
{
    int i,x1,y1,x2,y2,ptg,ptd;

    //MessageBox(ghwnd,"Delete en cours","PST",MB_OK);
    if(copcol_l1!=copcol_l2) { MessageBox(ghwnd,"La selection (les coins) doivent etre sur la meme ligne","PST",MB_OK); return; }
    if(copcol_x1>copcol_x2 || copcol_y1>copcol_y2) { MessageBox(ghwnd,"Les coins sont mal places","PST",MB_OK); return; }

    // suppression des segments
    for(i=0;i<seg_free;i++) if(seg[i][IND_SEG_PT_G]!=-1) if(seg[i][IND_SEG_TYPE]!=SEG_TYPE_DELETE)
    {
        ptg=seg[i][IND_SEG_PT_G]; if(pt[ptg][IND_PT_LIGNE]!=current_ligne) continue;
        ptd=seg[i][IND_SEG_PT_D];
        x1=pt[ptg][IND_PT_X]; y1=pt[ptg][IND_PT_Y];
        x2=pt[ptd][IND_PT_X]; y2=pt[ptd][IND_PT_Y];
        //t=seg[i][IND_SEG_TYPE];
        //if(x1>x2) {x=x1; x1=x2; x2=x; y=y1; y1=y2; y2=y;}

        if( (x1>copcol_x1 && x1<copcol_x2 && y1>copcol_y1 && y1<copcol_y2) || (x2>copcol_x1 && x2<copcol_x2 && y2>copcol_y1 && y2<copcol_y2) )
        {
            delete_seg(i);
        }
    }

    // suppression des geo
    for(i=0;i<geo_free;i++) if(geo[i][IND_GEO_forme]!=GEO_DELETE) if(geo[i][IND_GEO_ligne]==current_ligne)
    {
        x1=geo[i][IND_GEO_x1]; x2=geo[i][IND_GEO_x2];
        y1=geo[i][IND_GEO_y1]; y2=geo[i][IND_GEO_y2];

        if( (x1>copcol_x1 && x1<copcol_x2 && y1>copcol_y1 && y1<copcol_y2) || (x2>copcol_x1 && x2<copcol_x2 && y2>copcol_y1 && y2<copcol_y2) )
        {
            delete_geo(i);
        }
    }

    // suppression des batiments
    for(i=0;i<bat_free;i++) if(bat[i][IND_BAT_DISP]!=-1) if(bat[i][IND_BAT_LIGNE]==current_ligne)
    {
        x1=bat[i][IND_BAT_X];
        y1=bat[i][IND_BAT_Y];

        if(x1>copcol_x1 && x1<copcol_x2 && y1>copcol_y1 && y1<copcol_y2)
        {
            delete_bat(i);
        }
    }

    // suppression des textes
    for(i=0;i<txt_free;i++) if(txt[i][IND_TXT_pt_texte]!=-1) if(txt[i][IND_TXT_ligne]==current_ligne)
    {
        x1=txt[i][IND_TXT_x];
        y1=txt[i][IND_TXT_y];

        if(x1>copcol_x1 && x1<copcol_x2 && y1>copcol_y1 && y1<copcol_y2)
        {
            delete_txt(i);
        }
    }

    // suppression des sprites
    for(i=0;i<sprite_free;i++) if(sprite[i][IND_SPRITE_ON]==1 || sprite[i][IND_SPRITE_INV_TYPE]==3) if(sprite_get_ligne_pr_save(i)==current_ligne)
    {
        //if(sprite_get_ligne_pr_save(i)==copcol_l1)
        x1=sprite[i][IND_SPRITE_X];
        y1=sprite[i][IND_SPRITE_Y];

        if(x1>copcol_x1 && x1<copcol_x2 && y1>copcol_y1 && y1<copcol_y2)
        {
            delete_sprite(i);
        }
    }

    // suppression des coordonnees de saut des points de la carte
    /*
    for(i=0;i<carte_next_pt;i++) if(carte_pt[i][CARTE_IND_PT_LIGNE]==current_ligne)
    {
        x1=carte_pt[i][CARTE_IND_PT_X_LIGNE]; y1=carte_pt[i][CARTE_IND_PT_Y_LIGNE];

        if(x1>copcol_x1 && x1<copcol_x2 && y1>copcol_y1 && y1<copcol_y2)
        {
            carte_pt[i][CARTE_IND_PT_LIGNE]=-1;
            carte_pt[i][CARTE_IND_PT_X_LIGNE]=0;
            carte_pt[i][CARTE_IND_PT_Y_LIGNE]=0;
        }
    }
    */

    // suppression des coordonnees de saut des points de la carte2
    //carte2_delete(int ligne, int x_g, int y_h, int x_d, int y_b)
    carte2_delete(current_ligne, copcol_x1, copcol_y1, copcol_x2, copcol_y2);

    disp_seg_geo_txt_bat_fill(1); disp_sprite_fill(1); fill_pt_sega_segb();
}

void copcol_deplace(void)
{
    int i,x1,y1,x2,y2,ptg,ptd,in1,in2,laig;

    //MessageBox(ghwnd,"Deplacement en cours","PST",MB_OK);
    if(copcol_l1!=copcol_l2) { MessageBox(ghwnd,"La selection (les coins) doivent etre sur la meme ligne","PST",MB_OK); return; }
    if(copcol_l1!=copcol_ls) { MessageBox(ghwnd,"La selection (les coins) et la source doivent etre sur la meme ligne","PST",MB_OK); return; }
    if(copcol_x1>copcol_x2 || copcol_y1>copcol_y2) { MessageBox(ghwnd,"Les coins sont mal places","PST",MB_OK); return; }

    // suppression des segments entre l'exterieur et l'interieur de la selection
    // (pour ne pas avoir a doubler les points)
    for(i=0;i<seg_free;i++) if(seg[i][IND_SEG_PT_G]!=-1) if(seg[i][IND_SEG_TYPE]!=SEG_TYPE_DELETE)
    {
        ptg=seg[i][IND_SEG_PT_G]; if(pt[ptg][IND_PT_LIGNE]!=copcol_l1) continue;
        ptd=seg[i][IND_SEG_PT_D];
        x1=pt[ptg][IND_PT_X]; y1=pt[ptg][IND_PT_Y];
        x2=pt[ptd][IND_PT_X]; y2=pt[ptd][IND_PT_Y];

        in1=in2=0;
        if(x1>copcol_x1 && x1<copcol_x2 && y1>copcol_y1 && y1<copcol_y2) in1=1;
        if(x2>copcol_x1 && x2<copcol_x2 && y2>copcol_y1 && y2<copcol_y2) in2=1;

        if(in2!=in1) delete_seg(i);
    }

    // deplacement des segments en manipulant uniquement les points
    // (car en modifiant les segements on aurait modifier les points 2 fois !)
    for(i=0;i<pt_free;i++) if(pt[i][IND_PT_AIG]!=-2) if(pt[i][IND_PT_LIGNE]==copcol_ls)
    {
        x1=pt[i][IND_PT_X]; y1=pt[i][IND_PT_Y];
        in1=0; if(x1>copcol_x1 && x1<copcol_x2 && y1>copcol_y1 && y1<copcol_y2) in1=1;
        if(in1==0) continue;
        laig=pt[i][IND_PT_AIG];

        // suppression des aiguillages (car la zone cible en a surement de meme numero)
        // on pourrait demander si ok pour renumerpter les aiguillages (et prendre les libres)
        if(copcol_ls!=copcol_ld) if(laig>=0 && laig<=999) { pt[i][IND_PT_AIG]=-1; aig[copcol_ls][laig][0]=-1; /*non utilise*/  }
        // on n'a pas besoin de changer les link 10000-10999

        // deplacement des points en changeant les coordonnees l,x,y
        // s'il y a deja un point a la meme destination, il faudra surement le supprimer
        pt[i][IND_PT_X]=x1+copcol_xd-copcol_xs;
        pt[i][IND_PT_Y]=y1+copcol_yd-copcol_ys;
        pt[i][IND_PT_LIGNE]=copcol_ld;
    }

    // deplacement des geo
    for(i=0;i<geo_free;i++) if(geo[i][IND_GEO_forme]!=GEO_DELETE) if(geo[i][IND_GEO_ligne]==copcol_ls)
    {
        x1=geo[i][IND_GEO_x1]; x2=geo[i][IND_GEO_x2];
        y1=geo[i][IND_GEO_y1]; y2=geo[i][IND_GEO_y2];

        if( (x1>copcol_x1 && x1<copcol_x2 && y1>copcol_y1 && y1<copcol_y2) || (x2>copcol_x1 && x2<copcol_x2 && y2>copcol_y1 && y2<copcol_y2) )
        {
            geo[i][IND_GEO_ligne]=copcol_ld;
            geo[i][IND_GEO_x1]=x1+copcol_xd-copcol_xs;
            geo[i][IND_GEO_y1]=y1+copcol_yd-copcol_ys;
            geo[i][IND_GEO_x2]=x2+copcol_xd-copcol_xs;
            geo[i][IND_GEO_y2]=y2+copcol_yd-copcol_ys;
        }
    }

    // deplacement des batiments (si les lignes ont le meme fichier des batiments sinon aucun sens)
    if(0==stricmp(&szcarte_txt[ligne[copcol_l1][IND_LIGNE_IMG]],&szcarte_txt[ligne[copcol_ld][IND_LIGNE_IMG]]))
    for(i=0;i<bat_free;i++) if(bat[i][IND_BAT_DISP]!=-1) if(bat[i][IND_BAT_LIGNE]==copcol_ls)
    {
        x1=bat[i][IND_BAT_X];
        y1=bat[i][IND_BAT_Y];

        if(x1>copcol_x1 && x1<copcol_x2 && y1>copcol_y1 && y1<copcol_y2)
        {
            bat[i][IND_BAT_LIGNE]=copcol_ld;
            bat[i][IND_BAT_X]=x1+copcol_xd-copcol_xs;
            bat[i][IND_BAT_Y]=y1+copcol_yd-copcol_ys;
        }
    }

    // deplacement des textes
    for(i=0;i<txt_free;i++) if(txt[i][IND_TXT_pt_texte]!=-1) if(txt[i][IND_TXT_ligne]==copcol_ls)
    {
        x1=txt[i][IND_TXT_x];
        y1=txt[i][IND_TXT_y];

        if(x1>copcol_x1 && x1<copcol_x2 && y1>copcol_y1 && y1<copcol_y2)
        {
            txt[i][IND_TXT_ligne]=copcol_ld;
            txt[i][IND_TXT_x]=x1+copcol_xd-copcol_xs;
            txt[i][IND_TXT_y]=y1+copcol_yd-copcol_ys;
        }
    }

    // deplacement des sprites
    for(i=0;i<sprite_free;i++) if(sprite[i][IND_SPRITE_ON]==1 || sprite[i][IND_SPRITE_INV_TYPE]==3) if(sprite_get_ligne_pr_save(i)==copcol_ls)
    {
        //if(sprite_get_ligne_pr_save(i)==copcol_l1)
        x1=sprite[i][IND_SPRITE_X];
        y1=sprite[i][IND_SPRITE_Y];

        if(x1>copcol_x1 && x1<copcol_x2 && y1>copcol_y1 && y1<copcol_y2)
        {
            sprite[i][IND_SPRITE_X]=x1+copcol_xd-copcol_xs; // uniquement x/y car sprite reste sur son segment
            sprite[i][IND_SPRITE_Y]=y1+copcol_yd-copcol_ys;
        }
    }

    // mise a jour des coordonnees de saut des points de la carte
    /*
    for(i=0;i<carte_next_pt;i++) if(carte_pt[i][CARTE_IND_PT_LIGNE]==copcol_ls)
    {
        x1=carte_pt[i][CARTE_IND_PT_X_LIGNE]; y1=carte_pt[i][CARTE_IND_PT_Y_LIGNE];

        if(x1>copcol_x1 && x1<copcol_x2 && y1>copcol_y1 && y1<copcol_y2)
        {
            carte_pt[i][CARTE_IND_PT_LIGNE]=copcol_ld;
            carte_pt[i][CARTE_IND_PT_X_LIGNE]=x1+copcol_xd-copcol_xs;
            carte_pt[i][CARTE_IND_PT_Y_LIGNE]=y1+copcol_yd-copcol_ys;
        }
    }
    */

    // mise a jour des coordonnees de saut des points de la carte 2
    //carte2_deplace(int old_ligne, int x_g, int y_h, int x_d, int y_b, int x_src, int y_src, int new_ligne, int x_dst, int y_dst)
    carte2_deplace(copcol_ls, copcol_x1, copcol_y1, copcol_x2, copcol_y2, copcol_xs, copcol_ys, copcol_ld, copcol_xd, copcol_yd);

    disp_seg_geo_txt_bat_fill(1); disp_sprite_fill(1); fill_pt_sega_segb();
}

void copcol_ins(void)
{
    int i,x1,y1,x2,y2,ptg,ptd,in1,in2,laig;

    //MessageBox(ghwnd,"Deplacement en cours","PST",MB_OK);
    if(copcol_ls!=copcol_ld) { MessageBox(ghwnd,"La source et la destination doivent etre sur la meme ligne","PST",MB_OK); return; }

    // deplacement des segments en manipulant uniquement les points
    // (car en modifiant les segements on aurait modifier les points 2 fois !)
    for(i=0;i<pt_free;i++) if(pt[i][IND_PT_AIG]!=-2) if(pt[i][IND_PT_LIGNE]==copcol_ls)
    {
        x1=pt[i][IND_PT_X]; y1=pt[i][IND_PT_Y];
        in1=0; if(x1>copcol_x1) in1=1; //copcol_xs avant
        if(in1==0) continue;

        pt[i][IND_PT_X]=x1+copcol_xd-copcol_xs;
    }

    // deplacement des geo
    for(i=0;i<geo_free;i++) if(geo[i][IND_GEO_forme]!=GEO_DELETE) if(geo[i][IND_GEO_ligne]==copcol_ls)
    {
        x1=geo[i][IND_GEO_x1]; x2=geo[i][IND_GEO_x2];
        y1=geo[i][IND_GEO_y1]; y2=geo[i][IND_GEO_y2];

        if(x1>copcol_x1) //copcol_xs avant
        {
            geo[i][IND_GEO_x1]=x1+copcol_xd-copcol_xs;
            geo[i][IND_GEO_x2]=x2+copcol_xd-copcol_xs;
        }
    }

    // deplacement des batiments (si les lignes ont le meme fichier des batiments sinon aucun sens)
    if(0==stricmp(&szcarte_txt[ligne[copcol_l1][IND_LIGNE_IMG]],&szcarte_txt[ligne[copcol_ld][IND_LIGNE_IMG]]))
    for(i=0;i<bat_free;i++) if(bat[i][IND_BAT_DISP]!=-1) if(bat[i][IND_BAT_LIGNE]==copcol_ls)
    {
        x1=bat[i][IND_BAT_X];
        y1=bat[i][IND_BAT_Y];

        if(x1>copcol_x1) //copcol_xs avant
        {
            bat[i][IND_BAT_X]=x1+copcol_xd-copcol_xs;
        }
    }

    // deplacement des textes
    for(i=0;i<txt_free;i++) if(txt[i][IND_TXT_pt_texte]!=-1) if(txt[i][IND_TXT_ligne]==copcol_ls)
    {
        x1=txt[i][IND_TXT_x];
        y1=txt[i][IND_TXT_y];

        if(x1>copcol_x1) //copcol_xs avant
        {
            txt[i][IND_TXT_x]=x1+copcol_xd-copcol_xs;
        }
    }

    // deplacement des sprites
    for(i=0;i<sprite_free;i++) if(sprite[i][IND_SPRITE_ON]==1 || sprite[i][IND_SPRITE_INV_TYPE]==3) if(sprite_get_ligne_pr_save(i)==copcol_ls)
    {
        //if(sprite_get_ligne_pr_save(i)==copcol_l1)
        x1=sprite[i][IND_SPRITE_X];
        y1=sprite[i][IND_SPRITE_Y];

        if(x1>copcol_x1) //copcol_xs avant
        {
            sprite[i][IND_SPRITE_X]=x1+copcol_xd-copcol_xs; // uniquement x/y car sprite reste sur son segment
        }
    }

    // mise a jour des coordonnees de saut des points de la carte
    for(i=0;i<carte_next_pt;i++) if(carte_pt[i][CARTE_IND_PT_LIGNE]==copcol_ls)
    {
        x1=carte_pt[i][CARTE_IND_PT_X_LIGNE]; y1=carte_pt[i][CARTE_IND_PT_Y_LIGNE];

        if(x1>copcol_x1) //copcol_xs avant
        {
            carte_pt[i][CARTE_IND_PT_X_LIGNE]=x1+copcol_xd-copcol_xs;
        }
    }

    disp_seg_geo_txt_bat_fill(1); disp_sprite_fill(1); fill_pt_sega_segb();
}


//-----------------------------------------------------------------
// SCRIPT
//-----------------------------------------------------------------

int exe_script_on=0;
int script_debug_on=0;

int horo_day=0;
int horo_hour=5;
int horo_min=55;
int horo_hourmin=555;
int horo_dcpt=0;
int horo_nb_tic_min=40;
int horo_block=0;
int horo_user_block=0;

//#define SCRIPT_TAB_SIZE 100000 //declare plus haut
int script_tab[SCRIPT_TAB_SIZE][2];
int script_tab_next=0;
#define SCRIPT_TAB_IND_ORDRE 0
#define SCRIPT_TAB_IND_VAL   1

//#define SCRIPT_CH_NB 100 //declare plus haut
int script_ch[SCRIPT_CH_NB][10];
#define SCRIPT_CH_IND_PT       0
#define SCRIPT_CH_IND_PTDEB    1
#define SCRIPT_CH_IND_LOCO     2
#define SCRIPT_CH_IND_TEMPO    3
#define SCRIPT_CH_IND_HBLOCK   4
#define SCRIPT_CH_IND_WAIT     5
#define SCRIPT_CH_IND_LIGNEAIG 6

//#define SCRIPT_LOCO_NB 100 //declare plus haut
//int script_loco_mode_auto[SCRIPT_LOCO_NB]; //declare plus haut
int script_loco_aig[SCRIPT_LOCO_NB][MAX_AIG];
int script_loco_aig_use_tab[SCRIPT_LOCO_NB];

#define SCRIPT_ORDRE_END         0 //fin du tableau
#define SCRIPT_ORDRE_CH          1 //selection du canal
#define SCRIPT_ORDRE_CHEND       2 //fin du canal
#define SCRIPT_ORDRE_CHBCL       3 //rebouclage canal
#define SCRIPT_ORDRE_LOCO        4 //selection de la loco (automatique)
#define SCRIPT_ORDRE_VIT         5 //vitesse de la loco
#define SCRIPT_ORDRE_WAITT       6 //nb tic
#define SCRIPT_ORDRE_WAITM       7 //nb minute
#define SCRIPT_ORDRE_WAITH       8 //heure|minute
#define SCRIPT_ORDRE_WAITSX      9 //attente position >= X
#define SCRIPT_ORDRE_WAITIX     10 //attente position <= X
#define SCRIPT_ORDRE_AIGDIR     11 //comportement de l'aiguillage pour la loco
#define SCRIPT_ORDRE_AIGDEV     12 //comportement de l'aiguillage pour la loco
#define SCRIPT_ORDRE_BLOCKH     13 //heure|minute
#define SCRIPT_ORDRE_HOROSETDHM 14 //heure|minute
#define SCRIPT_ORDRE_HOROSETTIC 15 //tic
// rajouter
#define SCRIPT_ORDRE_ACCR       16 //accrocher un wagon
#define SCRIPT_ORDRE_DECR       17 //decrocher un wagon
#define SCRIPT_ORDRE_INV        18 //inverser la loco
#define SCRIPT_ORDRE_AIGLIGNE   19 //selection de la ligne pour les aiguillages (ou -1 pour le tableau de la loco) - info par canal
#define SCRIPT_ORDRE_AIGLOCOTAB 20 //utilisation du tableau de la loco pour les aiguillages
// rajouter plus tard
#define SCRIPT_ORDRE_SOUND      21 //execution d'un son

char* asz_script_ordre[] = {
  "ORDRE_END 0", "ORDRE_CH 1", "ORDRE_CHEND 2", "ORDRE_CHBCL 3", "ORDRE_LOCO 4",
  "ORDRE_VIT 5", "ORDRE_WAITT 6", "ORDRE_WAITM 7", "ORDRE_WAITH 8", "ORDRE_WAITSX 9",
  "ORDRE_WAITIX 10", "ORDRE_AIGDIR 11", "ORDRE_AIGDEV 12", "ORDRE_BLOCKH 13", "ORDRE_HOROSETDHM 14",
  "ORDRE_HOROSETTIC 15", "ORDRE_ACCR 16", "ORDRE_DECR 17", "ORDRE_INV 18", "ORDRE_AIGLIGNE 19",
  "ORDRE_AIGLOCOTAB 20", "ORDRE_SOUND 21"
                           };

int aig_state(int ligne_no, int aig_no, int sprite_no)
{
    int mot;

    mot=sprite[sprite_no][IND_SPRITE_MOT];
    if(mot>=0 && mot<SCRIPT_LOCO_NB)
        if(script_loco_mode_auto[mot]==1)
            if(script_loco_aig_use_tab[mot]==1)
                return script_loco_aig[mot][aig_no];
    return aig[ligne_no][aig_no][IND_AIG_ETAT];
}

void script_init(void) //a executer apres chargement fichier infra pour avoir la position des aiguillages par defaut
{
    int i,j;

    script_tab_next=0;
    for(i=0;i<SCRIPT_TAB_SIZE;i++) script_tab[i][SCRIPT_TAB_IND_ORDRE]=SCRIPT_ORDRE_END;

    for(i=0;i<SCRIPT_CH_NB;i++)
    {
        script_ch[i][SCRIPT_CH_IND_PT]=script_ch[i][SCRIPT_CH_IND_PTDEB]=-1;
        script_ch[i][SCRIPT_CH_IND_TEMPO]=-1;
        script_ch[i][SCRIPT_CH_IND_HBLOCK]=-1;
        script_ch[i][SCRIPT_CH_IND_WAIT]=0;
        script_ch[i][SCRIPT_CH_IND_LIGNEAIG]=-1;
    }

    for(i=0;i<SCRIPT_LOCO_NB;i++)
    {
         script_loco_mode_auto[i]=0;
         //for(j=0;j<MAX_AIG;j++) script_loco_aig[i][j]=aig[0][j][IND_AIG_ETAT];
         for(j=0;j<MAX_AIG;j++) script_loco_aig[i][j]=0; // position directe par defaut
         script_loco_aig_use_tab[i]=1;
    }
}

void script_debug(void)
{
    int i,j,ordre;

    FILE* pd;

    if(script_debug_on==0) return;

    pd=fopen("debug_script_exe.txt","wt"); fclose(pd); //effacement de l'execution precedente
    //pd=fopen("debug_script.txt","at");
    pd=fopen("debug_script.txt","wt"); // maintenant juste au demarrage
    if(pd==NULL) { MessageBox(NULL,"Cannot create file debug_script.txt","Error",MB_OK); return; }
    //fprintf(pd,"\n\n----------script_maj-------------");

    for(i=0;i<SCRIPT_TAB_SIZE;i++)
    {
        ordre=script_tab[i][SCRIPT_TAB_IND_ORDRE];
        if(ordre==0) fprintf(pd,"\nORDRE=%-2d VAL=%d",ordre,script_tab[i][SCRIPT_TAB_IND_VAL]);
        else         fprintf(pd,"\nORDRE=%s VAL=%d",asz_script_ordre[ordre],script_tab[i][SCRIPT_TAB_IND_VAL]);
    }

    for(i=0;i<SCRIPT_CH_NB;i++)
    {
        for(j=0;j<10;j++) fprintf(pd,"\nCH%d-%d=%d",i,j,script_ch[i][j]);
    }

    for(i=0;i<SCRIPT_LOCO_NB;i++)
    {
        fprintf(pd,"\nloco%d mode=%d aig",i,script_loco_mode_auto[i]);
        for(j=0;j<MAX_AIG;j++) fprintf(pd,"%d.",script_loco_aig[i][j]);
    }

    fclose(pd);
}

void horo_maj(void)
{
    int ch;

    // 1. gestion de l'horloge
    horo_block=0;
    for(ch=0;ch<SCRIPT_CH_NB;ch++)
    {
        if(script_ch[ch][SCRIPT_CH_IND_HBLOCK]==horo_hourmin) horo_block=1;
    }

    if(horo_block==0 && horo_user_block==0)
    {
        if(horo_dcpt==0)
        {
            horo_dcpt=horo_nb_tic_min;
            horo_min++;
            if(horo_min==60)
            {
                horo_min=0;
                horo_hour++;
                if(horo_hour==24)
                {
                    horo_hour=0;
                    horo_day++;
                    if(horo_day==7)
                    {
                        horo_day=0;
                    }
                }
            }
        }
        horo_dcpt--;
        horo_hourmin=100*horo_hour+horo_min;
    }
}

void script_maj(void)
{
    int ch,pt,ordre,val,loco,wait,k,on,lgne;

    FILE* pd;

    //script_debug();
    if(script_debug_on)
    {
        pd=fopen("debug_script_exe.txt","at");
        if(pd==NULL) { MessageBox(NULL,"Cannot create file infra_modif.txt","Error",MB_OK); return; }
        //fprintf(pd,"\nscript_maj");
    }

    //2. gestion des ordres
    for(ch=0;ch<SCRIPT_CH_NB;ch++)
    {
        //if(ch==0) fprintf(pd,"\npt=%d ptdeb=%d",script_ch[ch][SCRIPT_CH_IND_PT   ],script_ch[ch][SCRIPT_CH_IND_PTDEB]);

        if(script_ch[ch][SCRIPT_CH_IND_PTDEB]==-1) continue;
        if(script_ch[ch][SCRIPT_CH_IND_PT   ]==-1) continue;

        pt   =script_ch[ch][SCRIPT_CH_IND_PT  ];
        loco =script_ch[ch][SCRIPT_CH_IND_LOCO];
        wait =script_ch[ch][SCRIPT_CH_IND_WAIT];

        ordre=script_tab[pt][SCRIPT_TAB_IND_ORDRE];
        val  =script_tab[pt][SCRIPT_TAB_IND_VAL  ];

        if(wait==0)
        {
            if(script_debug_on)
            {
                //fprintf(pd,"\nch=%d ordre=%d val=%d",ch,ordre,val);
                fprintf(pd,"\nch=%d ordre=%s val=%d",ch,asz_script_ordre[ordre],val);
                sprintf(szDebug,"ch=%d ordre=%s val=%d",ch,asz_script_ordre[ordre],val);
            }

            if(ordre==SCRIPT_ORDRE_CHEND        ) { pt=-1; }
            if(ordre==SCRIPT_ORDRE_CH           ) { pt++;  }
            if(ordre==SCRIPT_ORDRE_CHBCL        ) { pt=script_ch[ch][SCRIPT_CH_IND_PTDEB]; }
            if(ordre==SCRIPT_ORDRE_LOCO         ) { pt++; if(loco!=-1) script_loco_mode_auto[loco]=0; loco=val; script_ch[ch][SCRIPT_CH_IND_LOCO]=loco; if(loco!=-1) script_loco_mode_auto[loco]=1; }
            if(ordre==SCRIPT_ORDRE_VIT          ) { pt++; if(loco!=-1) mot[loco][IND_MOT_VIT]=val;   }

            if(ordre==SCRIPT_ORDRE_AIGLOCOTAB   ) { pt++; if(loco!=-1) script_loco_aig_use_tab[loco]=val&1; }
            if(ordre==SCRIPT_ORDRE_AIGLIGNE     ) { pt++; script_ch[ch][SCRIPT_CH_IND_LIGNEAIG]=val; }
            if(ordre==SCRIPT_ORDRE_AIGDIR       ) { pt++; lgne=script_ch[ch][SCRIPT_CH_IND_LIGNEAIG];
                                                    if(lgne==-1) { if(loco!=-1) script_loco_aig[loco][val]=0; }
                                                    else         { if(aig[lgne][val][IND_AIG_ETAT]!=-1) aig[lgne][val][IND_AIG_ETAT]=0; } }
            if(ordre==SCRIPT_ORDRE_AIGDEV       ) { pt++; lgne=script_ch[ch][SCRIPT_CH_IND_LIGNEAIG];
                                                    if(lgne==-1) { if(loco!=-1) script_loco_aig[loco][val]=1; }
                                                    else         { if(aig[lgne][val][IND_AIG_ETAT]!=-1) aig[lgne][val][IND_AIG_ETAT]=1; } }

            if(ordre==SCRIPT_ORDRE_WAITT        ) { wait=1; script_ch[ch][SCRIPT_CH_IND_TEMPO]=val; }
            if(ordre==SCRIPT_ORDRE_WAITM        ) { wait=1; script_ch[ch][SCRIPT_CH_IND_TEMPO]=val*horo_nb_tic_min; }
            if(ordre==SCRIPT_ORDRE_WAITH        ) { wait=1; }
            if(ordre==SCRIPT_ORDRE_WAITSX       ) { wait=1; }
            if(ordre==SCRIPT_ORDRE_WAITIX       ) { wait=1; }

            if(ordre==SCRIPT_ORDRE_BLOCKH       ) { pt++; script_ch[ch][SCRIPT_CH_IND_HBLOCK]=val; }
            if(ordre==SCRIPT_ORDRE_HOROSETDHM   ) { pt++; horo_day=(val/10000)%10; if(horo_day>=7) horo_day=0; horo_hourmin=val%10000; horo_hour=(val/100)%100; horo_min=val%100; horo_dcpt=0; }
            if(ordre==SCRIPT_ORDRE_HOROSETTIC   ) { pt++; horo_nb_tic_min=val; horo_dcpt=0; }

            if(ordre==SCRIPT_ORDRE_ACCR         ) { pt++; accr_sprite(val,loco); }
            if(ordre==SCRIPT_ORDRE_DECR         ) { pt++; decr_sprite(val);      }
            if(ordre==SCRIPT_ORDRE_INV          ) { pt++; inv_sprite(get_spriteid_for_loco(loco)); }

            if(ordre==SCRIPT_ORDRE_SOUND        ) { pt++; ShellExecute(NULL,"open",&szcarte_txt[val], NULL, NULL, SW_SHOWNA); }
        }

        if(wait==1)
        {
            if(ordre==SCRIPT_ORDRE_WAITT        ) { if(script_ch[ch][SCRIPT_CH_IND_TEMPO]==0) {wait=0; pt++; } else script_ch[ch][SCRIPT_CH_IND_TEMPO]--; }
            if(ordre==SCRIPT_ORDRE_WAITM        ) { if(script_ch[ch][SCRIPT_CH_IND_TEMPO]==0) {wait=0; pt++; } else script_ch[ch][SCRIPT_CH_IND_TEMPO]--; }
            if(ordre==SCRIPT_ORDRE_WAITH        ) { if(horo_hourmin==val) {pt++; wait=0;} }
          //if(ordre==SCRIPT_ORDRE_WAITSX       ) { for(k=0;k<sprite_free;k++) if(sprite[k][IND_SPRITE_MOT]==loco) if(sprite[k][IND_SPRITE_X]>val) {wait=0; pt++; } }
          //if(ordre==SCRIPT_ORDRE_WAITIX       ) { for(k=0;k<sprite_free;k++) if(sprite[k][IND_SPRITE_MOT]==loco) if(sprite[k][IND_SPRITE_X]<val) {wait=0; pt++; } }
            if(ordre==SCRIPT_ORDRE_WAITSX       ) { for(k=0;k<sprite_free;k++) if(sprite[k][IND_SPRITE_LOCO]==loco) if(sprite[k][IND_SPRITE_X]>val) {wait=0; pt++; } }
            if(ordre==SCRIPT_ORDRE_WAITIX       ) { for(k=0;k<sprite_free;k++) if(sprite[k][IND_SPRITE_LOCO]==loco) if(sprite[k][IND_SPRITE_X]<val) {wait=0; pt++; } }
        }

        script_ch[ch][SCRIPT_CH_IND_PT]=pt;
        script_ch[ch][SCRIPT_CH_IND_WAIT]=wait;
    }

    on=0; for(ch=0;ch<SCRIPT_CH_NB;ch++) if(script_ch[ch][SCRIPT_CH_IND_PT]!=-1) on=1;  //arret automatique en fin
    if(on==0) exe_script_on=0;

    if(script_debug_on) fclose(pd);
}


char szBmpFilename[1000];
BOOL SelectBmpFileOpen(void)
{
    OPENFILENAME ofn;

    ZeroMemory(&ofn, sizeof(ofn));
    szBmpFilename[0] = '\0';

    ofn.lStructSize = sizeof(ofn);
    ofn.hwndOwner = ghwnd;
    ofn.lpstrFilter = "Image Files (*.bmp)\0*.bmp\0All Files (*.*)\0*.*\0\0";
    ofn.lpstrFile = szBmpFilename;
    ofn.nMaxFile = MAX_PATH;
    ofn.lpstrDefExt = "bmp";
    ofn.Flags = OFN_EXPLORER /*| OFN_FILEMUSTEXIST| OFN_HIDEREADONLY*/;

    if(GetOpenFileName(&ofn)) return TRUE;

    return FALSE;
}


char szMapFilename[1000];
BOOL SelectMapFileOpen(void)
{
    OPENFILENAME ofn;

    ZeroMemory(&ofn, sizeof(ofn));
    szMapFilename[0] = '\0';

    ofn.lStructSize = sizeof(ofn);
    ofn.hwndOwner = ghwnd;
    ofn.lpstrFilter = "Image Files (*.bmp)\0*.bmp\0All Files (*.*)\0*.*\0\0";
    ofn.lpstrFile = szMapFilename;
    ofn.nMaxFile = MAX_PATH;
    ofn.lpstrDefExt = "bmp";
    ofn.Flags = OFN_EXPLORER /*| OFN_FILEMUSTEXIST| OFN_HIDEREADONLY*/;

    if(GetOpenFileName(&ofn)) return TRUE;

    return FALSE;
}

//-----------------------------------------------------------------
// FICHIER DE CONFIG (du reseau)
//-----------------------------------------------------------------

BOOL SelectInfraFileOpen(void)
{
    OPENFILENAME ofn;

    ZeroMemory(&ofn, sizeof(ofn));
    szInfraFileName[0] = '\0';

    ofn.lStructSize = sizeof(ofn);
    ofn.hwndOwner = ghwnd;
    ofn.lpstrFilter = "Infra Files (*.txt)\0*.txt\0All Files (*.*)\0*.*\0\0";
    ofn.lpstrFile = szInfraFileName;
    ofn.nMaxFile = MAX_PATH;
    ofn.lpstrDefExt = "txt";
    ofn.Flags = OFN_EXPLORER /*| OFN_FILEMUSTEXIST| OFN_HIDEREADONLY*/;

    if(GetOpenFileName(&ofn)) return TRUE;

    return FALSE;
}

BOOL SelectInfraFileSaveAs(void)
{
    OPENFILENAME ofn;

    ZeroMemory(&ofn, sizeof(ofn));
    szInfraFileName[0] = '\0';

    ofn.lStructSize = sizeof(ofn);
    ofn.hwndOwner = ghwnd;
    ofn.lpstrFilter = "Infra Files (*.txt)\0*.txt\0All Files (*.*)\0*.*\0\0";
    ofn.lpstrFile = szInfraFileName;
    ofn.nMaxFile = MAX_PATH;
    ofn.lpstrDefExt = "txt";
    ofn.Flags = OFN_EXPLORER /* | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY*/;

    if(GetSaveFileName(&ofn)) return TRUE;

    return FALSE;
}

int modif_x(int x)
{
    if(x==-1) return -1;
    return x+10000;
  //return x;
}

int modif_y(int y)
{
    if(y==-1) return -1;
    //return (y/2);
    //return (y+50);
    return y;
}

#define MODE_SEG    0
#define MODE_AIG    1
#define MODE_TR     2
#define MODE_GEO    3
#define MODE_VAR    4
#define MODE_TXT    5
#define MODE_LINE   6
#define MODE_PT     7
#define MODE_SCRIPT 8
#define MODE_BAT    9
#define MODE_LIGNE 10
#define MODE_LINK  11
#define MODE_SPRITEFILE 12
#define MODE_PT2    13
#define MODE_CARTE2 14
char szVarName[100];
int base_x=0;
int base_y=0;
int base_aig=0;
int base_loco=0;


int load_infra_sprite(void)
{
    FILE* ps;  // fichier source
    char szStr[1024];
    char c;
    char sz[2];
    char szTxtStr[200];
    int mode;
    int i,ok,col,val,loc;
    int x1,y1,x2,y2,pt1,pt2,ptg,ptd,xg,yg,xd,yd,type,inv_type,inv_aff_init,inv_cmd_init;
    int num,pos,x_coeur,y_coeur,x_commun,y_commun,x_direct,y_direct,x_devie,y_devie;
    int pt_coeur,pt_commun,pt_direct,pt_devie,seg_commun,seg_direct,seg_devie;
    int src_x1,src_x2,src_y1,src_y2,seg_x1,seg_x2,seg_y1,seg_y2,pos_ligne,pos_x,pos_y,mot,seg_no;
    int color,forme;
    int yb,yh;
    int x_p,y_p,ligne_no,x_l,y_l,x_t,y_t,x0_ligne,y0_ligne;
    int x_p2,y_p2,c2_num=0;
    char szname[1000];
    char* pc;

    strcpy(szInfraFileName,"infra.txt");
    SelectInfraFileOpen();

    //repertoire de base de pst
    strcpy(szBasePstDir,szInfraFileName);
    pc=&szBasePstDir[strlen(szBasePstDir)-1];
          while((*pc)!='\\') pc--; //base du reseau
    pc--; while((*pc)!='\\') pc--; //repertoire res (commenter si base = reseau)
    pc--; while((*pc)!='\\') pc--; //base de pst (commenter si base = reseau)
    *(pc+1)='\0';
    strlwr(szBasePstDir);
    //MessageBox(NULL,szBasePstDir,"szBaseDir",MB_OK);

    //repertoire de base du reseau
    strcpy(szBaseResDir,szInfraFileName);
    pc=&szBaseResDir[strlen(szBaseResDir)-1];
          while((*pc)!='\\') pc--; //base du reseau
    *(pc+1)='\0';
    strlwr(szBaseResDir);

    //copie de securite du fichier reseau au chargement (so la sauvegarde se passe mal)
    sprintf(szInfraFileSecu,"%s.save",szInfraFileName);
    sprintf(szStr,"copy \"%s\" \"%s\"",szInfraFileName,szInfraFileSecu); // marche pas sans ""
    //MessageBox(NULL,szStr,"szInfraFileSecu",MB_OK);
    system(szStr);

    ps=fopen(szInfraFileName,"rt");
    if(ps==NULL) { MessageBox(NULL,"Cannot open file infrastructure file","Error",MB_OK); return 0; }

    mode=MODE_SEG;
    col=0;
    config_version=CONFIG_VERS;

    while(fscanf(ps," %s",szStr)!=EOF)
    {
        ok=0;

        //fprintf(pf,"\n%s",szStr);
        if(0==stricmp(szStr,"end"))    { ok=1; break; }
        if(0==stricmp(szStr,"seg"))    { mode=MODE_SEG;   ok=1; col=0; }
        if(0==stricmp(szStr,"aig"))    { mode=MODE_AIG;   ok=1; col=0; }
        if(0==stricmp(szStr,"tr" ))    { mode=MODE_TR;    ok=1; col=0; }
        if(0==stricmp(szStr,"geo"))    { mode=MODE_GEO;   ok=1; col=0; }
        if(0==stricmp(szStr,"txt" ))   { mode=MODE_TXT;   ok=1; col=0; }
        if(0==stricmp(szStr,"line"))   { mode=MODE_LINE;  ok=1; col=0; }
        if(0==stricmp(szStr,"pt"  ))   { mode=MODE_PT;    ok=1; col=0; }
        if(0==stricmp(szStr,"pt2" ))   { mode=MODE_PT2;   ok=1; col=0; }
        if(0==stricmp(szStr,"carte2")) { mode=MODE_CARTE2;ok=1; col=0; }
      //if(0==stricmp(szStr,"script")) { mode=MODE_SCRIPT;ok=1; col=0; } // ds fichier separe maintenant
        if(0==stricmp(szStr,"bat"))    { mode=MODE_BAT;   ok=1; col=0; }
        if(0==stricmp(szStr,"ligne"))  { mode=MODE_LIGNE; ok=1; col=0; }
        if(0==stricmp(szStr,"link"))   { mode=MODE_LINK;  ok=1; col=0; }
        if(0==strnicmp(szStr,"var",3)) { mode=MODE_VAR;   ok=1; col=0; strcpy(szVarName,&szStr[4]); }
        if(0==stricmp(szStr,"var_spritefile")) { mode=MODE_SPRITEFILE; ok=1; col=0; }
        //fprintf(pf,"\nmode=%d",mode);

        if(szStr[0]=='#')
        {
            while(fscanf(ps,"%c",&c)!=EOF) { if(c=='\n' || c=='\r') break; }
            ok=1;
            continue;
        }

        if(szStr[0]=='\"') if(   (mode==MODE_TXT) || (mode==MODE_PT) || (mode==MODE_LIGNE) || (mode==MODE_SPRITEFILE)
                              || (mode==MODE_PT2) || (mode==MODE_CARTE2) || (mode==MODE_TR)|| (mode==MODE_BAT) )
        {
    		//fprintf(pd,"%s",szStr);
            if(szStr[1]=='\0') strcpy(szTxtStr,""); else strcpy(szTxtStr,&szStr[1]);
            if(szTxtStr[strlen(szTxtStr)-1]=='\"')
            {
                szTxtStr[strlen(szTxtStr)-1]='\0';
            }
            else  while(fscanf(ps,"%c",&c)!=EOF)
            {
                //fprintf(pd,"%c",c);
                if(c=='\n' || c=='\r' || c=='\"' ) break;
                sz[0]=c; sz[1]='\0';
                strcat(szTxtStr,sz);
            }
            //MessageBox(NULL,szTxtStr,"debug",MB_OK);
            ok=1;
            col++;

            if(mode==MODE_SPRITEFILE) if(col==1)
            {
                strcpy(szSpriteFileName,szTxtStr);
                col=0;
            }

            if(mode==MODE_LIGNE) if(col==4)
            {
                strcpy(szname,szTxtStr);
            }
            if(mode==MODE_LIGNE) if(col==5)
            {
                ligne_init_one(load_ligne,x0_ligne,y0_ligne,szname,szTxtStr);
                col=0;
            }

            if(mode==MODE_TXT) if(col==3)
            {
                strcpy(&szcarte_txt[carte_txt_free],szTxtStr);
                txt[txt_free][IND_TXT_pt_texte]=carte_txt_free;
                carte_txt_free+=strlen(szTxtStr)+1;
            }
            if(mode==MODE_TXT) if(col==4)
            {
                strcpy(&szcarte_txt[carte_txt_free],szTxtStr);
                txt[txt_free][IND_TXT_pt_action]=carte_txt_free;
                carte_txt_free+=strlen(szTxtStr)+1;

                txt[txt_free][IND_TXT_x]=x1;
                txt[txt_free][IND_TXT_y]=y1;
                txt[txt_free][IND_TXT_ligne]=load_ligne;
                col=0;
                txt_free++;
            }

            if(mode==MODE_PT) if(col==9)  //car col++
            {
                strcpy(&szcarte_txt[carte_txt_free],szTxtStr);
                carte_pt[carte_next_pt][CARTE_IND_PT_TXT]=carte_txt_free;
                carte_txt_free+=strlen(szTxtStr)+1;
            }
            if(mode==MODE_PT) if(col==10)  //car col++
            {
                strcpy(&szcarte_txt[carte_txt_free],szTxtStr);
                carte_pt[carte_next_pt][CARTE_IND_PT_ACT]=carte_txt_free;
                carte_txt_free+=strlen(szTxtStr)+1;

                carte_pt[carte_next_pt][CARTE_IND_PT_X]=x_p;
                carte_pt[carte_next_pt][CARTE_IND_PT_Y]=y_p;
                carte_pt[carte_next_pt][CARTE_IND_PT_C]=color;
                carte_pt[carte_next_pt][CARTE_IND_PT_LIGNE]=ligne_no;
                carte_pt[carte_next_pt][CARTE_IND_PT_X_LIGNE]=x_l;
                carte_pt[carte_next_pt][CARTE_IND_PT_Y_LIGNE]=y_l;
                carte_pt[carte_next_pt][CARTE_IND_PT_X_T]=x_t;
                carte_pt[carte_next_pt][CARTE_IND_PT_Y_T]=y_t;
                col=0;
                carte_next_pt++;
                //fprintf(pf,"\nx_p=%d y_p=%d color=%d ligne=%d x_l=%d y_l=%d x_t=%d y_t=%d txt=\"%s\" act=\"%s\""
                //       ,x_p,y_p,color,ligne_no,x_l,y_l,x_t,y_t,&szcarte_txt[carte_pt[carte_next_pt-1][CARTE_IND_PT_TXT]],&szcarte_txt[carte_pt[carte_next_pt-1][CARTE_IND_PT_ACT]]);
            }

            if(mode==MODE_BAT) if(col==7) //car col++
            {
                //fprintf(pf,"\n%d %d %d %d         %d %d",src_x1,src_x2,src_y1,src_y2,pos_x,pos_y);
                bat[bat_free][IND_BAT_SRC_X1]=src_x1;
                bat[bat_free][IND_BAT_SRC_Y1]=src_y1;
                bat[bat_free][IND_BAT_SRC_X2]=src_x2;
                bat[bat_free][IND_BAT_SRC_Y2]=src_y2;
                bat[bat_free][IND_BAT_X]=pos_x;
                bat[bat_free][IND_BAT_Y]=pos_y;
                bat[bat_free][IND_BAT_LIGNE]=load_ligne;
                bat[bat_free][IND_BAT_DISP]=1;
                init_img_filename_bat(bat_free,szTxtStr);
                col=0;
                bat_free++;
            }

            if(mode==MODE_CARTE2) if(col==2)  //car col++
            {
                if(szTxtStr[0]=='\0') carte2_bmp[c2_num]=-1;
                else carte2_bmp[c2_num]=txtBuff_Add(szTxtStr);
                col=0;
            }

            if(mode==MODE_PT2) if(col==3)  //car col++   txt
            {
                if(szTxtStr[0]=='\0') carte2_pt[carte2_next_pt][CARTE2_PT_IND_TXT]=-1;
                else carte2_pt[carte2_next_pt][CARTE2_PT_IND_TXT]=txtBuff_Add(szTxtStr);
            }
            if(mode==MODE_PT2) if(col==4)  //car col++   act
            {
                if(szTxtStr[0]=='\0') carte2_pt[carte2_next_pt][CARTE2_PT_IND_ACT]=-1;
                else carte2_pt[carte2_next_pt][CARTE2_PT_IND_ACT]=txtBuff_Add(szTxtStr);
                carte2_pt[carte2_next_pt][CARTE2_PT_IND_CARTE]=c2_num;
                carte2_pt[carte2_next_pt][CARTE2_PT_IND_X]=x_p2;
                carte2_pt[carte2_next_pt][CARTE2_PT_IND_Y]=y_p2;
                carte2_next_pt++;
                col=0;
            }

            if(mode==MODE_TR) if(col==13)  //car col++   act
            {
                    //fprintf(pf,"\n%d %d %d %d         %d %d %d     %d %d    %d %d %d",src_x1,src_x2,src_y1,src_y2,pos_ligne,pos_x,pos_y,loc,mot,inv_type,inv_aff_init,inv_cmd_init);
                    col=0;

                    // recherche du segment
                    if(loc>=0 || loc==-1) //loco ou wagon, donc attache sur un segment (-2 fixe, -3 container)
                    {
                        seg_no=find_seg_for_sprite(pos_ligne,pos_x,pos_y);
                        if(seg_no==-1)
                        {
                            sprintf(szDebug,"Error in infra inexisting seg for sprite >%d<",sprite_free);
                            MessageBox(NULL,szDebug,"Error",MB_OK);
                            return 0;
                        }
                    }
                    else seg_no=-1;

                    //extraction de la taille du sprite du nom du fichier
                    if(config_version==3)
                    {
                        if(extract_xy_from_filename(szTxtStr,&src_x2,&src_y2)==0)
                        {
                            MessageBox(NULL,"Nom de fichier incorrect (manque la taille _XxY ex: _240x50)","Error",MB_OK);
                            return 0;
                        }
                        src_x1=src_y1=0; src_x2--; src_y2--;
                    }

                    // init
                    sprite_init_one(sprite_free++,src_x1,src_y1,src_x2,src_y2,pos_ligne,pos_x,pos_y,seg_no,loc,mot,inv_type,inv_aff_init,inv_cmd_init,szTxtStr);
            }
        }

      //if(mode==MODE_SCRIPT) if((szStr[0]>='a' && szStr[0]<='z') || (szStr[0]>='A' && szStr[0]<='Z')) { ok=1; strcpy(szVarName,szStr); }

        if((szStr[0]>='0' && szStr[0]<='9') || szStr[0]=='-')
        {
            val=atoi(szStr);
            ok=1;

            if(mode==MODE_SEG)
            {
                if(col==0) x1=val+base_x;
                if(col==1) x2=val+base_x;
                if(col==2) y1=val+base_y;
                if(col==3) y2=val+base_y;
                if(col==4) type=val;
                col++;

                if(col==5)
                {
                    //fprintf(pf,"\nx1=%d y1=%d x2=%d y2=%d type=%d",x1,y1,x2,y2,type);
                    col=0;
                    // remplissage du point 1
                    pt1=-1;
                    for(i=0;i<pt_free;i++) if(pt[i][IND_PT_LIGNE]==load_ligne) if(pt[i][IND_PT_X]==x1 && pt[i][IND_PT_Y]==y1) pt1=i;
                    if(pt1==-1) { pt_init_one(pt_free,load_ligne,x1,y1,-1); pt1=pt_free; pt_free++; }
                    // remplissage du point 2
                    pt2=-1;
                    for(i=0;i<pt_free;i++) if(pt[i][IND_PT_LIGNE]==load_ligne) if(pt[i][IND_PT_X]==x2 && pt[i][IND_PT_Y]==y2) pt2=i;
                    if(pt2==-1) { pt_init_one(pt_free,load_ligne,x2,y2,-1); pt2=pt_free; pt_free++; }
                    // remplissage du segment
                    if(x1<x2) { ptg=pt1; ptd=pt2; } else { ptg=pt2; ptd=pt1; }
                    seg[seg_free][IND_SEG_TYPE]=type; // remplissage du type
                    seg_init_one(seg_free,ptg,ptd); seg_free++;
                }
            }

            if(mode==MODE_LIGNE)
            {
                if(col==0) load_ligne=val%100;
                if(col==1) x0_ligne=val;
                if(col==2) y0_ligne=val;
                col++;
            }

            if(mode==MODE_LINK)
            {
                int i,la,xa,ya,lb,xb,yb,pta,ptb;

                if(col==0) la=val;
                if(col==1) xa=val;
                if(col==2) ya=val;
                if(col==3) lb=val;
                if(col==4) xb=val;
                if(col==5) yb=val;
                col++;
                if(col==6)
                {
                    col=0;
                    pta=-1; for(i=0;i<pt_free;i++) if(pt[i][IND_PT_LIGNE]==la) if(pt[i][IND_PT_X]==xa && pt[i][IND_PT_Y]==ya) pta=i;
                    ptb=-1; for(i=0;i<pt_free;i++) if(pt[i][IND_PT_LIGNE]==lb) if(pt[i][IND_PT_X]==xb && pt[i][IND_PT_Y]==yb) ptb=i;
                    if(pta==-1 || ptb==-1)
                    {
                        sprintf(szDebug,"Erreur dans le fichier du reseau\nAuncun segment pour le lien la=%d xa=%d ya=%d lb=%d xb=%d yb=%d",la,xa,ya,lb,xb,yb);
                        MessageBox(NULL,szDebug,"PST - erreur",MB_OK);
                        return 0;
                    }
                    link[link_free][IND_LINK_PTA]=pta;
                    link[link_free][IND_LINK_PTB]=ptb;
                    pt[pta][IND_PT_AIG]=10000+link_free;
                    pt[ptb][IND_PT_AIG]=10000+link_free;
                    link_free++;
                }
            }

            if(mode==MODE_AIG)
            {
                if(col==0) num=val+base_aig;
                if(col==1) pos=val;
                if(col==2) x_coeur=val+base_x;
                if(col==3) y_coeur=val+base_y;
                if(col==4) x_commun=val+base_x;
                if(col==5) y_commun=val+base_y;
                if(col==6) x_direct=val+base_x;
                if(col==7) y_direct=val+base_y;
                if(col==8) x_devie=val+base_x;
                if(col==9) y_devie=val+base_y;
                col++;
                if(col==10)
                {
                    //fprintf(pf,"\nnum=%d pos=%d %d %d %d %d %d %d %d %d",num,pos,x_coeur,y_coeur,x_commun,y_commun,x_direct,y_direct,x_devie,y_devie);
                    col=0;
                    // recharche des points
                    pt_coeur =-1; for(i=0;i<pt_free;i++) if(pt[i][IND_PT_LIGNE]==load_ligne) if(pt[i][IND_PT_X]==x_coeur  && pt[i][IND_PT_Y]==y_coeur ) pt_coeur=i ;
                    pt_commun=-1; for(i=0;i<pt_free;i++) if(pt[i][IND_PT_LIGNE]==load_ligne) if(pt[i][IND_PT_X]==x_commun && pt[i][IND_PT_Y]==y_commun) pt_commun=i;
                    pt_direct=-1; for(i=0;i<pt_free;i++) if(pt[i][IND_PT_LIGNE]==load_ligne) if(pt[i][IND_PT_X]==x_direct && pt[i][IND_PT_Y]==y_direct) pt_direct=i;
                    pt_devie =-1; for(i=0;i<pt_free;i++) if(pt[i][IND_PT_LIGNE]==load_ligne) if(pt[i][IND_PT_X]==x_devie  && pt[i][IND_PT_Y]==y_devie ) pt_devie=i ;

                    if(pt_coeur==-1 || pt_commun==-1 || pt_direct==-1 || pt_devie==-1)
                    {
                        sprintf(szDebug,"Error in infra inexisting point for aig >%d<\npt_coeur=%d\npt_commun=%d\npt_direct=%d\npt_devie=%d",num,pt_coeur,pt_commun,pt_direct,pt_devie);
                        MessageBox(NULL,szDebug,"Error",MB_OK);
                        return 0;
                    }

                    //recherche des segments
                    seg_commun=-1;
                    seg_direct-1;
                    seg_devie=-1;
                    for(i=0;i<seg_free;i++)
                    {
                        ptg=seg[i][IND_SEG_PT_G]; xg=pt[ptg][IND_PT_X]; yg=pt[ptg][IND_PT_Y];
                        ptd=seg[i][IND_SEG_PT_D]; xd=pt[ptd][IND_PT_X]; yd=pt[ptd][IND_PT_Y];

                        if( xg==x_coeur && yg==y_coeur && xd==x_commun && yd==y_commun ) seg_commun=i;
                        if( xd==x_coeur && yd==y_coeur && xg==x_commun && yg==y_commun ) seg_commun=i;

                        if( xg==x_coeur && yg==y_coeur && xd==x_direct && yd==y_direct ) seg_direct=i;
                        if( xd==x_coeur && yd==y_coeur && xg==x_direct && yg==y_direct ) seg_direct=i;

                        if( xg==x_coeur && yg==y_coeur && xd==x_devie && yd==y_devie ) seg_devie=i;
                        if( xd==x_coeur && yd==y_coeur && xg==x_devie && yg==y_devie ) seg_devie=i;
                    }
                    if(seg_commun==-1 || seg_direct==-1 || seg_devie==-1)
                    {
                        sprintf(szDebug,"Error in infra inexisting seg for aig >%d< seg_commun=%d seg_direct=%d seg_devie=%d",num,seg_commun,seg_direct,seg_devie);
                        MessageBox(NULL,szDebug,"Error",MB_OK);
                        return 0;
                    }

                    //remplissage des informations
                    pt[pt_coeur][IND_PT_AIG]=num;
                    aig[load_ligne][num][IND_AIG_ETAT]=aig[load_ligne][num][IND_AIG_ETAT_INIT]=pos;
                    aig[load_ligne][num][IND_AIG_SEG_COMMUN]=seg_commun;
                    aig[load_ligne][num][IND_AIG_SEG_DIRECT]=seg_direct;
                    aig[load_ligne][num][IND_AIG_SEG_DEVIE]=seg_devie;
                }
            }

            if(mode==MODE_BAT)
            {
                if(col==0) src_x1=val;
                if(col==1) src_y1=val;
                if(col==2) src_x2=val;
                if(col==3) src_y2=val;
                if(col==4) pos_x=val+base_x;
                if(col==5) pos_y=val+base_y;
                col++;
            }

            if(mode==MODE_TR)
            {
                if(col==0) if(config_version==3) col=4;

                if(col==0) src_x1=val;
                if(col==1) src_y1=val;
                if(col==2) src_x2=val;
                if(col==3) src_y2=val;
                if(col==4) pos_ligne=val;
                if(col==5) pos_x=val+base_x;
                if(col==6) pos_y=val+base_y;
                if(col==7) { if(val>=0) loc=val+base_loco; else loc=val; }
                if(col==8) { if(val>=0) mot=val+base_loco; else mot=val; }
                if(col==9) inv_type=val;
                if(col==10) inv_aff_init=val;
                if(col==11) inv_cmd_init=val;
                col++;
            }

            if(mode==MODE_GEO)
            {
                if(col==0) x1=val+base_x;
                if(col==1) x2=val+base_x;
                if(col==2) y1=val+base_y;
                if(col==3) y2=val+base_y;
                if(col==4) forme=val;
                if(col==5) color=val;
                if(col==6) pos=val;
                col++;
                if(col==7)
                {
                    //fprintf(pf,"\n%d %d %d %d     %d %d %d",x1,x2,y1,y2,color,forme,pos);
                    col=0;
                    geo[geo_free][IND_GEO_x1]=x1;
                    geo[geo_free][IND_GEO_x2]=x2;
                    geo[geo_free][IND_GEO_y1]=y1;
                    geo[geo_free][IND_GEO_y2]=y2;
                    geo[geo_free][IND_GEO_color]=color;
                    geo[geo_free][IND_GEO_forme]=forme;
                    geo[geo_free][IND_GEO_pos]=pos;
                    geo[geo_free][IND_GEO_ligne]=load_ligne;
                    geo_free++;
                }
            }

            if(mode==MODE_VAR)
            {
                //fprintf(pf,"\n%var_%s %d",szVarName,val);

                if(!stricmp(szVarName,"x_res"     )) x_res=val;
                if(!stricmp(szVarName,"y_res"     )) y_res=val;
                if(!stricmp(szVarName,"y_panel"   )) panel_base=val;
                if(!stricmp(szVarName,"panel_on"  )) panel_on=val;
                if(!stricmp(szVarName,"zoom_moins")) zoom_moins=val;
                if(!stricmp(szVarName,"use_mask"  )) use_mask=val;
                if(!stricmp(szVarName,"base_x"    )) base_x=val;
                if(!stricmp(szVarName,"base_y"    )) base_y=val;
                if(!stricmp(szVarName,"base_loco" )) base_loco=val;
                if(!stricmp(szVarName,"base_aig"  )) base_aig=val;
                if(!stricmp(szVarName,"start_ligne")) start_ligne=val;
                if(!stricmp(szVarName,"carte_x0"  )) carte_x=val;
                if(!stricmp(szVarName,"carte_y0"  )) carte_y=val;
                if(!stricmp(szVarName,"carte_zoom")) carte_zoom=val;
                if(!stricmp(szVarName,"old_draw"  )) old_draw=val;
                if(!stricmp(szVarName,"config_vers")) config_version=val;
              //if(!stricmp(szVarName,"start_x0"  )) x0=val;  //ne sert plus car un x0/y0 par ligne maintenant
              //if(!stricmp(szVarName,"start_y0"  )) y0=val;
                col=0;
            }

            if(mode==MODE_TXT)
            {
                if(col==0) x1=val+base_x;
                if(col==1) y1=val+base_y;
                col++;
            }

            //line
            if(mode==MODE_LINE)
            {
                if(col==0) x1=val;
                if(col==1) y1=val;
                if(col==2) x2=val;
                if(col==3) y2=val;
                if(col==4) color=val;
                col++;

                if(col==5)
                {
                    //fprintf(pf,"\nx1=%d y1=%d x2=%d y2=%d color=%d",x1,y1,x2,y2,color);
                    col=0;
                    carte_seg[carte_next_seg][CARTE_IND_SEG_X1]=x1;
                    carte_seg[carte_next_seg][CARTE_IND_SEG_Y1]=y1;
                    carte_seg[carte_next_seg][CARTE_IND_SEG_X2]=x2;
                    carte_seg[carte_next_seg][CARTE_IND_SEG_Y2]=y2;
                    carte_seg[carte_next_seg][CARTE_IND_SEG_C]=color;
                    carte_next_seg++;
                }
            }

            //pt
            //x_point,y_point,color,line,line_x,line_y,x_texte,y_texte,"texte/action si line=-1",
            if(mode==MODE_PT)
            {
                if(col==0) x_p=val;
                if(col==1) y_p=val;
                if(col==2) color=val;
                if(col==3) ligne_no=val;
                if(col==4) x_l=val;
                if(col==5) y_l=val;
                if(col==6) x_t=val;
                if(col==7) y_t=val;
                col++;
            }

            if(mode==MODE_PT2)
            {
                if(col==0) x_p2=val;
                if(col==1) y_p2=val;
                col++;
            }
            
            if(mode==MODE_CARTE2)
            {
                if(col==0) c2_num=val;
                col++;
            }

          //if(mode==MODE_SCRIPT) ...
        }

        if(ok==0)
        {
            sprintf(szDebug,"Erreur dans le fichier du reseau\nsur la chaine >%s<",szStr);
            MessageBox(NULL,szDebug,"PST - Erreur",MB_OK);
            return 0;
        }
    }

    fclose(ps);

    return 1;
}

char szHelpFile[1000];
char szHelpDocFile[1000];
void compute_help_file_path(void)
{
    char* pc;

    /*
    // ex "c:\prog\pst\france\france.txt" -> "c:\prog\pst\aide.txt"
    strcpy(szHelpFile,szInfraFileName);
    pc=&szHelpFile[strlen(szHelpFile)-1];
    while((*pc)!='\\') pc--;
    pc--;
    while((*pc)!='\\') pc--;
    *(pc+1)='\0';
    strcpy(szHelpDocFile,szHelpFile);
    strcat(szHelpFile,"aide.txt");
    strcat(szHelpDocFile,"aide.doc");
    //MessageBox(NULL,szHelpFile,"szHelpFile",MB_OK);
    //MessageBox(NULL,szHelpDocFile,"szHelpdocFile",MB_OK);
    */
    sprintf(szHelpFile,"%s%s",szBasePstDir,"aide.txt");
    sprintf(szHelpDocFile,"%s%s",szBasePstDir,"aide.doc");
}

int save_work(void)
{
    FILE* pz;
    int save_pos_aig=0; int save_pos_tr=0; int save_pos_view=0;

    // choix du fichier de sauvegarde (met a jour szInfraFileName)
    SelectInfraFileSaveAs();

    // choix des sauvegardes
    save_pos_aig=0; if(MessageBox(ghwnd,"Voulez vous sauver la position actuel des aiguillages ?\nYES: conserve la position actuelle des aiguilles\nNO: restaure et sauvegarde la postion initiale des aiguilles","PST",MB_YESNO)==IDYES) save_pos_aig=1;
    save_pos_tr=0;  if(MessageBox(ghwnd,"Voulez vous sauver la position actuel des trains ?\nYES: conserve la position actuelle des trains\nNO: restaure et sauvegarde la postion initiale des trains","PST",MB_YESNO)==IDYES) save_pos_tr=1;
    save_pos_view=0;if(MessageBox(ghwnd,"Voulez vous sauver la position actuel des vues ?\nYES: conserve la position actuelle des vues\nNO: restaure et sauvegarde la postion initiale des vues","PST",MB_YESNO)==IDYES) save_pos_view=1;

    // creation du fichier du reseau (car les fonction save sont en append)
    pz=fopen(szInfraFileName,"wt");
    fprintf(pz,  "#======================================");
    fprintf(pz,"\n#==    Fichier de reseau PST v2.0    ==");
    fprintf(pz,"\n#======================================\n\n");
    fclose(pz);

    // sauvegardes en append
    save_var(save_pos_view);
    //carte_save();
    carte2_save();
    save_seg_aig_geo_bat_txt_link(save_pos_aig,save_pos_view);
    save_sprite(save_pos_tr);
    save_stat();
}

char szScriptFileName[1000];
int load_script(void)
{
    FILE* ps;  // fichier source
    char szStr[1024]; char szTxtStr[1024]; char sz[1024];
    char c;
    int mode,i,ok,val;

    SelectInfraFileOpen();

    strcpy(szScriptFileName,szInfraFileName);

    ps=fopen(szInfraFileName,"rt");
    if(ps==NULL) { MessageBox(NULL,"Cannot open the script file","Error",MB_OK); return 0; }

    mode=MODE_SCRIPT; script_debug_on=0;

    while(fscanf(ps," %s",szStr)!=EOF)
    {
        ok=0;

        if(0==stricmp(szStr,"end"))        { ok=1; break; }
        if(0==stricmp(szStr,"script"))     { mode=MODE_SCRIPT;  ok=1; }
        if(0==stricmp(szStr,"sect_on"))    { mode=MODE_SCRIPT;  ok=1; }
        if(0==stricmp(szStr,"sect_off"))   { mode=-1;           ok=1; }

        if(szStr[0]=='#')
        {
            while(fscanf(ps,"%c",&c)!=EOF) { if(c=='\n' || c=='\r') break; }
            ok=1;
            continue;
        }

        if(mode==-1) continue;

        if(0==stricmp(szStr,"debug_on"))   { script_debug_on=1; ok=1; }

        if(szStr[0]=='\"') // met la chaine dans szTxtStr
        {
            if(szStr[1]=='\0') strcpy(szTxtStr,""); else strcpy(szTxtStr,&szStr[1]);
            if(szTxtStr[strlen(szTxtStr)-1]=='\"')
            {
                szTxtStr[strlen(szTxtStr)-1]='\0';
            }
            else  while(fscanf(ps,"%c",&c)!=EOF)
            {
                if(c=='\n' || c=='\r' || c=='\"' ) break;
                sz[0]=c; sz[1]='\0';
                strcat(szTxtStr,sz);
            }

            if(mode==MODE_SCRIPT) if(!stricmp(szVarName,"sound"))
            {
                script_tab[script_tab_next][SCRIPT_TAB_IND_ORDRE]=SCRIPT_ORDRE_SOUND;

                strcpy(&szcarte_txt[carte_txt_free],szTxtStr);
                script_tab[script_tab_next][SCRIPT_TAB_IND_VAL]=carte_txt_free;
                carte_txt_free+=strlen(szTxtStr)+1;

                script_tab_next++; ok=1;
            }
        }

        if(mode==MODE_SCRIPT) if((szStr[0]>='a' && szStr[0]<='z') || (szStr[0]>='A' && szStr[0]<='Z')) { ok=1; strcpy(szVarName,szStr); }

        if((szStr[0]>='0' && szStr[0]<='9') || szStr[0]=='+' || szStr[0]=='-')
        {
            val=atoi(szStr);
            ok=1;

            if(mode==MODE_SCRIPT)
            {
                //fprintf(pd,"\n%s %d",szVarName,val);

                ok=0;
                if(!stricmp(szVarName,"loco"        )) { ok=1; script_tab[script_tab_next][SCRIPT_TAB_IND_ORDRE]=SCRIPT_ORDRE_LOCO;    }
                if(!stricmp(szVarName,"vit"         )) { ok=1; script_tab[script_tab_next][SCRIPT_TAB_IND_ORDRE]=SCRIPT_ORDRE_VIT;
                                                         if( (val%10)!=0 ) { ok=0; MessageBox(NULL,"Les vitesses doivent etre multipls de 10km/h","PST - Erreur",MB_OK);}
                                                         val=val/10; } //km/h -> cran
                if(!stricmp(szVarName,"wait_t"      )) { ok=1; script_tab[script_tab_next][SCRIPT_TAB_IND_ORDRE]=SCRIPT_ORDRE_WAITT;   }
                if(!stricmp(szVarName,"wait_m"      )) { ok=1; script_tab[script_tab_next][SCRIPT_TAB_IND_ORDRE]=SCRIPT_ORDRE_WAITM;   }
                if(!stricmp(szVarName,"wait_hm"     )) { ok=1; script_tab[script_tab_next][SCRIPT_TAB_IND_ORDRE]=SCRIPT_ORDRE_WAITH;   }
                if(!stricmp(szVarName,"wait_sx"     )) { ok=1; script_tab[script_tab_next][SCRIPT_TAB_IND_ORDRE]=SCRIPT_ORDRE_WAITSX;  }
                if(!stricmp(szVarName,"wait_ix"     )) { ok=1; script_tab[script_tab_next][SCRIPT_TAB_IND_ORDRE]=SCRIPT_ORDRE_WAITIX;  }
                if(!stricmp(szVarName,"horo_stophm" )) { ok=1; script_tab[script_tab_next][SCRIPT_TAB_IND_ORDRE]=SCRIPT_ORDRE_BLOCKH;  }
                if(!stricmp(szVarName,"horo_hm"     )) { ok=1; script_tab[script_tab_next][SCRIPT_TAB_IND_ORDRE]=SCRIPT_ORDRE_HOROSETDHM; }
                if(!stricmp(szVarName,"horo_ticmin" )) { ok=1; script_tab[script_tab_next][SCRIPT_TAB_IND_ORDRE]=SCRIPT_ORDRE_HOROSETTIC; }
                if(!stricmp(szVarName,"aig_dir"     )) { ok=1; script_tab[script_tab_next][SCRIPT_TAB_IND_ORDRE]=SCRIPT_ORDRE_AIGDIR;  }
                if(!stricmp(szVarName,"aig_dev"     )) { ok=1; script_tab[script_tab_next][SCRIPT_TAB_IND_ORDRE]=SCRIPT_ORDRE_AIGDEV;  }
                if(!stricmp(szVarName,"accr"        )) { ok=1; script_tab[script_tab_next][SCRIPT_TAB_IND_ORDRE]=SCRIPT_ORDRE_ACCR;    }
                if(!stricmp(szVarName,"decr"        )) { ok=1; script_tab[script_tab_next][SCRIPT_TAB_IND_ORDRE]=SCRIPT_ORDRE_DECR;    }
                if(!stricmp(szVarName,"inv"         )) { ok=1; script_tab[script_tab_next][SCRIPT_TAB_IND_ORDRE]=SCRIPT_ORDRE_INV;     }
                if(!stricmp(szVarName,"ligne_aig"   )) { ok=1; script_tab[script_tab_next][SCRIPT_TAB_IND_ORDRE]=SCRIPT_ORDRE_AIGLIGNE;}
                if(!stricmp(szVarName,"loco_aigauto")) { ok=1; script_tab[script_tab_next][SCRIPT_TAB_IND_ORDRE]=SCRIPT_ORDRE_AIGLOCOTAB; }
                if(!stricmp(szVarName,"ch_end"      )) { ok=1; script_tab[script_tab_next][SCRIPT_TAB_IND_ORDRE]=SCRIPT_ORDRE_CHEND;   }
                if(!stricmp(szVarName,"ch_bcl"      )) { ok=1; script_tab[script_tab_next][SCRIPT_TAB_IND_ORDRE]=SCRIPT_ORDRE_CHBCL;   }
                if(!stricmp(szVarName,"ch"          )) { ok=1; script_tab[script_tab_next][SCRIPT_TAB_IND_ORDRE]=SCRIPT_ORDRE_CH;
                                                            script_ch[val][SCRIPT_CH_IND_PT   ]=script_tab_next;
                                                            script_ch[val][SCRIPT_CH_IND_PTDEB]=script_tab_next;                      }

                script_tab[script_tab_next][SCRIPT_TAB_IND_VAL]=val;

                script_tab_next++;
            }
        }

        if(ok==0)
        {
            sprintf(szDebug,"Erreur dans le fichier du script\nsur la chaine >%s<",szStr);
            MessageBox(NULL,szDebug,"PST - Erreur",MB_OK);
            return 0;
        }
    }

    fclose(ps);

    /**/script_debug();

    return 1;
}


//-----------------------------------------------------------------
// CREATION DE LIGNE EN FONCTION DES INFOS SUR LES LIGNES DE WIKIPEDIA
//-----------------------------------------------------------------

char szWikipediaLigne[1000];
int wikipedia_ligne[1000][4];
#define IND_WIKIPEDIA_LIGNE_PK   0
#define IND_WIKIPEDIA_LIGNE_TXT  1
#define IND_WIKIPEDIA_LIGNE_LEN  2
#define IND_WIKIPEDIA_LIGNE_TYPE 3
#define WP_RIEN       -1
#define WP_TUNNEL     1
#define WP_PONTVIADUC 2
#define WP_PASSAGE    3
#define WP_INFO       4
#define WP_GARE       5
int wikipedia_ligne_free=0;

int get_pk(char sz[])
{
     int km,m,i,len,ind;
     char c;
     char* pc;

     len=strlen(sz);
     if((pc=strstr(sz,","))==NULL) return -1;
     ind=pc-sz;
     i=ind-1; if(i<0 || i>=len) return -1; if(sz[i]<'0' || sz[i]>'9') return -1;
     i=ind+1; if(i<0 || i>=len) return -1; if(sz[i]<'0' || sz[i]>'9') return -1;
     i=ind+2; if(i<0 || i>=len) return -1; if(sz[i]<'0' || sz[i]>'9') return -1;
     i=ind+3; if(i<0 || i>=len) return -1; if(sz[i]<'0' || sz[i]>'9') return -1;

     sscanf(sz,"%d%c%d",&km,&c,&m);
     return (1000*km+m)*10; //car resolution pst de dix centimetres
}

// reduction de la taille des lignes
// garde les 50 premiers metres sans reduction
// puis reduit fortement jusqua 1km par ecran de 1000 pixels
int reduce_keep_500(int dist)
{
    if(dist<=500  ) return dist;                       //0  + 0/500
    if(dist<=1000 ) return 500+(200*(dist-500))/500;   //500+ 0/200
    if(dist<=5000 ) return 700+(150*(dist-1000))/4000; //700+ 0/150
    if(dist<=10000) return 850+(150*(dist-5000))/5000; //850+ 0/150
    return dist/10; //dist >10000                      //1000 + ...
}

int reduce(int dist)
{
    return reduce_keep_500(dist);
}

// reduction de la taille des lignes
// garde les 100 premiers metres sans reduction
// les 101-999m ne retournent aucun pixel
// puis reduit fortement jusqua 1km par ecran de 1000 pixels
// surtout utilise apres un ouvrage ou une gare
int reduce_keep_1000(int dist)
{
    if(dist<=1000 ) return dist;                       //0  + 0/1000
    if(dist<=10000) return 1000;
    return dist/10; //dist >10000                      //1000 + ...
}

int reduce_after_ouvrage_gare(int dist)
{
    return reduce_keep_1000(dist);
}

/*
{
    FILE* pj;
    pj=fopen("debug_wp.txt","at");
    fprintf(pj,"\ntxt wp l=%d x=%d y=%d txt=\"%s\"",copcol_ld,x,y+50,&szcarte_txt[wikipedia_ligne[i][IND_WIKIPEDIA_LIGNE_TXT]]);
    fclose(pj);
}
*/

void process_wikipedia_ligne(void)
{
    FILE* ps;
    int i,j,x,y,dx,pk,len,len1000,len1,len_used,t,tseg,carte_txt_null;
    char szName[1000]; char szStr[1000]; char szPk[1000];
    int isDoubleLigne,dispPk,createLeft,reduireDimLigne,reduireDimOuvrage;
    int stat_seg,stat_txt,stat_gare,stat_tunnel,stat_pont;
    int ouvrage_ou_gare;

    stat_seg=stat_txt=stat_gare=stat_tunnel=stat_pont=0;

    //0. point de depart en fonction de la position du curseur
    x=grip_50(x0+x_mouse_move); y=grip_50(y0+y_mouse_move);

    //1. selection du fichier et questions de base
    SelectInfraFileOpen();
    strcpy(szWikipediaLigne,szInfraFileName);

    ps=fopen(szInfraFileName,"rt");
    if(ps==NULL) { MessageBox(NULL,"Cannot open the specified Wikipedia track file","Error",MB_OK); return; }

    isDoubleLigne=0;
    if(MessageBox(ghwnd,"Est ce une ligne a 2 voies ?\n\nYES - Double voie\nNO - Voie unique","PST",MB_YESNO)==IDYES) isDoubleLigne=1;

    dispPk=0;
    if(MessageBox(ghwnd,"Voulez vous afficher les pk ?\n\nYES - Afficher les PK\nNO - Ne pas afficher les PK","PST",MB_YESNO)==IDYES) dispPk=1;

    createLeft=0;
    if(MessageBox(ghwnd,"Voulez vous creer la voie a gauche de la cible ?\n\nYES - Creer la voie a gauche de la cible\nNO - Creer la voie a droite de la cible","PST",MB_YESNO)==IDYES) createLeft=1;

    reduireDimLigne=0;
    if(MessageBox(ghwnd,"Voulez vous reduire les dimensions de la ligne ?\n\nYES - Reduire les dimensions de la ligne (plus agreable a jouer)\nNO - Conserver les dimensions de la ligne (plus realiste)","PST",MB_YESNO)==IDYES) reduireDimLigne=1;

    reduireDimOuvrage=0;
    if(reduireDimLigne==1)
    if(MessageBox(ghwnd,"Voulez vous reduire les dimensions des ouvrages ?\n\nYES - Reduire les dimensions des ouvrages (plus agreable a jouer)\nNO - Conserver les dimensions des ouvrages (plus realiste)","PST",MB_YESNO)==IDYES) reduireDimOuvrage=1;

    //2. extraction des infos du fichier pour remplir le tableau
    wikipedia_ligne_free=-1;
    while(fscanf(ps," %s",szStr)!=EOF)
    {
        pk=get_pk(szStr);
        if(pk!=-1)
        {
            sprintf(szPk,"pk %s",szStr);
            wikipedia_ligne_free++;
            wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_PK]=pk;
            wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TXT]=-1;
            wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_LEN]=-1;
            wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=-1;
            strcpy(szName,"");
        }
        else
        {
            if(wikipedia_ligne_free!=-1)
            {
                if(szName[0]=='\0')
                {
                    if(dispPk==1) sprintf(szName,"%s ",szPk);
                    strcat(szName,szStr);

                    strcpy(&szcarte_txt[carte_txt_free],szName);
                    wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TXT]=carte_txt_free;
                    carte_txt_free+=strlen(szName)+1;

                    if(0==stricmp(szStr,"tunnel" )) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_TUNNEL;
                    if(0==stricmp(szStr,"t."     )) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_TUNNEL;
                    if(0==stricmp(szStr,"galerie")) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_TUNNEL;

                    if(0==strnicmp(szStr,"pont",4)) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_PONTVIADUC;
                    if(0==stricmp(szStr,"pt"     )) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_PONTVIADUC;
                    if(0==stricmp(szStr,"pt."    )) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_PONTVIADUC;
                    if(0==stricmp(szStr,"p."     )) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_PONTVIADUC;
                    if(0==stricmp(szStr,"viaduc" )) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_PONTVIADUC;
                    if(0==stricmp(szStr,"v."     )) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_PONTVIADUC;
                    if(0==stricmp(szStr,"(sur"   )) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_PONTVIADUC;
                    if(0==stricmp(szStr,"petit"  )) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_PONTVIADUC;
                    if(0==stricmp(szStr,"grand"  )) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_PONTVIADUC;
                    if(0==stricmp(szStr,"canal"  )) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_PONTVIADUC;
                    if(0==stricmp(szStr,"canalet")) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_PONTVIADUC;
                    if(0==stricmp(szStr,"bras"   )) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_PONTVIADUC;
                    if(0==stricmp(szStr,"decharge")) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_PONTVIADUC;
                    if(0==stricmp(szStr,"dcharge")) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_PONTVIADUC;
                    if(0==stricmp(szStr,"riviere")) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_PONTVIADUC;
                    if(0==stricmp(szStr,"rivire")) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_PONTVIADUC;
                    if(0==stricmp(szStr,"passerelle")) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_PONTVIADUC;
                  //if(0==stricmp(szStr,"passage")) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_PONTVIADUC;
                  //if(0==stricmp(szStr,"passage")) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_PASSAGE;

                    if(0==stricmp(szStr,"passage")) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_TUNNEL;
                    if(0==stricmp(szStr,"souterrain")) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_TUNNEL;
                    if(0==stricmp(szStr,"grand tunnel")) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_TUNNEL;
                    if(0==stricmp(szStr,"petit tunnel")) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_TUNNEL;


                    if(0==stricmp(szStr,"limite" )) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_INFO;
                    if(0==stricmp(szStr,"vers"   )) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_INFO;
                    if(0==stricmp(szStr,"info"   )) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_INFO;
                    if(0==strnicmp(szStr,"bif",3 )) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_INFO;
                    if(0==strnicmp(szStr,"rac",3 )) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_INFO;
                    if(0==stricmp(szStr,"triage" )) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_INFO;
                    if(0==stricmp(szStr,"tgv"    )) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_INFO;
                    if(0==stricmp(szStr,"lgv"    )) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_INFO;
                    if(0==stricmp(szStr,"port"   )) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_INFO;
                    if(0==strnicmp(szStr,"fronti",6 )) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_INFO;

                    if(wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]==-1) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_TYPE]=WP_GARE;
                }
                else
                {
                    strcat(szName,""); strcat(szName,szStr);
                    carte_txt_free--;
                    strcpy(&szcarte_txt[carte_txt_free]," "); carte_txt_free++;
                    strcpy(&szcarte_txt[carte_txt_free],szStr); carte_txt_free+=strlen(szStr)+1;
                }

                if(szStr[0]=='(' && szStr[1]>='0' && szStr[1]<='9') sscanf(&szStr[1],"%d",&len);
                if(0==stricmp(szStr,"m)")) wikipedia_ligne[wikipedia_ligne_free][IND_WIKIPEDIA_LIGNE_LEN]=len;
            }
        }
    }
    wikipedia_ligne_free++;

    for(i=0;i<wikipedia_ligne_free;i++)
    {
        strcpy(szName,"");
        if(wikipedia_ligne[i][IND_WIKIPEDIA_LIGNE_TXT]!=-1) strcpy(szName,&szcarte_txt[wikipedia_ligne[i][IND_WIKIPEDIA_LIGNE_TXT]]);
        fprintf(pf,"\n%d: pk=%d type=%d len=%d name=\"%s\"",i
                                               ,wikipedia_ligne[i][IND_WIKIPEDIA_LIGNE_PK]
                                               ,wikipedia_ligne[i][IND_WIKIPEDIA_LIGNE_TYPE]
                                               ,wikipedia_ligne[i][IND_WIKIPEDIA_LIGNE_LEN]
                                               ,szName);
    }

    if(wikipedia_ligne_free==0) return;

    //3. utilisation du tableau pour creer la ligne
    //x=copcol_xd; y=copcol_yd; //ligne copcol_ld; remplace par x_mouse_mouve au tout debut

    strcpy(&szcarte_txt[carte_txt_free],""); carte_txt_null=carte_txt_free; carte_txt_free++;

    for(i=0;i<wikipedia_ligne_free;i++)
    {
        t=wikipedia_ligne[i][IND_WIKIPEDIA_LIGNE_TYPE];
        if(t==WP_GARE       ) stat_gare++;
        if(t==WP_TUNNEL     ) stat_tunnel++;
        if(t==WP_PONTVIADUC ) stat_pont++;

        // affichage du texte
        if(wikipedia_ligne[i][IND_WIKIPEDIA_LIGNE_TXT]!=-1)
        {
            txt[txt_free][IND_TXT_ligne]=current_ligne;
            txt[txt_free][IND_TXT_x]=x;
            if(createLeft) txt[txt_free][IND_TXT_x]=x-10*strlen(&szcarte_txt[wikipedia_ligne[i][IND_WIKIPEDIA_LIGNE_TXT]]);
            txt[txt_free][IND_TXT_y]=y+50; if(isDoubleLigne) txt[txt_free][IND_TXT_y]+=50; if(t==WP_INFO) txt[txt_free][IND_TXT_y]+=20;
            txt[txt_free][IND_TXT_pt_texte]=wikipedia_ligne[i][IND_WIKIPEDIA_LIGNE_TXT];
            txt[txt_free][IND_TXT_pt_action]=carte_txt_null;
            txt_free++;
            stat_txt++;
        }
        fprintf(pf,"\ntxt wp l=%d x=%d y=%d txt=\"%s\"",current_ligne,x,y+50,&szcarte_txt[wikipedia_ligne[i][IND_WIKIPEDIA_LIGNE_TXT]]);

        // affichage du segment ouvrage (tunnel ou pont/viaduc)
        ouvrage_ou_gare=0;
        t=wikipedia_ligne[i][IND_WIKIPEDIA_LIGNE_TYPE];
        tseg=SEG_TYPE_NORMAL;
        if(t==WP_TUNNEL    ) tseg=SEG_TYPE_TUNEL;
        if(t==WP_PONTVIADUC) tseg=SEG_TYPE_PONT_METAL_B;

        if(t==WP_TUNNEL || t==WP_PONTVIADUC)
        {
            len=wikipedia_ligne[i][IND_WIKIPEDIA_LIGNE_LEN]*10; //en 10cm
            //if(len==-1) len=0;
            if(len<0) len=500; //longueur par defaut 50m
            ouvrage_ou_gare=1;
            len_used=len; //avant reduction
            if(reduireDimOuvrage) len=reduce(len);
            len=grip_50(len);
            len1000=len/1000;
            len1   =len%1000;
            stat_seg+=len1000; if(len1) stat_seg++; if(isDoubleLigne) { stat_seg+=len1000; if(len1) stat_seg++; }
            if(createLeft==0)
            {
                if(isDoubleLigne) //voie du bas en 1er car mieux pour les tunnels
                {
                for(j=0;j<len1000;j++) new_seg_lxy(current_ligne,x+j*1000      ,y+50,  current_ligne,x+j*1000+1000      ,y+50,  tseg);
                if(len1!=0)            new_seg_lxy(current_ligne,x+len1000*1000,y+50,  current_ligne,x+len1000*1000+len1,y+50,  tseg);
                }
                for(j=0;j<len1000;j++) new_seg_lxy(current_ligne,x+j*1000      ,y,     current_ligne,x+j*1000+1000      ,y,     tseg);
                if(len1!=0)            new_seg_lxy(current_ligne,x+len1000*1000,y,     current_ligne,x+len1000*1000+len1,y,     tseg);
                x+=len;
            }
            if(createLeft==1)
            {
                if(isDoubleLigne) //voie du bas en 1er car mieux pour les tunnels
                {
                for(j=0;j<len1000;j++) new_seg_lxy(current_ligne,x-j*1000      ,y+50,  current_ligne,x-j*1000-1000      ,y+50,  tseg);
                if(len1!=0)            new_seg_lxy(current_ligne,x-len1000*1000,y+50,  current_ligne,x-len1000*1000-len1,y+50,  tseg);
                }
                for(j=0;j<len1000;j++) new_seg_lxy(current_ligne,x-j*1000      ,y,     current_ligne,x-j*1000-1000      ,y,     tseg);
                if(len1!=0)            new_seg_lxy(current_ligne,x-len1000*1000,y,     current_ligne,x-len1000*1000-len1,y,     tseg);
                x-=len;
            }
        }

        // affichage des gares (200m)
        if(t==WP_GARE)
        {
            len=2000; len1000=len/1000; len1=0; len_used=len; ouvrage_ou_gare=1;
            if(createLeft==0)
            {
                tseg=SEG_TYPE_QUAI_H;
                for(j=0;j<len1000;j++) { new_seg_lxy(current_ligne,x+j*1000 ,y,    current_ligne,x+j*1000+1000 ,y,    tseg); }
                if(isDoubleLigne)
                {
                tseg=SEG_TYPE_QUAI_B;
                for(j=0;j<len1000;j++) { new_seg_lxy(current_ligne,x+j*1000 ,y+50, current_ligne,x+j*1000+1000 ,y+50, tseg); }
                }
                x+=len;
            }
            if(createLeft==1)
            {
                tseg=SEG_TYPE_QUAI_H;
                for(j=0;j<len1000;j++) { new_seg_lxy(current_ligne,x-j*1000 ,y,    current_ligne,x-j*1000-1000 ,y,    tseg); }
                if(isDoubleLigne)
                {
                tseg=SEG_TYPE_QUAI_B;
                for(j=0;j<len1000;j++) { new_seg_lxy(current_ligne,x-j*1000 ,y+50, current_ligne,x-j*1000-1000 ,y+50, tseg); }
                }
                x-=len;
            }
            tseg=0; //fin de gare
        }

        // affichage des segments non ouvrages ou du reste du degment pour les ouvrages (dont 100 si gare)
        if((i+1)==wikipedia_ligne_free) break; //fin de ligne;

        tseg=SEG_TYPE_NORMAL;

        dx=wikipedia_ligne[i+1][IND_WIKIPEDIA_LIGNE_PK]-wikipedia_ligne[i][IND_WIKIPEDIA_LIGNE_PK];
        if(dx<0) dx=-dx;
        len=dx-len_used; //-longueur deja utilisee
        if(len<0) len=0;
        if(reduireDimLigne)
        {
            if(ouvrage_ou_gare) len=reduce_after_ouvrage_gare(len); // laisse 1 ecran au moins si >100m (commenter si ne convient pas)
            else len=reduce(len);
        }
        len=grip_50(len);
        len1000=len/1000;
        len1   =len%1000; //UU: si len1000==0 et gare ou ouvrage alors reduction speciale (ne pas changer 0-100m)
        stat_seg+=len1000; if(len1) stat_seg++; if(isDoubleLigne) { stat_seg+=len1000; if(len1) stat_seg++; }

        if(createLeft==0)
        {
            //if(t==WP_GARE) tseg=SEG_TYPE_QUAI_H;
            for(j=0;j<len1000;j++) { new_seg_lxy(current_ligne,x+j*1000      ,y,     current_ligne,x+j*1000+1000      ,y,     tseg); /*tseg=0;*/ }  //fin de gare
            if(len1!=0)            { new_seg_lxy(current_ligne,x+len1000*1000,y,     current_ligne,x+len1000*1000+len1,y,     tseg); /*tseg=0;*/ }
            if(isDoubleLigne)
            {
            //if(t==WP_GARE) tseg=SEG_TYPE_QUAI_B;
            for(j=0;j<len1000;j++) { new_seg_lxy(current_ligne,x+j*1000      ,y+50,  current_ligne,x+j*1000+1000      ,y+50,  tseg); /*tseg=0;*/ }  //fin de gare
            if(len1!=0)            { new_seg_lxy(current_ligne,x+len1000*1000,y+50,  current_ligne,x+len1000*1000+len1,y+50,  tseg); /*tseg=0;*/ }
            }
            x+=len;
        }
        if(createLeft==1)
        {
            //if(t==WP_GARE) tseg=SEG_TYPE_QUAI_H;
            for(j=0;j<len1000;j++) { new_seg_lxy(current_ligne,x-j*1000      ,y,     current_ligne,x-j*1000-1000      ,y,     tseg); /*tseg=0;*/ }  //fin de gare
            if(len1!=0)            { new_seg_lxy(current_ligne,x-len1000*1000,y,     current_ligne,x-len1000*1000-len1,y,     tseg); /*tseg=0;*/ }
            if(isDoubleLigne)
            {
            //if(t==WP_GARE) tseg=SEG_TYPE_QUAI_B;
            for(j=0;j<len1000;j++) { new_seg_lxy(current_ligne,x-j*1000      ,y+50,  current_ligne,x-j*1000-1000      ,y+50,  tseg); /*tseg=0;*/ }  //fin de gare
            if(len1!=0)            { new_seg_lxy(current_ligne,x-len1000*1000,y+50,  current_ligne,x-len1000*1000-len1,y+50,  tseg); /*tseg=0;*/ }
            }
            x-=len;
        }

        // affichage geo si passage WP_PASSAGE (plus besoin, affichage comme un pont)
     }

    fclose(ps);

    sprintf(szDebug,"\nStat:\nL_WP=%d SEG=%d TXT=%d GARE=%d TUNNEL=%d VIADUC/PONT=%d",wikipedia_ligne_free,stat_seg,stat_txt,stat_gare,stat_tunnel,stat_pont);

    disp_seg_geo_txt_bat_fill(1); disp_sprite_fill(1); fill_pt_sega_segb();
}


// table des menus (la copier et maintenir a jour ds le fichier des ressources)
#define CM_EXIT              900
#define CM_SAVE              901
#define CM_SCRIPT_LOAD       905
#define CM_PAUSE             906
#define CM_HELP              902
#define CM_HELP_DOC          903
#define CM_ABOUT             904
#define CM_TXT_VAL           907
#define CM_MAP_AFF           926
#define CM_MAP_SEL_0         908
#define CM_MAP_SEL_N         909
#define CM_MAP_PT_ON         910
#define CM_MAP_PT_CLI        911
#define CM_MAP_PT_INS        912
#define CM_MAP_PT_DEL        913
#define CM_MAP_PT_EXE        914
#define CM_MAP_LD_IMG        915
#define CM_MAP_RM_IMG        916
#define CM_MAP_EXIT          917
#define CM_TR_ADD            918
#define CM_TR_ADD_RIGHT      919
#define CM_TR_ADD_LEFT       920
#define CM_TR_ADD_RIGHT_SAME 921
#define CM_TR_ADD_LEFT_SAME  922
#define CM_TR_ADD_VAL        923
#define CM_TR_DEL            924
#define CM_TR_INV            925
#define CM_BAT_DEL           930
#define CM_BAT_ADD_SEL_DIM   931
#define CM_BAT_ADD_VAL       932
#define CM_BAT_MASK_UNMASK   933
#define CM_BAT_MASK_UNMASK_ALL 934
#define CM_BAT_ADD_POSE      935
#define CM_LIGNE_GO          940
#define CM_LIGNE_GO_0        941
#define CM_LIGNE_GO_N        942
#define CM_LIGNE_AFF_LISTE   943
#define CM_LIGNE_X0_Y0       944
#define CM_LIGNE_NEW         945
#define CM_TR_AFF_LISTE      946
#define CM_EDIT_ON           947
#define CM_EDIT_ADD_SEG      948
#define CM_EDIT_ADD_AIG      949
#define CM_EDIT_ADD_GEO      950
#define CM_EDIT_ADD_TXT      951
#define CM_EDIT_COPCOL_PT_SUP_LEFT  952
#define CM_EDIT_COPCOL_PT_INF_RIGHT 953
#define CM_EDIT_COPCOL_ORG   954
#define CM_EDIT_COPCOL_DST   955
#define CM_EDIT_COPCOL_DEL   956
#define CM_EDIT_COPCOL_MOVE  957
#define CM_EDIT_IMPORT_WP    958
#define CM_AFF_TXT           960
#define CM_AFF_VOIES_OLD_ROUGE 962
#define CM_AFF_VOIES_OLD_NOIR  963
#define CM_AFF_VOIES_OLD_OFF 964
#define CM_AFF_GRID          965
#define CM_AFF_PANEL         966
#define CM_AFF_SEL_RES       967
#define CM_AFF_VAL_RES       968
#define CM_AFF_CAM_ON        969
#define CM_AFF_CAM_Y         970
#define CM_LIGNE_NAME        971
#define CM_LIGNE_NAME_VAL    972
int en_edition=0;
int txtedit=0;
int simu_exe=1;

void update_menu_check(void)
{
    HMENU hm; hm=GetMenu(ghwnd);

    if(carte2_aff_pt) CheckMenuItem(hm,CM_MAP_PT_ON,MF_CHECKED); else CheckMenuItem(hm,CM_MAP_PT_ON,MF_UNCHECKED);
    if(carte2_cli_pt) CheckMenuItem(hm,CM_MAP_PT_CLI,MF_CHECKED); else CheckMenuItem(hm,CM_MAP_PT_CLI,MF_UNCHECKED);

    //if(carte2_att==CARTE2_ATT_NOP) { CheckMenuItem(hm,CM_MAP_PT_EXE,MF_CHECKED);   CheckMenuItem(hm,CM_MAP_PT_INS,MF_UNCHECKED); CheckMenuItem(hm,CM_MAP_PT_DEL,MF_UNCHECKED); }
    //if(carte2_att==CARTE2_ATT_INS) { CheckMenuItem(hm,CM_MAP_PT_EXE,MF_UNCHECKED); CheckMenuItem(hm,CM_MAP_PT_INS,MF_CHECKED  ); CheckMenuItem(hm,CM_MAP_PT_DEL,MF_UNCHECKED); }
    //if(carte2_att==CARTE2_ATT_DEL) { CheckMenuItem(hm,CM_MAP_PT_EXE,MF_UNCHECKED); CheckMenuItem(hm,CM_MAP_PT_INS,MF_UNCHECKED); CheckMenuItem(hm,CM_MAP_PT_DEL,MF_CHECKED);   }

    if(bat_all_disp_off) CheckMenuItem(hm,CM_BAT_MASK_UNMASK_ALL,MF_CHECKED); else CheckMenuItem(hm,CM_BAT_MASK_UNMASK_ALL,MF_UNCHECKED);

    if(old_draw==OLD_DRAW_RED) { CheckMenuItem(hm,CM_AFF_VOIES_OLD_ROUGE,MF_CHECKED);   CheckMenuItem(hm,CM_AFF_VOIES_OLD_NOIR,MF_UNCHECKED); CheckMenuItem(hm,CM_AFF_VOIES_OLD_OFF,MF_UNCHECKED); }
    if(old_draw==OLD_DRAW_STD) { CheckMenuItem(hm,CM_AFF_VOIES_OLD_ROUGE,MF_UNCHECKED); CheckMenuItem(hm,CM_AFF_VOIES_OLD_NOIR,MF_CHECKED);   CheckMenuItem(hm,CM_AFF_VOIES_OLD_OFF,MF_UNCHECKED); }
    if(old_draw==OLD_DRAW_NO ) { CheckMenuItem(hm,CM_AFF_VOIES_OLD_ROUGE,MF_UNCHECKED); CheckMenuItem(hm,CM_AFF_VOIES_OLD_NOIR,MF_UNCHECKED); CheckMenuItem(hm,CM_AFF_VOIES_OLD_OFF,MF_CHECKED);   }

    if(cam_sprite!=-1) CheckMenuItem(hm,CM_AFF_CAM_Y,MF_CHECKED); else CheckMenuItem(hm,CM_AFF_CAM_Y,MF_UNCHECKED);
    if(en_y_cam) CheckMenuItem(hm,CM_AFF_GRID,MF_CHECKED);  else CheckMenuItem(hm,CM_AFF_GRID,MF_UNCHECKED);
    if(coord_on) CheckMenuItem(hm,CM_AFF_GRID,MF_CHECKED);  else CheckMenuItem(hm,CM_AFF_GRID,MF_UNCHECKED);
    if(panel_on) CheckMenuItem(hm,CM_AFF_PANEL,MF_CHECKED); else CheckMenuItem(hm,CM_AFF_PANEL,MF_UNCHECKED);
    if(txtedit)  CheckMenuItem(hm,CM_AFF_TXT,MF_CHECKED); else CheckMenuItem(hm,CM_AFF_TXT,MF_UNCHECKED);

    if(en_edition)
    {
        CheckMenuItem(hm,CM_EDIT_ON,MF_CHECKED);
        EnableMenuItem(hm,CM_EDIT_ADD_SEG,MF_ENABLED);
        EnableMenuItem(hm,CM_EDIT_ADD_AIG,MF_ENABLED);
        EnableMenuItem(hm,CM_EDIT_ADD_GEO,MF_ENABLED);
        EnableMenuItem(hm,CM_EDIT_ADD_TXT,MF_ENABLED);
        EnableMenuItem(hm,CM_EDIT_COPCOL_PT_SUP_LEFT,MF_ENABLED);
        EnableMenuItem(hm,CM_EDIT_COPCOL_PT_INF_RIGHT,MF_ENABLED);
        EnableMenuItem(hm,CM_EDIT_COPCOL_ORG,MF_ENABLED);
        EnableMenuItem(hm,CM_EDIT_COPCOL_DST,MF_ENABLED);
        EnableMenuItem(hm,CM_EDIT_COPCOL_DEL,MF_ENABLED);
        EnableMenuItem(hm,CM_EDIT_COPCOL_MOVE,MF_ENABLED);
        EnableMenuItem(hm,CM_BAT_DEL,MF_ENABLED);
        EnableMenuItem(hm,CM_EDIT_IMPORT_WP,MF_ENABLED);
    }
    else
    {
        CheckMenuItem(hm,CM_EDIT_ON,MF_UNCHECKED);
        EnableMenuItem(hm,CM_EDIT_ADD_SEG,MF_GRAYED);  //mieux que DISABLED (grayed disable et grise)
        EnableMenuItem(hm,CM_EDIT_ADD_AIG,MF_GRAYED);
        EnableMenuItem(hm,CM_EDIT_ADD_GEO,MF_GRAYED);
        EnableMenuItem(hm,CM_EDIT_ADD_TXT,MF_GRAYED);
        EnableMenuItem(hm,CM_EDIT_COPCOL_PT_SUP_LEFT,MF_GRAYED);
        EnableMenuItem(hm,CM_EDIT_COPCOL_PT_INF_RIGHT,MF_GRAYED);
        EnableMenuItem(hm,CM_EDIT_COPCOL_ORG,MF_GRAYED);
        EnableMenuItem(hm,CM_EDIT_COPCOL_DST,MF_GRAYED);
        EnableMenuItem(hm,CM_EDIT_COPCOL_DEL,MF_GRAYED);
        EnableMenuItem(hm,CM_EDIT_COPCOL_MOVE,MF_GRAYED);
        EnableMenuItem(hm,CM_BAT_DEL,MF_GRAYED);
        EnableMenuItem(hm,CM_EDIT_IMPORT_WP,MF_GRAYED);
}

    if(simu_exe) CheckMenuItem(hm,CM_PAUSE,MF_UNCHECKED); else CheckMenuItem(hm,CM_PAUSE,MF_CHECKED);

}

//-----------------------------------------------------------------
// WINDOWS (init + boucle de messages)
//-----------------------------------------------------------------

/* Declare Windows procedure */
LRESULT CALLBACK WindowProcedure(HWND, UINT, WPARAM, LPARAM);
/* Make the class name into a global variable */
char szClassName[ ] = "WindowsApp";
int WINAPI WinMain(HINSTANCE hThisInstance, HINSTANCE hPrevInstance, LPSTR lpszArgument, int nFunsterStil)

{
    HWND hwnd;               /* This is the handle for our window */
    MSG messages;            /* Here messages to the application are saved */
    WNDCLASSEX wincl;        /* Data structure for the windowclass */

    ghInstance=hThisInstance;

    /* The Window structure */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc = WindowProcedure;      /* This function is called by windows */
    wincl.style = CS_DBLCLKS;                 /* Catch double-clicks */
    wincl.cbSize = sizeof(WNDCLASSEX);

    /* Use default icon and mouse-pointer */
    wincl.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon(NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor(NULL, IDC_ARROW);
    wincl.lpszMenuName = "MAINMENU"; //NULL; /* No menu */
    wincl.cbClsExtra = 0;                      /* No extra bytes after the window class */
    wincl.cbWndExtra = 0;                      /* structure or the window instance */
    /* Use light-gray as the background of the window */
    wincl.hbrBackground = (HBRUSH) GetStockObject(LTGRAY_BRUSH);

    /* Register the window class, if fail quit the program */
    if(!RegisterClassEx(&wincl)) return 0;

    /* The class is registered, let's create the program*/
    hwnd = CreateWindowEx(
           0,                   /* Extended possibilites for variation */
           szClassName,         /* Classname */
           PST_TITLE,           /* Title */
           WS_OVERLAPPEDWINDOW, /* default window */
           0/*CW_USEDEFAULT*/,  /* Windows decides the position */
           0/*CW_USEDEFAULT*/,  /* where the window ends up on the screen */
           1024,                /* The programs width */
           768,                 /* and height in pixels */
           HWND_DESKTOP,        /* The window is a child-window to desktop */
           NULL,                /* No menu */
           hThisInstance,       /* Program Instance handler */
           NULL                 /* No Window Creation data */
           );

    /* Make the window visible on the screen */
    ShowWindow(hwnd, nFunsterStil);
    /* Run the message loop. It will run until GetMessage( ) returns 0 */
    while(GetMessage(&messages, NULL, 0, 0))
    {
           /* Translate virtual-key messages into character messages */
           TranslateMessage(&messages);
           /* Send message to WindowProcedure */
           DispatchMessage(&messages);
    }

    /* The program return-value is 0 - The value that PostQuitMessage( ) gave */
    return messages.wParam;
}

int initialized=0;
int init_step=0;
int cpt_ok=0,cpt_total=0;
int step=0;
int nb_num=0;
char szInit[1000];
int manual_change=0;
int tr_pose=0, bat_pose=0; //0=rien 1=tout 2=partielle
int tr_pose_x=0;
int tr_pose_y=0;
int bat_pose_yet=0;
int bat_sel_x1=0,bat_sel_y1=0,bat_sel_x2=0,bat_sel_y2=0;
int next_copcol=0;

/* This function is called by the Windows function DispatchMessage( ) */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    int i,j,k,ok;
    int i2,j2;
    long c,r,v,b,c1,r1,v1,b1,c2,r2,v2,b2,rd,vd,bd,t,p;
    static int dr=100;
    int x_mouse,y_mouse;
    char touche_char;
    int touche_no;
    int x,y;
    char ch[100];
    int ret;
    int loc_sel,cran_sel,vit_sel;

    //hdc=GetDC(hwnd);
    //hdcScreen=GetDC(NULL);

    switch (message)                  /* handle the messages */
    {
       case WM_CREATE:
            if(initialized) break;
            initialized=1;
            ghwnd=hwnd;
            hdc=GetDC(hwnd);
            SetTimer(hwnd,1,40,NULL);
            CreateWindow("EDIT", "",WS_BORDER | WS_CHILD | WS_VISIBLE | ES_WANTRETURN, 0, 0, 1000, 20, hwnd, (HMENU) 800 /*ID_MAIN_TEXT*/ , ghInstance, NULL);
            SendMessage(GetDlgItem(hwnd,800), WM_SETTEXT, 0, (LPARAM) "Tapez le texte ici");
            ShowWindow(GetDlgItem(hwnd,800 ), SW_HIDE);
            break;

       case WM_TIMER:
           cpt_total++;
           if(wParam==1) if(en_cours==0) if(simu_exe==1)
           {
                en_cours=1;
                cpt_ok++;

                //-- initialisation --//

                //if(init_step==0)
                if(aff_mode==AFF_MODE_INIT)
                if(aff_step==0)
                {
                    font_pinceau_stylo_init();
                  //SelectObject(hdc,bmp_stylo_rouge);
                  //SelectObject(hdc,bmp_pinceau_rouge);
                  //Rectangle(hdc,0,0,1280,1024);
                    sprintf(szInit,"Initialisation");
                    aff_step++;
                }
                else if(aff_step==1)
                {
                    cpt=0;
                    pf=fopen("debug.txt","wt");
                    sprite_init();
                    pt_seg_aig_ligne_init();
                    txtBuff_Init();
                    txtBuffBat_Init();
                    carte2_init();
                    sprintf(szInit,"Selection puis chargement du fichier du reseau");
                    aff_step++;
                }
                else if(aff_step==2)
                {
                    load_infra_sprite();
                    compute_help_file_path();
                    fill_pt_sega_segb();
                    carte2_select(0);
                    update_menu_check(); 
                    script_init();
                    sprintf(szInit,"Chargement des sprites des trains (necessite un gros calcul pour la gestion de la transparence et de l'inversion)");
                    aff_step++;
                }
                else if(aff_step==3)
                {
                    init_hdc_mem();
                    if(start_ligne>=0 && start_ligne<MAX_LIGNE) { current_ligne=next_ligne=start_ligne; }
                    sprintf(szInit,"Chargement des images de l'infrastructure de la ligne %d (batiments, ponts ...)",next_ligne);
                    aff_step++;
                }
                else if(aff_step==4)
                {
                  //if(szcarte_txt[ligne[current_ligne][IND_LIGNE_IMG]]=='\0') MessageBox(NULL,"Pas de fichier image associe a cette ligne","PST - erreur",MB_OK);
                  //else  init_hdc_mem_bat(&szcarte_txt[ligne[current_ligne][IND_LIGNE_IMG]]); //init de la ligne specifiee ou 0 par defaut
                    x0=ligne[current_ligne][IND_LIGNE_X0]; y0=ligne[current_ligne][IND_LIGNE_Y0];
                    if(start_ligne>=0 && start_ligne<MAX_LIGNE) aff_mode=AFF_MODE_RESEAU; else aff_mode=AFF_MODE_CARTE ;
                    cpt_total=cpt_ok=0;
                    aff_step=0;
                    load_reload_bat_img_for_line(current_ligne);
                    disp_seg_geo_txt_bat_fill(1); disp_sprite_fill(1);
                }

                //-- changement de ligne --//

                if(aff_mode==AFF_MODE_CHANGE_LIGNE && aff_step==1)
                {
                  //if(szcarte_txt[ligne[next_ligne][IND_LIGNE_IMG]]=='\0') MessageBox(NULL,"Pas de fichier image associe a cette ligne","PST - erreur",MB_OK);
                  //else  init_hdc_mem_bat(&szcarte_txt[ligne[next_ligne][IND_LIGNE_IMG]]);
                    //Sleep(4000);
                    aff_mode=AFF_MODE_RESEAU;
                    aff_step=0;
                    load_reload_bat_img_for_line(current_ligne);
                    disp_seg_geo_txt_bat_fill(1); disp_sprite_fill(1);
                }

                if(current_ligne!=next_ligne)
                {
                    // sauvegarde du x0/y0 de la ligne afin de revenir au meme endroit
                    ligne[current_ligne][IND_LIGNE_X0]=x0; ligne[current_ligne][IND_LIGNE_Y0]=y0;
                    if(manual_change==1) { manual_change=0; x0=ligne[next_ligne][IND_LIGNE_X0]; y0=ligne[next_ligne][IND_LIGNE_Y0]; }
                    // demande de chngement de ligne
                    current_ligne=next_ligne;
                    aff_mode=AFF_MODE_CHANGE_LIGNE;
                    aff_step=1;
                }

                //-- rendu --//

                if(aff_mode==AFF_MODE_CHANGE_LIGNE || (aff_mode==AFF_MODE_INIT && aff_step==4) )
                {
                    SelectObject(hdc,bmp_stylo_vert);
                    SelectObject(hdc,bmp_pinceau_vert);
                    Rectangle(hdc,0,0,1280,1024);
                    SetBkMode(hdc,TRANSPARENT);
                    SetTextColor(hdc,RGB(0,0,0));
                    sprintf(szDisp,"Chargement de la ligne %d en cours ...",next_ligne);
                    EasyTextOut(100,300,szDisp);
                    sprintf(szDisp,"    Nom = \"%s\"",&szcarte_txt[ligne[next_ligne][IND_LIGNE_NAME]]);
                    EasyTextOut(100,330,szDisp);
                 // sprintf(szDisp,"    Fichier batiments = \"%s\"",&szcarte_txt[ligne[next_ligne][IND_LIGNE_IMG]]);
                 // EasyTextOut(100,360,szDisp);
                    sprintf(szDisp,"(cela peut prendre quelques dizaines de secondes)");
                    EasyTextOut(100,400,szDisp);
                }

                if(aff_mode==AFF_MODE_INIT && aff_step!=4)
                {
                    SelectObject(hdc,bmp_stylo_vert);
                    SelectObject(hdc,bmp_pinceau_vert);
                    Rectangle(hdc,0,0,1280,1024);
                    SetBkMode(hdc,TRANSPARENT);
                    SetTextColor(hdc,RGB(0,0,0));
                    strcpy(szDisp,szInit);
                    EasyTextOut(100,300,szDisp);
                    sprintf(szDisp,"(cela peut prendre quelques dizaines de secondes)"); //sprintf(szDisp,"(cela peut prendre quelques dizaines de secondes, patientez !)");
                    EasyTextOut(100,330,szDisp);
                }

                if(aff_mode!=AFF_MODE_CHANGE_LIGNE && aff_mode!=AFF_MODE_INIT)
                {
                    //x_res=1024; y_res=768 ; panel_base=605; // defaut 1024x768
                    //if(ecran_res==1280) { x_res=1280; y_res=1024; panel_base=805; }
                    SelectObject(hdcMemTemp,bmp_stylo_blanc);
                    SelectObject(hdcMemTemp,bmp_pinceau_blanc);
                    Rectangle(hdcMemTemp,0,0,1280,1024);
                }

                if(aff_mode==AFF_MODE_RESEAU || aff_mode==AFF_MODE_CONTAINERS_DEPL )
                {
                    disp_seg_geo_txt_bat_fill(0);
                    disp_sprite_fill(0);
                    geo_draw(0);
                    pt_seg_aig_txt_draw();
                    sprite_draw();
                    geo_draw(1);

                    if(tr_pose ) img_tr_pose.draw_centerlow(tr_pose_x,tr_pose_y,0);
                    if(bat_pose==1) img_bat_pose.draw_centerlow(tr_pose_x,tr_pose_y,0);
                    if(bat_pose==2) img_bat_pose.drawsub_centerlow(tr_pose_x,tr_pose_y,0,bat_sel_x1,bat_sel_y1,bat_sel_x2,bat_sel_y2);

                    // grille
                    if(coord_on) for(i=0;i<x_res;i+=50) for(j=0;j<y_res;j+=50) SetPixel(hdcMemTemp,i-(x0%50),j-(y0%50),RGB(255,0,0)); //modulo pour ne pas deplacer la grille
                    copcol_draw();

                    if(panel_on)
                    {
                        SelectObject(hdcMemTemp,bmp_stylo_jaune);
                        SelectObject(hdcMemTemp,bmp_pinceau_jaune);
                        Rectangle(hdcMemTemp,0,panel_base,x_res,y_res);

                        //SelectObject(hdc,bmp_fonte);
                        SetBkMode(hdcMemTemp,TRANSPARENT);
                        SetTextColor(hdcMemTemp,RGB(0,0,0));
                        EasyTextOutTemp(10,panel_base,szDebug);

                        sprintf(szDisp,"ligne=%d x=%d y=%d cpt=%d nb=%d",current_ligne,x_mouse_move+x0,y_mouse_move+y0,cpt_total,nb_num);
                        EasyTextOutTemp(10,panel_base+20,szDisp);

                        cran_sel=vit_sel=0;
                        loc_sel=sprite[sprite_sel][IND_SPRITE_MOT];
                        if(loc_sel!=-1)
                        {
                            cran_sel=mot[loc_sel][IND_MOT_VIT];
                            //vit_sel=(int)(25*0.1*3.6)*cran_sel; //timer 40ms = 25x 10cm /sec /cran = 25*0.1*3.6 km/h = 14km/h / cran
                            vit_sel=(int)10*cran_sel; // vrai vitesse avec formule ci dessus (x9).Mais moeux x10 car les vitessess lilites sont multiples de 10
                        }
                        //sprintf(szDisp,"sprite_sel=%d loco=%d cran=%d vit=%dkm/h",sprite_sel,loc_sel,cran_sel,vit_sel);
                        sprintf(szDisp,"sprite_sel=%d loco=%d vit=%dkm/h",sprite_sel,loc_sel,vit_sel);
                        EasyTextOutTemp(10,panel_base+40,szDisp);

                        sprintf(szDisp,"script_exe=%d hourmin=%d blocage=%d%d",exe_script_on,horo_hourmin,horo_block,horo_user_block);
                        EasyTextOutTemp(10,panel_base+60,szDisp);

                        if(aff_sprite_sel()==0) if(aff_txt_sel()==0) if(aff_geo_sel()==0)  if(aff_seg_sel()==0) aff_bat_sel();

                        EasyTextOutTemp(10,panel_base+80,szhot_txt);
                    }

                    //SelectObject(hdcMemTemp,bmp_stylo_rouge);
                    //EasyLineTemp(0,60,1024,60);
                    //SelectObject(hdcMemTemp,bmp_pinceau_blanc);
                    //SelectObject(hdcMemTemp,bmp_stylo_blanc);
                    //BitBlt(hdcMemTemp,x,0,176,58,hdcMem,0,0,SRCCOPY); //MERGECOPY
                    // BitBlt(hdc,0,0,x_res,y_res,hdcMemMask,0,0,SRCCOPY); //MERGECOPY pour voir le mask
                    // BitBlt(hdc,0,0,1024,748,hdcMemTemp,0,0,SRCCOPY); //MERGECOPY
                    // BitBlt(hdc,0,0,1024,748,hdcMem,0,0,SRCCOPY);     //MERGECOPY
                    // BitBlt(hdc,0,0,1024,748,hdcMemInv,0,0,SRCCOPY);  //MERGECOPY
                }

                //if(aff_mode==AFF_MODE_SPRITES) BitBlt(hdcMemTemp,0,0,sprite_x2-sprite_x1,sprite_y2-sprite_y1,hdcMem,sprite_x1,sprite_y1,SRCCOPY);     //MERGECOPY

                if(aff_mode==AFF_MODE_BAT)
                {
                    SelectObject(hdcMemTemp,bmp_stylo_vert);  SelectObject(hdcMemTemp,bmp_pinceau_vert);
                    Rectangle(hdcMemTemp,0,0,x_res,y_res);

                    SelectObject(hdcMemTemp,bmp_stylo_blanc); SelectObject(hdcMemTemp,bmp_pinceau_blanc);
                    Rectangle(hdcMemTemp,100,100,100+bat_sel_x2-bat_sel_x1+1,100+bat_sel_y2-bat_sel_y1); //mieux avec + 1

                    SelectObject(hdcMemTemp,bmp_stylo_rouge); SelectObject(hdcMemTemp,bmp_pinceau_rouge);
                    if(step==0) Rectangle(hdcMemTemp,100-5,100-5,100+5,100+5);
                    if(step==1) Rectangle(hdcMemTemp,100+bat_sel_x2-bat_sel_x1-5,100+bat_sel_y2-bat_sel_y1-5,100+bat_sel_x2-bat_sel_x1+5,100+bat_sel_y2-bat_sel_y1+5);
                    img_bat_pose.drawsub(100,100,0,bat_sel_x1,bat_sel_y1,bat_sel_x2,bat_sel_y2);
                }

                if(aff_mode==AFF_MODE_CARTE)
                {
                    carte2_draw();  // carte_draw(); if(panel_on) carte_panel();
                }

                if(aff_mode!=AFF_MODE_CHANGE_LIGNE && aff_mode!=AFF_MODE_INIT)
                {
                    if(txtedit==0) BitBlt(hdc,0,0,x_res,y_res,hdcMemTemp,0,0,SRCCOPY); //MERGECOPY
                    else           BitBlt(hdc,0,20,x_res,y_res-20,hdcMemTemp,0,20,SRCCOPY); //MERGECOPY
                    if(txtedit==0) ShowWindow(GetDlgItem(hwnd,800 ), SW_HIDE);
                    else           ShowWindow(GetDlgItem(hwnd,800 ),SW_SHOWNORMAL);
                }

                if(aff_mode==AFF_MODE_RESEAU)
                {
                    sprite_depl_all();
                    containers_maj_xy();
                    horo_maj();
                    script_maj();
                }

                en_cours=0;
           }
           break;

       case WM_LBUTTONDOWN:  if(aff_mode==AFF_MODE_INIT) break;
           x_mouse=LOWORD(lParam);
           y_mouse=HIWORD(lParam);
           if(aff_mode==AFF_MODE_RESEAU)
           {
               if(panel_on && (y_mouse>panel_base)) break;

               if(tr_pose || bat_pose) { tr_pose_x=x_mouse; tr_pose_y=y_mouse; break; }

               ret=sprite_click_select(x_mouse,y_mouse);
               if(ret==0) aig_click_change(x_mouse,y_mouse);
               if(ret==0) txt_action(x_mouse,y_mouse);
           }
           if(aff_mode==AFF_MODE_BAT)
           {
               if(step==0)
               {
                   bat_sel_x1=bat_sel_x1+x_mouse-100;
                   bat_sel_y1=bat_sel_y1+y_mouse-100;
               }
               if(step==1)
               {
                   bat_sel_x2=bat_sel_x1+x_mouse-100;
                   bat_sel_y2=bat_sel_y1+y_mouse-100;
               }
               if(bat_sel_x1<0) bat_sel_x1=0; if(bat_sel_x1>2000) bat_sel_x1=2000;
               if(bat_sel_x2<0) bat_sel_x2=0; if(bat_sel_x2>2000) bat_sel_x2=2000;
               if(bat_sel_y1<0) bat_sel_y1=0; if(bat_sel_y1>2000) bat_sel_y1=2000;
               if(bat_sel_y2<0) bat_sel_y2=0; if(bat_sel_y2>2000) bat_sel_y2=2000;
           }
           if(aff_mode==AFF_MODE_CONTAINERS_DEPL)
           {
               if(sprite_sel!=-1) if(sprite[sprite_sel][IND_SPRITE_LOCO]==-3)
               {
                   sprite[sprite_sel][IND_SPRITE_X]=x0+x_mouse;
                   sprite[sprite_sel][IND_SPRITE_Y]=y0+y_mouse;
               }
           }
           if(aff_mode==AFF_MODE_CARTE)
           {
               //if(panel_on && (y_mouse>panel_base)) break;
               carte2_click(x_mouse,y_mouse);
           }
           break;

       case WM_MOUSEMOVE:   if(aff_mode==AFF_MODE_INIT) break;
           x_mouse_move=LOWORD(lParam);
           y_mouse_move=HIWORD(lParam);
           break;

       case WM_RBUTTONDOWN:  if(aff_mode==AFF_MODE_INIT) break;
           x_mouse=LOWORD(lParam);
           y_mouse=HIWORD(lParam);
           if(aff_mode==AFF_MODE_RESEAU)
           {
               if(panel_on && (y_mouse>panel_base)) break;
               ret=sprite_click_acrochage_decrochage(x_mouse,y_mouse);
           }
           break;

       case WM_KEYDOWN:  if(aff_mode==AFF_MODE_INIT) break;
           touche_no=wParam;
           if(aff_mode==AFF_MODE_CARTE)
           {
               if(touche_no==VK_RIGHT) carte2_x+=100;
               if(touche_no==VK_LEFT ) carte2_x-=100;
               if(touche_no==VK_UP   ) carte2_y-=100;
               if(touche_no==VK_DOWN ) carte2_y+=100;
               if(touche_no==VK_HOME ) carte2_x=carte2_y=0;
               if(touche_no==VK_INSERT) carte2_op_key_ins();
               if(touche_no==VK_DELETE) carte2_op_key_del();
           }
           if(aff_mode==AFF_MODE_RESEAU)
           {
               if(tr_pose || bat_pose)
               {
                   if(touche_no==VK_RIGHT)  tr_pose_x++;
                   if(touche_no==VK_LEFT )  tr_pose_x--;
                   if(touche_no==VK_UP   )  tr_pose_y--;
                   if(touche_no==VK_DOWN )  tr_pose_y++;
                   if(touche_no==VK_SPACE)  if(tr_pose ) PostMessage(hwnd,WM_COMMAND,CM_TR_ADD_VAL,0);
                   if(touche_no==VK_SPACE)  if(bat_pose) PostMessage(hwnd,WM_COMMAND,CM_BAT_ADD_VAL,0);
               }
               else
               {
                   if(touche_no==VK_RIGHT)  x0+=100;
                   if(touche_no==VK_LEFT )  x0-=100;
                   if(touche_no==VK_UP   )  y0-=100;
                   if(touche_no==VK_DOWN )  y0+=100;
                   if(touche_no==VK_HOME )  x0=y0=0;
                   if(en_edition)
                   {
                       if(touche_no==VK_DELETE) { if(delete_sprite(sprite_del)==0) if(delete_txt(txt_del)==0) if(delete_geo(geo_del)==0) if(delete_seg(seg_del)==0) delete_bat(bat_del);
                                                  disp_seg_geo_txt_bat_fill(1); disp_sprite_fill(1); fill_pt_sega_segb(); }
                       if(touche_no==VK_INSERT) { copcol_pose(next_copcol); next_copcol++; if(next_copcol==6) next_copcol=0; }
                   }
                   if(touche_no==VK_SPACE) if(en_edition) { bat_pose=2; tr_pose_x=300; tr_pose_y=200; }
               }
           }
           if(aff_mode==AFF_MODE_BAT)
           {
               if(step==0)
               {
                   if(touche_no==VK_RIGHT) { bat_sel_x1++;                  }
                   if(touche_no==VK_LEFT ) { if(bat_sel_x1>0) bat_sel_x1--; }
                   if(touche_no==VK_UP   ) { if(bat_sel_y1>0) bat_sel_y1--; }
                   if(touche_no==VK_DOWN ) {                  bat_sel_y1++; }
               }
               if(step==1)
               {
                   if(touche_no==VK_RIGHT) {                  bat_sel_x2++; }
                   if(touche_no==VK_LEFT ) { if(bat_sel_x2>0) bat_sel_x2--; }
                   if(touche_no==VK_UP   ) { if(bat_sel_y2>0) bat_sel_y2--; }
                   if(touche_no==VK_DOWN ) {                  bat_sel_y2++; }
               }
               if(touche_no==VK_TAB  ) { step++; if(step==2) step=0; }
               if(touche_no==VK_HOME ) { bat_sel_x1=0; bat_sel_y1=0; bat_sel_x2=img_bat_pose.tr_dx-1; bat_sel_y2=img_bat_pose.tr_dy-1; }
               if(touche_no==VK_SPACE) { aff_mode=AFF_MODE_RESEAU; tr_pose_x=300; tr_pose_y=200; }
               if(touche_no==VK_SHIFT) { }
           }

           if(aff_mode==AFF_MODE_CONTAINERS_DEPL)
           {
               if(sprite_sel!=-1) if(sprite[sprite_sel][IND_SPRITE_LOCO]==-3)
               {
                   if(touche_no==VK_RIGHT) { sprite[sprite_sel][IND_SPRITE_X]++; }
                   if(touche_no==VK_LEFT ) { sprite[sprite_sel][IND_SPRITE_X]--; }
                   if(touche_no==VK_UP   ) { sprite[sprite_sel][IND_SPRITE_Y]--; }
                   if(touche_no==VK_DOWN ) { sprite[sprite_sel][IND_SPRITE_Y]++; }
               }
           }

           if(touche_no==VK_F1   ) { ShellExecute(NULL,"open",szHelpFile, NULL, NULL, SW_SHOWNORMAL); }
           if(touche_no==VK_F2   ) { save_work();   }
         //if(touche_no==VK_F3   ) { script_init(); load_script(); script_debug(); exe_script_on=1; }
         //if(touche_no==VK_F4   ) { simu_exe^=1;   }
           if(touche_no==VK_F5   ) { if(aff_mode!=AFF_MODE_RESEAU) aff_mode=AFF_MODE_RESEAU; else aff_mode=AFF_MODE_CARTE; }
           if(touche_no==VK_F6   ) { next_ligne=nb_num; manual_change=1; }
         //if(touche_no==VK_F7   ) { if(aff_mode==AFF_MODE_SPRITES) aff_mode=AFF_MODE_BAT;   else aff_mode=AFF_MODE_SPRITES; step=0; }
         //if(touche_no==VK_F8   ) { aff_mode=AFF_MODE_CONTAINERS_DEPL; step=0; }
         //if(touche_no==VK_F9   ) { process_wikipedia_ligne(); }
         //if(touche_no==VK_F10  ) // VK_F10 ne fonctionne pas

           break;

       case WM_CHAR: if(aff_mode==AFF_MODE_INIT) break;
           touche_char=LOWORD(wParam);
           if(aff_mode==AFF_MODE_RESEAU)
           {
                if(touche_char>='0' && touche_char<='9') { nb_num=((10*nb_num)%100)+touche_char-'0'; }

                if(touche_char=='a' || touche_char=='A') x0-=500;
                if(touche_char=='z' || touche_char=='Z') x0+=500;
                if(touche_char=='+' || touche_char=='-' || touche_char=='*' || touche_char=='/' ) sprite_mot_vit(touche_char);

                if(touche_char=='c' || touche_char=='C')
                {
                    if(cam_sprite==-1)
                    {
                        cam_sprite=sprite_sel;
                        if(sprite_sel!=-1)
                        {
                            x_sprite_cam_old=sprite[cam_sprite][IND_SPRITE_X];
                            y_sprite_cam_old=sprite[cam_sprite][IND_SPRITE_Y];
                            l_sprite_cam=current_ligne;
                        }
                    }
                    else cam_sprite=-1;
                    update_menu_check();
                }
                if(touche_char=='b' || touche_char=='B') en_y_cam^=1;

                if(touche_char=='x' || touche_char=='X') coord_on^=1;
                if(touche_char=='p' || touche_char=='P') panel_on^=1;
                if(touche_char=='w' || touche_char=='W') hide_unhide_bat();
                if(touche_char=='i' || touche_char=='I') inv_current_sprite();
                if(touche_char=='o' || touche_char=='O') seg_change_type();
                if(touche_char=='d' || touche_char=='D') geo_change_dessus_dessous();
                if(touche_char=='q' || touche_char=='Q') horo_user_block^=1;
                if(touche_char=='n' || touche_char=='N') { old_draw=(old_draw+1)%3; }

                if(en_edition)
                {
                    if(touche_char=='s' || touche_char=='S') new_seg(0);
                    if(touche_char=='f' || touche_char=='F') { new_seg(1); disp_seg_geo_txt_bat_fill(1); fill_pt_sega_segb(); }

                    if(touche_char=='g' || touche_char=='G') { /*txtedit=1;*/ new_aig(0); } //txtedit commente car empeche d'appuyer sur les touches suivantes
                    if(touche_char=='h' || touche_char=='H') new_aig(1);
                    if(touche_char=='j' || touche_char=='J') new_aig(2);
                    if(touche_char=='k' || touche_char=='K') { txtedit=0; new_aig(3); }

                    if(touche_char=='e' || touche_char=='E') new_geo(0);
                    if(touche_char=='t' || touche_char=='T') { new_geo(1); disp_seg_geo_txt_bat_fill(1); }
                    if(touche_char=='r' || touche_char=='R') { new_geo(2); disp_seg_geo_txt_bat_fill(1); }
                    if(touche_char=='y' || touche_char=='Y') { new_geo(3); disp_seg_geo_txt_bat_fill(1); }

                    if(touche_char=='v' || touche_char=='V') { new_txt(); disp_seg_geo_txt_bat_fill(1); }

                    if(touche_char=='u' || touche_char=='U')
                    {
                        new_color++; if(new_color==COLOR_FREE) new_color=0;
                        if(geo_free!=0) geo[geo_free-1][IND_GEO_color]=new_color;
                    }
                }
           }

           break;

        case WM_COMMAND:
            switch(LOWORD(wParam))
            {
                case CM_EXIT      : PostMessage(hwnd,WM_DESTROY,0,0); break;

                case CM_SAVE      : save_work(); break;

                case CM_SCRIPT_LOAD: script_init(); load_script(); script_debug(); exe_script_on=1; break;

                case CM_PAUSE     : simu_exe^=1; break;

                case CM_HELP      : ShellExecute(NULL,"open",szHelpFile, NULL, NULL, SW_SHOWNORMAL); break;
                case CM_HELP_DOC  : ShellExecute(NULL,"open",szHelpDocFile, NULL, NULL, SW_SHOWNORMAL); break;
                case CM_ABOUT     : MessageBox(NULL,STR_ABOUT,"About",MB_OK|MB_ICONINFORMATION); break;

                case CM_AFF_TXT   : txtedit^=1; break;
                case CM_TXT_VAL   : char sz_tco_txt[1000];
                                   SendMessage(GetDlgItem(hwnd,800), WM_GETTEXT, 900, (LPARAM) sz_tco_txt);
                                   //MessageBox(NULL,sz_tco_txt,"debug",MB_OK);
                                   //if(aff_mode==AFF_MODE_CARTE) { carte2_op_val(sz_tco_txt); }
                                   txtedit=0; break;

                case CM_MAP_AFF   : aff_mode=AFF_MODE_CARTE; carte2_prep_edit_for_ins(); break;
                case CM_MAP_SEL_0 : carte2_select(0); aff_mode=AFF_MODE_CARTE; carte2_prep_edit_for_ins(); break;
                case CM_MAP_SEL_N : carte2_op_sel_carte(); aff_mode=AFF_MODE_CARTE; carte2_prep_edit_for_ins();  break;
                case CM_MAP_PT_ON : carte2_aff_pt^=1; update_menu_check(); break;
                case CM_MAP_PT_CLI: carte2_cli_pt^=1; update_menu_check(); break;
                case CM_MAP_PT_INS: carte2_op_menu_ins(); txtedit=1; break;
                case CM_MAP_PT_DEL: carte2_op_menu_del(); break;
                case CM_MAP_LD_IMG: SelectMapFileOpen(); carte2_op_change_img(szMapFilename); break;
                case CM_MAP_RM_IMG: carte2_op_del_img(); break;
                case CM_MAP_EXIT  : aff_mode=AFF_MODE_RESEAU; txtedit=0; break;

                case CM_TR_ADD           :
                case CM_TR_ADD_RIGHT     :
                case CM_TR_ADD_LEFT      :
                case CM_TR_ADD_RIGHT_SAME:
                case CM_TR_ADD_LEFT_SAME :
                                    char szEdit[1000];
                                    if(LOWORD(wParam)!=CM_TR_ADD_RIGHT_SAME) if(LOWORD(wParam)!=CM_TR_ADD_LEFT_SAME) if(SelectBmpFileOpen()==FALSE) break;
                                    img_tr_pose.load(szBmpFilename,1,1);
                                    tr_pose=1; tr_pose_x=300; tr_pose_y=200;
                                    if(LOWORD(wParam)==CM_TR_ADD_RIGHT || LOWORD(wParam)==CM_TR_ADD_RIGHT_SAME) tr_compute_xy_droite(szBmpFilename, &tr_pose_x, &tr_pose_y, 1);
                                    if(LOWORD(wParam)==CM_TR_ADD_LEFT  || LOWORD(wParam)==CM_TR_ADD_LEFT_SAME) tr_compute_xy_droite(szBmpFilename, &tr_pose_x, &tr_pose_y, 0);
                                    sprintf(szEdit,"loco=-1 (-1 wagon / %d locolibre) type_inv=1 (0 aucune / 1 invertion)",tr_pose_get_next_free_loc());
                                    set_wid_txt(szEdit);
                                    txtedit=1;
                                    break;
                case CM_TR_ADD_VAL: if(tr_pose==0) break;
                                    get_wid_txt(szEdit);
                                    tr_pose_ajouter(szBmpFilename,tr_pose_x,tr_pose_y,szEdit);
                                    disp_sprite_fill(1);
                                    txtedit=0;
                                    tr_pose=0;
                                    break;
                case CM_TR_DEL    : delete_sprite(sprite_sel); break;
                case CM_TR_INV    : inv_current_sprite(); break;

                case CM_BAT_ADD_SEL_DIM:
                                    if(SelectBmpFileOpen()==FALSE) break;
                                    img_bat_pose.load(szBmpFilename,1,0);
                                    /*bat_pose=1;*/ tr_pose_x=300; tr_pose_y=200;
                                    bat_sel_x1=0; bat_sel_y1=0; bat_sel_x2=img_bat_pose.tr_dx-1; bat_sel_y2=img_bat_pose.tr_dy-1;
                                    aff_mode=AFF_MODE_BAT;
                                    bat_pose=2; bat_pose_yet=1;
                                    break;
                case CM_BAT_ADD_POSE:
                                    if(bat_pose_yet==0) break;
                                    bat_pose=2; tr_pose_x=300; tr_pose_y=200;
                                    aff_mode=AFF_MODE_RESEAU;
                                    break;
                case CM_BAT_ADD_VAL:
                                    if(bat_pose==0) break;
                                  //if(bat_pose==1) bat_pose_ajouter(szBmpFilename,tr_pose_x,tr_pose_y,0,0,0,0,0);
                                    if(bat_pose==2) bat_pose_ajouter(szBmpFilename,tr_pose_x,tr_pose_y,1,bat_sel_x1,bat_sel_y1,bat_sel_x2,bat_sel_y2);
                                    disp_seg_geo_txt_bat_fill(1);
                                    bat_pose=0;
                                    break;
                case CM_BAT_DEL:
                                    MessageBox(ghwnd,"Positionnez le curseur sur le batiment a supprimer\nPuis appuez sur la touche \"Suppr\"","PST",MB_OK | MB_ICONINFORMATION);
                                    break;
                case CM_BAT_MASK_UNMASK:
                                    MessageBox(ghwnd,"Positionnez le curseur sur le batiment a masquer/demasquer\nPuis appuez sur la touche \"W\"","PST",MB_OK | MB_ICONINFORMATION);
                                    break;
                case CM_BAT_MASK_UNMASK_ALL:
                                    bat_all_disp_off^=1;
                                    update_menu_check();
                                    break;

                case CM_LIGNE_GO:   aff_mode=AFF_MODE_RESEAU; txtedit=0; break;
                case CM_LIGNE_GO_0: next_ligne=0; manual_change=1; break;
                case CM_LIGNE_GO_N: get_wid_txt(szEdit); next_ligne=atoi(szEdit); manual_change=1; break;
                case CM_LIGNE_AFF_LISTE: disp_lignes_names(); break;
                case CM_LIGNE_X0_Y0: x0=y0=0; break;
                case CM_LIGNE_NEW:  MessageBox(ghwnd,"Pour cr une ligne,\n\n- Trouver une ligne non utilis et y aller avec afficher ligne N\n- Changez son nom\nEditez","PST",MB_OK | MB_ICONINFORMATION); break;
                case CM_LIGNE_NAME: MessageBox(ghwnd,"Indiquez le nom de la ligne dans le zone d'edition puis valider avec le menu \"Ligne | Valider nom de la ligne\"","PST",MB_OK | MB_ICONINFORMATION); txtedit=1; set_current_ligne_name(); break;
                case CM_LIGNE_NAME_VAL: change_ligne_name(); txtedit=0; break;

                case CM_TR_AFF_LISTE: break;

                case CM_EDIT_ON:      en_edition^=1; update_menu_check(); break;
                case CM_EDIT_ADD_SEG: MessageBox(ghwnd,"Positionnez le curseur au debut du degment et appuyez sur la touche S\nPositionnez le curseur a la fin du degment et appuyez sur la touche F\n\nPour changer le type du segment, positionnez le curseur sur le segment et appuyez sur la touche o\n\nPour supprimer un segment, positionnez le curseur sur le segment et appuyez sur la touche Suppr","PST",MB_OK | MB_ICONINFORMATION); break;
                case CM_EDIT_ADD_AIG: MessageBox(ghwnd,"Positionnez le curseur sur les points suivant et appuyez sur les touches suivantes\n\nG - pour le coeur de l'aiguillage\nH - pour la voie commune\nJ - pour la voie directe\nK - pour la voie devie\n\nL'aiguillage est cr lors de l'appui sur K\n\nSi le numero propos ne vous convient pas, avant d'appuier sur K, affichez la zone de saisie avec le menu Text et changez le numro\n\nPour supprimer un aiguillage, supprimez un de ses segments","PST",MB_OK | MB_ICONINFORMATION); break;
                case CM_EDIT_ADD_GEO: MessageBox(ghwnd,"Positionnez le curseur sur le coin superieur gauche de la forme et appuyez sur E\n\nPositionnez le curseur sur le coin infrieur droit et appuyez sur une des touches suivantes en fonction de son type\nT - pour un trait\nR - pour un rectangle vide\nY pour un rectangle plein\n\nPour changer la couleur de la dernire forme cre, appuyez sur la touche U\n\nPour detruire une forme, positionnez le curseur sur le coin superieur gauche et appuyez sur la touche Suppr\n\nPour changer la priorit d'affichage, positionnez le curseur sur le coin superieur gauche et appuyez sur la touche D","PST",MB_OK | MB_ICONINFORMATION); break;
                case CM_EDIT_ADD_TXT: MessageBox(ghwnd,"Remplir le texte dans la zone d'edition\nSi le texte doit faire une action, rensignez le champ action\nPositionnez le curseur a l'endroit ou vous voulez afficher le texte puis appuyez sur la touche V","PST",MB_OK | MB_ICONINFORMATION);
                                      new_txt_ex(); txtedit=1; break;
                case CM_EDIT_COPCOL_PT_SUP_LEFT:  copcol_aff=1; next_copcol=0;  MessageBox(ghwnd,"Positionnez le curseur sur le point superieur gauche de la selection et appuyez sur la touche INS","PST",MB_OK | MB_ICONINFORMATION); break;
                case CM_EDIT_COPCOL_PT_INF_RIGHT: copcol_aff=1; next_copcol=1; MessageBox(ghwnd,"Positionnez le curseur sur le point inferieur droit  de la selection et appuyez sur la touche INS\nSi ce point se confond avec le point superieur gauche alors tout ce qui est a droite des 2 points est selectionn","PST",MB_OK | MB_ICONINFORMATION); break;
                case CM_EDIT_COPCOL_ORG:          copcol_aff=1; next_copcol=2;          MessageBox(ghwnd,"Positionnez le curseur sur un point d'origine du deplacement et appuyez sur la touche INS","PST",MB_OK | MB_ICONINFORMATION); break;
                case CM_EDIT_COPCOL_DST:          copcol_aff=1; next_copcol=3;          MessageBox(ghwnd,"Positionnez le curseur sur un point destintion du deplacement et appuyez sur la touche INS","PST",MB_OK | MB_ICONINFORMATION); break;break;
                case CM_EDIT_COPCOL_DEL:  copcol_pose(4); disp_seg_geo_txt_bat_fill(1); copcol_aff=0; break;
                case CM_EDIT_COPCOL_MOVE: copcol_pose(5); disp_seg_geo_txt_bat_fill(1); copcol_aff=0; break;
                case CM_EDIT_IMPORT_WP: process_wikipedia_ligne(); break;

                case CM_AFF_VOIES_OLD_ROUGE: old_draw=OLD_DRAW_RED; update_menu_check(); break;
                case CM_AFF_VOIES_OLD_NOIR:  old_draw=OLD_DRAW_STD; update_menu_check(); break;
                case CM_AFF_VOIES_OLD_OFF:   old_draw=OLD_DRAW_NO;  update_menu_check(); break;
                case CM_AFF_GRID:  coord_on^=1; update_menu_check(); break;
                case CM_AFF_PANEL: panel_on^=1; update_menu_check(); break;
                case CM_AFF_SEL_RES: sprintf(szEdit,"x_res=%d y_res=%d y_panel=%d",x_res,y_res,panel_base); set_wid_txt(szEdit); txtedit=1; break;
                case CM_AFF_VAL_RES: get_wid_txt(szEdit); use_res(szEdit); txtedit=0;
                                    SelectObject(hdcMemTemp,bmp_stylo_noir);
                                    SelectObject(hdcMemTemp,bmp_pinceau_noir);
                                    Rectangle(hdc,0,0,1200,1024);
                                    break;
                case CM_AFF_CAM_ON: en_y_cam=-1; MessageBox(ghwnd,"cliquez sur une locomotive ou wagon a suivre, puis appuyez sur la touche C","PST",MB_OK|MB_ICONINFORMATION); break;
                case CM_AFF_CAM_Y: en_y_cam^=1;  update_menu_check(); break;

                default  : break;
            }
            break;

       case WM_DESTROY: if(aff_mode==AFF_MODE_INIT) break;
           //if(MessageBox(ghwnd,"Etes vous sure de vouloir quitter PST ? \n\n(Penser a sauver si necessaire)\n\nYES - Quitter\nNO - Continuer","PST",MB_YESNO | MB_APPLMODAL)==IDNO) return  0;
           if(MessageBox(ghwnd,"Voulez vous sauver vos changements ? \n\nYES - Sauver les changements (ajouts / suppressions / positions)\nNO - Ne rien sauvegarder","PST",MB_YESNO | MB_APPLMODAL)==IDYES)
           {
               save_work();
           }
           fclose(pf);           // fermeture du fichier de debug
           PostQuitMessage(0);   /* send a WM_QUIT to the message queue */
           break;

       default:
           break;  /* for messages that we don't deal with */
    }

    //ReleaseDC(hwnd,hdc);
    //ReleaseDC(NULL,hdcScreen);

    return DefWindowProc(hwnd, message, wParam, lParam);
}


/*
TBD:
    faire en sorte que deplacement et suppression de selection, mettent a jour les points de la carte 2
    pre-remplir la zone de saisie a l'entree dans le mode carte
    mettre un bouton pour valider la zone de saisie

    mettre menu pour afficher ou pas les aides
*/
